import _isEmpty from "lodash/isEmpty";
import React from 'react';
import styles from './styles.scss';
export default (function (_ref) {
  var placeholder = _ref.placeholder,
      type = _ref.type,
      isRequired = _ref.isRequired,
      textColor = _ref.textColor,
      backgroundColor = _ref.backgroundColor,
      onChange = _ref.onChange,
      isValid = _ref.isValid,
      inputValue = _ref.inputValue,
      placeholderColor = _ref.placeholderColor;
  var validField = isValid & isRequired || isRequired & inputValue === '';
  return /*#__PURE__*/React.createElement("div", {
    className: styles.inputWrapper,
    style: {
      backgroundColor: 'transparent',
      color: textColor
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.inputBackground,
    style: {
      background: textColor
    }
  }), /*#__PURE__*/React.createElement("input", {
    spellCheck: "false",
    style: {
      color: _isEmpty(inputValue) && placeholderColor ? placeholderColor : textColor,
      border: "1px solid " + (validField ? 'red' : textColor),
      background: 'transparent'
    },
    placeholder: placeholder,
    onChange: onChange
  }), isRequired && /*#__PURE__*/React.createElement("div", {
    style: {
      color: _isEmpty(inputValue) ? placeholderColor : textColor
    },
    className: styles.icon
  }, "*"));
});