import _extends from "@babel/runtime/helpers/extends";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _get from "lodash/get";
import React, { Component } from 'react';
import { connect } from 'react-redux';
import MinimumIcon from '../minimum-icon';
import Conversation from '../conversation';

var ChatBox = /*#__PURE__*/function (_Component) {
  _inheritsLoose(ChatBox, _Component);

  function ChatBox() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = ChatBox.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        showChat = _this$props.showChat,
        isInConfigurationMode = _this$props.isInConfigurationMode,
        currentComponent = _this$props.demoData.currentComponent,
        numberOfNewMessages = _this$props.numberOfNewMessages;
    var isShowChat = showChat || isInConfigurationMode && currentComponent === 'chatbox';
    return /*#__PURE__*/React.createElement("div", {
      style: {
        height: '100%',
        zIndex: '9999997'
      }
    }, /*#__PURE__*/React.createElement(Conversation, _extends({
      isShowChat: isShowChat
    }, this.props)), /*#__PURE__*/React.createElement(MinimumIcon, {
      props: this.props,
      numberOfNewMessages: numberOfNewMessages
    }));
  };

  return ChatBox;
}(Component);

export default connect(function (store) {
  return {
    showChat: _get(store, 'behavior.showChat'),
    numberOfNewMessages: _get(store, 'messages.numberOfNewMessages')
  };
})(ChatBox);