import _get from "lodash/get";
import React from 'react';
import { useDispatch, useSelector } from 'react-redux';
import styles from './styles.scss';
import SVG from 'react-inlinesvg';
import SVGSoundOn from '../../icon/sound-on.svg';
import SVGSoundOff from '../../icon/sound-off.svg';
import { settingSound } from '../../../store/actions';
export default (function (_ref) {
  var setting = _ref.setting,
      style = _ref.style;
  var dispatch = useDispatch();
  var soundOn = useSelector(function (store) {
    return _get(store, 'behavior.soundOn');
  });
  return /*#__PURE__*/React.createElement("div", {
    className: styles.settingContent,
    style: style
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      color: _get(setting, 'iconTextColor')
    },
    className: styles.icon,
    onClick: function onClick() {
      return dispatch(settingSound());
    }
  }, soundOn ? /*#__PURE__*/React.createElement(SVG, {
    src: SVGSoundOn
  }) : /*#__PURE__*/React.createElement(SVG, {
    src: SVGSoundOff
  })));
});