import _get from "lodash/get";
import React, { Component } from 'react';
import styles from './styles.scss';
import { CloseIcon } from '../../../icon';
import ConversationSetting from '../conversation-setting';
export default (function (_ref) {
  var setting = _ref.setting,
      isInConfigurationMode = _ref.isInConfigurationMode,
      demoData = _ref.demoData,
      currentScreen = _ref.currentScreen,
      isMobileMode = _ref.isMobileMode;
  var showedScreen = isInConfigurationMode ? demoData.currentScreen : currentScreen;

  var activeTheme = _get(setting, 'activeTheme');

  var iconTextColor = _get(setting, 'iconTextColor');

  return showedScreen === 'form' ? /*#__PURE__*/React.createElement("div", {
    className: styles.headerContainer + " " + styles.screenForm,
    style: {
      background: _get(setting, 'iconBackgroundColor'),
      color: iconTextColor,
      borderRadius: (isMobileMode ? '0' : '18px  18px 0 0') + " "
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.headerRow
  }, /*#__PURE__*/React.createElement("span", {
    style: {
      color: iconTextColor
    }
  }, _get(setting, "chatboxThemeSettings." + activeTheme + ".screenForm.header_text_1"))), /*#__PURE__*/React.createElement(CloseIcon, {
    className: styles.closeIcon,
    iconTextColor: iconTextColor
  })) : /*#__PURE__*/React.createElement("div", {
    className: styles.headerContainer + " " + styles.screenConversation,
    style: {
      background: _get(setting, 'iconBackgroundColor'),
      color: 'white',
      height: 'auto',
      padding: '0px',
      display: 'flex',
      flexDirection: 'row',
      borderRadius: "" + (isMobileMode ? '0' : '18px 18px 0 0')
    }
  }, /*#__PURE__*/React.createElement("div", {
    style: {
      flexGrow: 1,
      display: 'flex',
      flexDirection: 'column',
      justifyContent: 'center',
      padding: '24px' // background: get(setting, 'iconBackgroundColor'),

    }
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("span", {
    style: {
      color: iconTextColor
    }
  }, _get(setting, 'chatboxThemeSettings.style-three.screenConversation.header_text_1')))), /*#__PURE__*/React.createElement("div", {
    style: {
      width: '40px',
      height: '100%',
      flexGrow: '0' // background: get(setting, 'iconBackgroundColor'),

    }
  }, /*#__PURE__*/React.createElement(ConversationSetting, {
    setting: setting,
    style: {
      top: "36px",
      right: "50px"
    }
  }), /*#__PURE__*/React.createElement(CloseIcon, {
    className: styles.closeIcon,
    iconTextColor: iconTextColor
  })));
});