import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _isEmpty from "lodash/isEmpty";
import _get from "lodash/get";
import React, { Component } from 'react';
import SVGPhoto from '../../../icon/photo.svg';
import SVGAttach from '../../../icon/attach.svg';
import styles from './styles.scss';
import SVG from 'react-inlinesvg';
import AttachmentList from '../components/attachment-list';
import Upload from 'rc-upload';

var StyleOne = /*#__PURE__*/function (_Component) {
  _inheritsLoose(StyleOne, _Component);

  function StyleOne() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = StyleOne.prototype;

  _proto.render = function render() {
    var _this = this;

    var _this$props = this.props,
        setting = _this$props.setting,
        uploadFiles = _this$props.uploadFiles,
        inputValue = _this$props.inputValue,
        handleRemoveAttachment = _this$props.handleRemoveAttachment;

    var iconColor = _get(setting, 'screenForm.placeholderTextColor');

    return /*#__PURE__*/React.createElement("div", {
      className: styles.inputContainer + " bs-chatbox-input-container"
    }, !_isEmpty(uploadFiles) && /*#__PURE__*/React.createElement(AttachmentList, {
      uploadFiles: uploadFiles,
      setting: setting,
      handleRemoveAttachment: handleRemoveAttachment
    }), /*#__PURE__*/React.createElement("div", {
      className: styles.inputRow
    }, /*#__PURE__*/React.createElement("textarea", {
      value: inputValue,
      placeholder: _get(setting, 'chatboxThemeSettings.commonSettings.send_message_placeholder'),
      onChange: this.props.handleOnChange,
      onKeyPress: function onKeyPress(e) {
        _this.props.handleKeyPress(e);
      },
      style: {
        color: _isEmpty(inputValue) ? _get(setting, 'screenForm.placeholderTextColor') : _get(setting, 'screenForm.inputTextColor')
      }
    })), /*#__PURE__*/React.createElement("div", {
      className: styles.additionalFunctionRow
    }, /*#__PURE__*/React.createElement("div", {
      className: styles.left
    }, /*#__PURE__*/React.createElement("span", {
      className: styles.icon
    }, /*#__PURE__*/React.createElement(Upload, {
      showUploadList: false,
      multiple: true,
      beforeUpload: this.props.handleBeforeUploadAttachments
    }, /*#__PURE__*/React.createElement(SVG, {
      src: SVGAttach,
      style: {
        width: '16.9px',
        height: '17.6px',
        color: iconColor
      }
    }))), /*#__PURE__*/React.createElement("span", {
      className: styles.icon
    }, /*#__PURE__*/React.createElement(Upload, {
      showUploadList: false,
      multiple: true,
      beforeUpload: this.props.handleBeforeUploadAttachments
    }, /*#__PURE__*/React.createElement(SVG, {
      src: SVGPhoto,
      style: {
        width: '20.5px',
        height: '17.6px',
        color: iconColor
      }
    })))), /*#__PURE__*/React.createElement("div", {
      className: styles.right
    }, /*#__PURE__*/React.createElement("span", {
      className: styles.btnSend,
      onClick: this.props.handleClickBtnSend,
      style: {
        backgroundColor: _get(setting, 'screenConversation.rightSideBackgroundColor'),
        color: _get(setting, 'screenConversation.rightSideTextColor')
      }
    }, "Send"))));
  };

  return StyleOne;
}(Component);

export { StyleOne as default };