import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _isEmpty from "lodash/isEmpty";
import _get from "lodash/get";
import React, { Component } from 'react';
import SVGPhoto from '../../../icon/photo.svg';
import SVGAttach from '../../../icon/attach.svg';
import styles from './styles.scss';
import SVG from 'react-inlinesvg';
import SVGSend from '../../../icon/send.svg';
import AttachmentList from '../components/attachment-list';
import Upload from 'rc-upload';

var StyleTwo = /*#__PURE__*/function (_Component) {
  _inheritsLoose(StyleTwo, _Component);

  function StyleTwo() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = StyleTwo.prototype;

  _proto.render = function render() {
    var _this = this;

    var _this$props = this.props,
        setting = _this$props.setting,
        uploadFiles = _this$props.uploadFiles,
        inputValue = _this$props.inputValue,
        handleRemoveAttachment = _this$props.handleRemoveAttachment;

    var iconColor = _get(setting, 'screenConversation.rightSideBackgroundColor');

    return /*#__PURE__*/React.createElement("div", {
      className: styles.inputContainer + " bs-chatbox-input-container"
    }, !_isEmpty(uploadFiles) && /*#__PURE__*/React.createElement(AttachmentList, {
      uploadFiles: uploadFiles,
      setting: setting,
      handleRemoveAttachment: handleRemoveAttachment
    }), /*#__PURE__*/React.createElement("div", {
      className: styles.additionalFunctionRow
    }, /*#__PURE__*/React.createElement("div", {
      className: styles.left
    }, /*#__PURE__*/React.createElement("span", {
      className: styles.icon
    }, /*#__PURE__*/React.createElement(Upload, {
      showUploadList: false,
      multiple: true,
      beforeUpload: this.props.handleBeforeUploadAttachments
    }, /*#__PURE__*/React.createElement(SVG, {
      src: SVGAttach,
      style: {
        width: '16.9px',
        height: '17.6px',
        color: iconColor
      }
    }))), /*#__PURE__*/React.createElement("span", {
      className: styles.icon
    }, /*#__PURE__*/React.createElement(Upload, {
      showUploadList: false,
      multiple: true,
      beforeUpload: this.props.handleBeforeUploadAttachments
    }, /*#__PURE__*/React.createElement(SVG, {
      src: SVGPhoto,
      style: {
        width: '20.5px',
        height: '17.6px',
        color: iconColor
      }
    }))))), /*#__PURE__*/React.createElement("div", {
      className: styles.inputRow
    }, /*#__PURE__*/React.createElement("div", {
      className: styles.inputBg,
      style: {
        background: iconColor
      }
    }), /*#__PURE__*/React.createElement("textarea", {
      value: inputValue,
      placeholder: _get(setting, 'chatboxThemeSettings.commonSettings.send_message_placeholder'),
      onChange: this.props.handleOnChange,
      onKeyPress: function onKeyPress(e) {
        _this.props.handleKeyPress(e);
      },
      style: {
        color: _isEmpty(inputValue) ? _get(setting, 'screenForm.placeholderTextColor') : _get(setting, 'screenForm.inputTextColor'),
        backgroundColor: 'transparent',
        zIndex: '999999'
      }
    }), /*#__PURE__*/React.createElement("span", {
      className: styles.btnSend,
      style: {
        backgroundColor: _get(setting, 'screenConversation.rightSideBackgroundColor')
      },
      onClick: this.props.handleClickBtnSend
    }, /*#__PURE__*/React.createElement(SVG, {
      src: SVGSend,
      style: {
        width: '13.9px',
        height: '12px',
        marginLeft: '5px',
        color: _get(setting, 'screenConversation.rightSideTextColor')
      }
    }))));
  };

  return StyleTwo;
}(Component);

export { StyleTwo as default };