import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _get from "lodash/get";
import React from 'react';
import styles from './offline-status.scss';
import { connect } from 'react-redux';
import { bindActionCreators } from 'redux';
import { startConversation } from '../../../store/actions';
import { CloseIcon } from '../../icon';
import { BUTTON_STARTS } from '../../../commons/constants/websocket';
import WithoutAutomation from './components/without-automation';
import WithAutomation from './components/with-automation';

var OfflineStatus = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(OfflineStatus, _React$Component);

  function OfflineStatus() {
    var _this;

    _this = _React$Component.call(this) || this;

    _defineProperty(_assertThisInitialized(_this), "onStartConversation", function (message) {});

    _this.state = {
      message: null
    };
    return _this;
  }

  var _proto = OfflineStatus.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        setting = _this$props.setting,
        showedScreen = _this$props.showedScreen;
    return /*#__PURE__*/React.createElement("div", {
      className: styles.container
    }, showedScreen === 'off' && /*#__PURE__*/React.createElement(WithoutAutomation, {
      setting: setting,
      onStartConversation: function onStartConversation(message) {
        var isInConfigurationMode = _this2.props.isInConfigurationMode;
        if (isInConfigurationMode) return;

        _this2.props.actions.startConversation(BUTTON_STARTS.LEAVE_MESSAGE, {
          isWorkingDay: setting.isInOperatingHours,
          leaveMessage: message
        });
      }
    }), showedScreen === 'off_with_chatbot' && /*#__PURE__*/React.createElement(WithAutomation, {
      setting: setting,
      onStartConversation: function onStartConversation() {
        _this2.props.actions.startConversation(BUTTON_STARTS.CHAT_WITH_BOT, {
          isWorkingDay: setting.isInOperatingHours
        });
      }
    }), /*#__PURE__*/React.createElement(CloseIcon, {
      className: styles.closeIcon,
      iconTextColor: _get(setting, 'screenConversation.rightSideBackgroundColor')
    }));
  };

  return OfflineStatus;
}(React.Component);

export default connect(function (store) {
  return {
    userInfo: _get(store, 'behavior.userInfo')
  };
}, function (dispatch) {
  return {
    actions: bindActionCreators({
      startConversation: startConversation
    }, dispatch)
  };
})(OfflineStatus);