import _extends from "@babel/runtime/helpers/extends";
import _get from "lodash/get";
import React from "react";
import styles from "./styles.scss";
import SVG from "react-inlinesvg";
import call from "../../../../icon/call.svg";
import "../overwrite.css";
import Loading from "../../../../../commons/components/loading";
export default (function (props) {
  var setting = props.setting,
      onClick = props.onClick,
      text = props.text,
      callIcon = props.callIcon,
      isBorder = props.isBorder,
      isLoading = props.isLoading,
      isAccessButton = props.isAccessButton,
      color = props.color,
      borderRadius = props.borderRadius,
      width = props.width; // console.log("isLoading: ", isLoading);

  return /*#__PURE__*/React.createElement("div", null, !isAccessButton ? /*#__PURE__*/React.createElement("div", {
    style: {
      width: "100%",
      height: "38px"
    },
    className: "boostcrm-call-button"
  }, /*#__PURE__*/React.createElement("button", {
    type: "submit",
    onClick: onClick,
    className: styles.theme3Container
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.button,
    style: _extends({}, isBorder ? {
      border: "1px solid " + _get(setting, 'screenConversation.rightSideBackgroundColor'),
      color: _get(setting, 'screenConversation.rightSideBackgroundColor')
    } : {
      backgroundColor: _get(setting, 'screenConversation.rightSideBackgroundColor')
    }, {
      width: width
    })
  }, !isLoading && callIcon && /*#__PURE__*/React.createElement("div", {
    className: styles.icon
  }, /*#__PURE__*/React.createElement(SVG, {
    src: call
  })), isLoading && /*#__PURE__*/React.createElement("div", {
    className: styles.icon
  }, /*#__PURE__*/React.createElement(Loading, {
    color: color || _get(setting, "screenConversation.rightSideBackgroundColor")
  })), text))) : /*#__PURE__*/React.createElement("div", {
    className: "boostcrm-call-button"
  }, /*#__PURE__*/React.createElement("button", {
    onClick: onClick,
    className: styles.theme3Container + " "
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.accessButton,
    style: {
      backgroundColor: _get(setting, "screenConversation.rightSideBackgroundColor")
    }
  }, text))));
});