import _get from "lodash/get";
import React from 'react';
import styles from './styles.scss';
import Header from '../header';
import Power from '../power';
import Button from '../button';
export default (function (_ref) {
  var handleGetPermission = _ref.handleGetPermission,
      setting = _ref.setting,
      isMobileMode = _ref.isMobileMode;

  var handleRequestAccessMicrophone = function handleRequestAccessMicrophone() {
    navigator.mediaDevices.getUserMedia({
      audio: true
    }).then(function (mediaStream) {
      handleGetPermission && handleGetPermission({
        isAllow: true
      });
      mediaStream.getTracks().forEach(function (track) {
        track.stop();
      });
    })["catch"](function () {
      handleGetPermission && handleGetPermission({
        isAllow: false
      });
    });
  };

  return /*#__PURE__*/React.createElement("div", {
    className: styles.container
  }, /*#__PURE__*/React.createElement(Header, {
    setting: setting,
    isMobileMode: isMobileMode
  }), /*#__PURE__*/React.createElement("div", {
    className: styles.deviceSetting
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.deviceStatus
  }, /*#__PURE__*/React.createElement("div", {
    className: styles.titleContent
  }, /*#__PURE__*/React.createElement("span", {
    className: styles.title,
    style: {
      color: _get(setting, 'screenConversation.rightSideBackgroundColor')
    }
  }, _get(setting, 'callThemeSettings.commonSettings.using_microphone_text'))), /*#__PURE__*/React.createElement("div", {
    className: styles.buttonContent
  }, /*#__PURE__*/React.createElement("span", {
    style: {
      fontFamily: 'Open Sans'
    },
    className: styles.button
  }, _get(setting, 'callThemeSettings.commonSettings.access_microphone_text'))), /*#__PURE__*/React.createElement("div", {
    className: styles.allowButton
  }, /*#__PURE__*/React.createElement(Button, {
    setting: setting,
    onClick: handleRequestAccessMicrophone,
    isAccessButton: true,
    callIcon: false,
    text: _get(setting, 'callThemeSettings.commonSettings.allow_microphone_label')
  })))), /*#__PURE__*/React.createElement(Power, {
    setting: setting
  }));
});