import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _get from "lodash/get";
import React, { Component } from 'react';
import styles from './styles.scss';
import { CALL_STATUS, CALL_STOP_REASON } from '../../constants';
import { CloseCallIcon } from '../../../icon';
import Power from '../power';
import SVG from 'react-inlinesvg';
import endCall from '../../../icon/end-call.svg';
import Avatar from '../../../../commons/components/avatar';
import { CALLING_ICON } from '../../../icon';

var PageInitCall = /*#__PURE__*/function (_Component) {
  _inheritsLoose(PageInitCall, _Component);

  function PageInitCall(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "onClickStop", function () {
      var handleStopCall = _this.props.handleStopCall; //ToDo: Server is based on TotalDuration. Need to refactor

      handleStopCall && handleStopCall(CALL_STOP_REASON.SUBSCRIBER_STOP, 0);
      clearTimeout(_this.setTimeoutStopCall);
    });

    return _this;
  }

  var _proto = PageInitCall.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    // Auto stop call after init 30s but nobody accepting this call
    // console.log("handleAutoStopCall");
    this.setTimeoutStopCall = setTimeout(function () {
      _this2.props.handleStopCall(CALL_STOP_REASON.SUBSCRIBER_AUTO_STOP_WHEN_TIMEOUT);
    }, 60000);

    window.parent.onbeforeunload = function () {
      return 'Do not reload page';
    };

    window.parent.addEventListener('unload', this.onClickStop);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.setTimeoutStopCall && clearInterval(this.setTimeoutStopCall);
    window.parent.onbeforeunload = null;
    window.parent.removeEventListener('unload', this.onClickStop);
  };

  _proto.render = function render() {
    var _this$props = this.props,
        callInfo = _this$props.callInfo,
        setting = _this$props.setting,
        isMobileMode = _this$props.isMobileMode;

    var status = _get(callInfo, ['callData', 'status']);

    var subscriberName = _get(callInfo.callData, ['callInfo', 'name']);

    var isCustomAvatar = _get(setting, 'callThemeSettings.isCustomProjectAvatar');

    return /*#__PURE__*/React.createElement("div", {
      className: styles.container
    }, status === CALL_STATUS.INITIATED && /*#__PURE__*/React.createElement("div", {
      className: styles.callStatus
    }, "Initializing..."), status === CALL_STATUS.RINGING && /*#__PURE__*/React.createElement("div", {
      className: styles.callStatus
    }, "Ringing..."), /*#__PURE__*/React.createElement("div", {
      className: styles.infoContent
    }, /*#__PURE__*/React.createElement("div", {
      className: styles.userAvatar
    }, /*#__PURE__*/React.createElement("div", {
      style: {
        backgroundColor: _get(setting, 'screenConversation.rightSideBackgroundColor'),
        color: _get(setting, 'screenConversation.rightSideBackgroundColor')
      },
      className: styles.wrapOpacity1
    }), /*#__PURE__*/React.createElement("div", {
      style: {
        backgroundColor: _get(setting, 'screenConversation.rightSideBackgroundColor')
      },
      className: styles.wrapOpacity2
    }), !isCustomAvatar ? /*#__PURE__*/React.createElement("div", {
      style: {
        backgroundColor: _get(setting, 'screenConversation.rightSideBackgroundColor')
      },
      className: styles.wrap
    }, /*#__PURE__*/React.createElement("div", {
      className: styles.icon
    }, /*#__PURE__*/React.createElement("img", {
      src: CALLING_ICON.CALLING1
    })), /*#__PURE__*/React.createElement("div", {
      className: styles.icon
    }, /*#__PURE__*/React.createElement("img", {
      src: CALLING_ICON.CALLING2
    })), /*#__PURE__*/React.createElement("div", {
      className: styles.icon
    }, /*#__PURE__*/React.createElement("img", {
      src: CALLING_ICON.CALLING3
    }))) : /*#__PURE__*/React.createElement("div", {
      style: {
        backgroundColor: _get(setting, 'screenConversation.rightSideBackgroundColor')
      },
      className: styles.wrap
    }, /*#__PURE__*/React.createElement(Avatar, {
      size: "60px",
      src: _get(setting, 'callThemeSettings.informationSettings.project_avatar')
    }))), /*#__PURE__*/React.createElement("div", {
      style: {
        marginTop: '9px'
      }
    }, /*#__PURE__*/React.createElement("span", {
      className: styles.userName
    }, _get(setting, 'callThemeSettings.informationSettings.project_name')))), /*#__PURE__*/React.createElement("div", {
      className: styles.endButton,
      onClick: this.onClickStop
    }, /*#__PURE__*/React.createElement("div", {
      className: styles.iconContainer
    }, /*#__PURE__*/React.createElement(SVG, {
      src: endCall
    }))), /*#__PURE__*/React.createElement("div", {
      className: styles.power
    }, /*#__PURE__*/React.createElement(Power, {
      setting: setting
    })), /*#__PURE__*/React.createElement(CloseCallIcon, {
      className: styles.closeIcon
    }));
  };

  return PageInitCall;
}(Component);

export { PageInitCall as default };