import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _isEmpty from "lodash/isEmpty";
import _get from "lodash/get";
import React, { Component } from 'react';
import styles from './styles.scss';
import Header from '../header';
import Power from '../power';
import Button from '../button';

var PageStartCall = /*#__PURE__*/function (_Component) {
  _inheritsLoose(PageStartCall, _Component);

  function PageStartCall() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "handleChangeSpeaker", function (e) {
      var _this$props = _this.props,
          handleSelectDevices = _this$props.handleSelectDevices,
          selectedMicrophoneId = _this$props.selectedMicrophoneId;
      handleSelectDevices && handleSelectDevices(e.target.value, selectedMicrophoneId);
    });

    _defineProperty(_assertThisInitialized(_this), "handleChangeMicrophone", function (e) {
      var _this$props2 = _this.props,
          handleSelectDevices = _this$props2.handleSelectDevices,
          selectedSpeakerId = _this$props2.selectedSpeakerId;
      handleSelectDevices && handleSelectDevices(selectedSpeakerId, e.target.value);
    });

    _defineProperty(_assertThisInitialized(_this), "handleClickCall", function () {
      var _this$props3 = _this.props,
          handleStartCall = _this$props3.handleStartCall,
          selectedMicrophoneId = _this$props3.selectedMicrophoneId,
          selectedSpeakerId = _this$props3.selectedSpeakerId;
      handleStartCall && handleStartCall(selectedSpeakerId, selectedMicrophoneId);
    });

    return _this;
  }

  var _proto = PageStartCall.prototype;

  _proto.render = function render() {
    var _this$props4 = this.props,
        selectedMicrophoneId = _this$props4.selectedMicrophoneId,
        selectedSpeakerId = _this$props4.selectedSpeakerId,
        callInfo = _this$props4.callInfo;
    var _this$props5 = this.props,
        devices = _this$props5.devices,
        setting = _this$props5.setting,
        isMobileMode = _this$props5.isMobileMode;
    var speakers = (devices || []).filter(function (device) {
      return device.kind === 'audiooutput';
    });
    var microphones = (devices || []).filter(function (device) {
      return device.kind === 'audioinput';
    });
    selectedSpeakerId = selectedSpeakerId || (!_isEmpty(speakers) ? speakers[0].deviceId : undefined);
    selectedMicrophoneId = selectedMicrophoneId || (!_isEmpty(microphones) ? microphones[0].deviceId : undefined);
    return /*#__PURE__*/React.createElement("div", {
      className: styles.container
    }, /*#__PURE__*/React.createElement(Header, {
      setting: setting,
      isMobileMode: isMobileMode
    }), /*#__PURE__*/React.createElement("div", {
      className: styles.content
    }, /*#__PURE__*/React.createElement("div", {
      className: styles.deviceSetting
    }, /*#__PURE__*/React.createElement("div", {
      className: styles.labelContainer
    }, /*#__PURE__*/React.createElement("div", {
      style: {
        color: _get(setting, 'screenConversation.rightSideBackgroundColor')
      },
      className: styles.label
    }, _get(setting, 'callThemeSettings.commonSettings.start_call__choose_your_input_device') || 'Choose your input device')), /*#__PURE__*/React.createElement("div", {
      className: styles.deviceStatus
    }, /*#__PURE__*/React.createElement("select", {
      onChange: this.handleChangeMicrophone,
      value: selectedMicrophoneId
    }, microphones.map(function (mic) {
      return /*#__PURE__*/React.createElement("option", {
        key: mic.deviceId,
        value: mic.deviceId
      }, mic.label);
    })))), /*#__PURE__*/React.createElement("div", {
      className: styles.btnCallWrapper
    }, /*#__PURE__*/React.createElement("div", {
      style: {
        width: '100%',
        paddingLeft: '39px',
        paddingRight: '39px'
      }
    }, /*#__PURE__*/React.createElement(Button, {
      isLoading: _get(this.props, 'callInfo.callData.status') === 'Connecting',
      setting: setting,
      onClick: this.handleClickCall,
      callIcon: true,
      color: "#fff",
      text: _get(setting, 'callThemeSettings.commonSettings.call_now_label'),
      width: "min-content"
    })))), /*#__PURE__*/React.createElement(Power, {
      setting: setting
    }));
  };

  return PageStartCall;
}(Component);

export { PageStartCall as default };