import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _get from "lodash/get";
import React, { Component } from 'react';
import Frame from 'react-frame-component';
import scrollIcon from '../icon/scroll_top.svg';
import WidgetIcon from '../../commons/components/widget-icon';

var ScrollTop = /*#__PURE__*/function (_Component) {
  _inheritsLoose(ScrollTop, _Component);

  function ScrollTop() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "state", {
      visibile: false
    });

    _defineProperty(_assertThisInitialized(_this), "handleClick", function () {
      var rootWindow = _this.props.rootWindow;
      var position = rootWindow.pageYOffset; // console.log("position", position);

      rootWindow && rootWindow.scrollTo({
        top: 0,
        left: 0,
        behavior: 'smooth'
      });
    });

    return _this;
  }

  var _proto = ScrollTop.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    var _this$props = this.props,
        rootWindow = _this$props.rootWindow,
        rootDocument = _this$props.rootDocument;

    if (rootWindow) {
      var updateIconStatus = function updateIconStatus() {
        var scrollHeight = _get(rootWindow, 'pageYOffset');

        var screenHeight = _get(rootWindow, 'screen.height') || _get(rootDocument, 'body.clientHeight');

        if (scrollHeight - screenHeight > 0) {
          _this2.setState({
            visibile: true
          });
        } else {
          _this2.setState({
            visibile: false
          });
        }
      };

      rootWindow.onscroll = function () {
        updateIconStatus();
      };

      if (rootWindow && rootDocument) {
        updateIconStatus();
      }
    }
  };

  _proto.render = function render() {
    var _this$props2 = this.props,
        iframeStyles = _this$props2.iframeStyles,
        position = _this$props2.position,
        setting = _this$props2.setting,
        svgSize = _this$props2.svgSize;
    var iconBackgroundColor = setting.iconBackgroundColor,
        iconTextColor = setting.iconTextColor,
        isAlwayShowScrollTop = setting.isAlwayShowScrollTop;

    var iconSize = _get(setting, 'iconSize');

    return isAlwayShowScrollTop || this.state.visibile ? /*#__PURE__*/React.createElement(Frame, {
      initialContent: "<!DOCTYPE html><html><head>" + iframeStyles + "</head><body></body></html>",
      mountTarget: "body",
      style: {
        width: iconSize,
        height: iconSize,
        position: 'absolute',
        bottom: position.bottom + "px",
        right: position.right + "px",
        transition: "opacity 0.8s",
        zIndex: '9999997',
        maxWidth: iconSize,
        minWidth: iconSize,
        minHeight: iconSize,
        maxHeight: iconSize
      },
      allowtransparency: "yes",
      frameBorder: "0"
    }, /*#__PURE__*/React.createElement(WidgetIcon, {
      iconBackgroundColor: iconBackgroundColor,
      iconSize: iconSize,
      iconSrc: scrollIcon,
      iconTextColor: iconTextColor,
      svgSize: 20,
      onClick: this.handleClick
    })) : /*#__PURE__*/React.createElement("div", {
      style: {
        display: 'none'
      }
    });
  };

  return ScrollTop;
}(Component);

export { ScrollTop as default };