import _extends from "@babel/runtime/helpers/extends";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _get from "lodash/get";
import React, { Component } from 'react';
import Frame from 'react-frame-component';
import closeIcon from '../icon/collapse_widgets.svg';
import supportIcon from '../icon/support.svg';
import WidgetIcon from '../../commons/components/widget-icon';

var Support = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Support, _Component);

  function Support(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleClick", function () {
      var _this$props = _this.props,
          t = _this$props.t,
          toggleCollapseExpandWidget = _this$props.toggleCollapseExpandWidget;
      toggleCollapseExpandWidget && toggleCollapseExpandWidget();
    });

    _this.myRef = React.createRef();
    _this.state = {
      widthText: 0
    };
    return _this;
  }

  var _proto = Support.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.myRef.current && this.setState({
      widthText: this.myRef.current.offsetWidth
    });
  };

  _proto.render = function render() {
    var _this$props2 = this.props,
        iframeStyles = _this$props2.iframeStyles,
        position = _this$props2.position,
        setting = _this$props2.setting,
        svgSize = _this$props2.svgSize,
        isCurrentExpand = _this$props2.isCurrentExpand,
        area = _this$props2.area,
        showChat = _this$props2.showChat,
        numberOfNewMessages = _this$props2.numberOfNewMessages,
        marginBottom = _this$props2.marginBottom,
        isSettingLeftBottom = _this$props2.isSettingLeftBottom,
        marginLeft = _this$props2.marginLeft,
        isFixedRect = _this$props2.isFixedRect;
    var iconBackgroundColor = setting.iconBackgroundColor,
        iconTextColor = setting.iconTextColor;

    var iconSize = _get(setting, 'iconSize');

    var isActive = _get(setting, 'display.isActiveTextAction');

    var toolTipHeight = iconSize === 70 ? 44 : iconSize === 60 ? 38 : 36;
    var bottom = (iconSize - toolTipHeight) / 2 + marginBottom;
    var positionTextAction = isSettingLeftBottom ? {
      left: !isFixedRect ? -(position.right - 10) : marginLeft + iconSize + 10
    } : {
      right: position.right + iconSize + 10
    };

    var style = _extends({
      padding: iconSize === 70 ? '11px 16px' : iconSize === 60 ? '8px 14px' : '7px 12px',
      boxShadow: '0 0 10px 0 rgba(0, 0, 0, 0.16)',
      backgroundColor: '#ffffff',
      position: 'absolute',
      bottom: bottom + "px",
      fontFamily: 'OpenSans-Regular',
      fontSize: '16px',
      fontWeight: 'normal',
      fontStretch: 'normal',
      fontStyle: 'normal',
      letterSpacing: 'normal',
      textAlign: 'left',
      color: '#000000',
      minWidth: 'max-content'
    }, positionTextAction);

    return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Frame, {
      initialContent: "<!DOCTYPE html><html><head>" + iframeStyles + "</head><body></body></html>",
      mountTarget: "body",
      style: {
        width: iconSize,
        height: iconSize,
        position: 'absolute',
        bottom: position.bottom + "px",
        right: position.right + "px",
        transition: "opacity 0.8s",
        zIndex: '9999997',
        maxWidth: iconSize,
        minWidth: iconSize,
        minHeight: iconSize,
        maxHeight: iconSize
      },
      allowtransparency: "yes",
      frameBorder: "0"
    }, /*#__PURE__*/React.createElement(WidgetIcon, {
      iconBackgroundColor: iconBackgroundColor,
      iconSize: iconSize,
      iconSrc: isCurrentExpand ? closeIcon : supportIcon,
      iconTextColor: iconTextColor,
      svgSize: isCurrentExpand ? 16 : svgSize,
      onClick: this.handleClick,
      numberOfNewMessages: !isCurrentExpand && !showChat ? numberOfNewMessages : null
    })), /*#__PURE__*/React.createElement("div", null, isActive && !isCurrentExpand && /*#__PURE__*/React.createElement("span", {
      ref: this.myRef,
      style: style
    }, _get(setting, 'display.textAction') || 'Need support?')));
  };

  return Support;
}(Component);

export { Support as default };