import _extends from "@babel/runtime/helpers/extends";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _get from "lodash/get";
import React, { Component, useState, useRef, useEffect } from "react";

var Tooltip = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Tooltip, _Component);

  function Tooltip(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.myRef = React.createRef();
    _this.state = {
      widthText: 0
    };
    return _this;
  }

  var _proto = Tooltip.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.getWidthTooltip();
  };

  _proto.componentDidUpdate = function componentDidUpdate() {
    this.getWidthTooltip();
  };

  _proto.getWidthTooltip = function getWidthTooltip() {
    if (this.myRef.current && +this.myRef.current.offsetWidth !== +this.state.widthText && (+this.myRef.current.offsetWidth > +this.state.widthText + 5 || +this.myRef.current.offsetWidth < +this.state.widthText - 5)) {
      this.setState({
        widthText: +this.myRef.current.offsetWidth
      });
    }
  };

  _proto.render = function render() {
    var _this$props = this.props,
        type = _this$props.type,
        isSettingLeftBottom = _this$props.isSettingLeftBottom,
        position = _this$props.position,
        marginBottom = _this$props.marginBottom,
        setting = _this$props.setting,
        isHover = _this$props.isHover,
        isSettingVertical = _this$props.isSettingVertical,
        marginRight = _this$props.marginRight,
        index = _this$props.index;
    var widthText = this.state.widthText;

    var iconSize = _get(setting, 'iconSize');

    var toolTipHeight = iconSize === 70 ? 44 : iconSize === 60 ? 38 : 36;
    var bottom = isSettingVertical ? (iconSize - toolTipHeight) / 2 + marginBottom + (iconSize + 10) * index : marginBottom + iconSize + 10;
    var positionTextAction = isSettingLeftBottom ? {
      right: isSettingVertical ? position.right - 10 - widthText : position.right - (widthText - iconSize) / 2
    } : {
      right: isSettingVertical ? marginRight + iconSize + 10 : position.right - (widthText - iconSize) / 2
    };

    var style = _extends({
      padding: iconSize === 70 ? '11px 16px' : iconSize === 60 ? '8px 14px' : '7px 12px',
      boxShadow: '0 0 10px 0 rgba(0, 0, 0, 0.16)',
      backgroundColor: '#ffffff',
      position: 'absolute',
      bottom: bottom + "px",
      fontFamily: 'OpenSans-Regular',
      fontSize: '16px',
      fontWeight: 'normal',
      fontStretch: 'normal',
      fontStyle: 'normal',
      letterSpacing: 'normal',
      textAlign: 'left',
      color: '#000000',
      minWidth: 'max-content'
    }, positionTextAction);

    return /*#__PURE__*/React.createElement("span", {
      style: style,
      ref: this.myRef,
      className: "tooltip"
    }, type.charAt(0).toUpperCase() + type.slice(1));
  };

  return Tooltip;
}(Component);

export { Tooltip as default };