import _extends from "@babel/runtime/helpers/extends";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _get from "lodash/get";
import React, { Component } from "react";
import Frame from "react-frame-component";
import twitterIcon from "../icon/twitter.svg";
import WidgetIcon from "../../commons/components/widget-icon";
import Tooltip from "../tooltip";

var Twitter = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Twitter, _Component);

  function Twitter(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      isHover: false
    };
    return _this;
  }

  var _proto = Twitter.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        iframeStyles = _this$props.iframeStyles,
        position = _this$props.position,
        setting = _this$props.setting,
        svgSize = _this$props.svgSize,
        component = _this$props.component;
    var iconBackgroundColor = setting.iconBackgroundColor,
        iconTextColor = setting.iconTextColor;

    var iconSize = _get(setting, "iconSize");

    var link = _get(component, "configurationData.link");

    return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Frame, {
      initialContent: "<!DOCTYPE html><html><head>" + iframeStyles + "</head><body></body></html>",
      mountTarget: "body",
      style: {
        width: iconSize,
        height: iconSize,
        position: "absolute",
        bottom: position.bottom + "px",
        right: position.right + "px",
        transition: "opacity 0.8s",
        zIndex: "9999997",
        maxWidth: iconSize,
        minWidth: iconSize,
        minHeight: iconSize,
        maxHeight: iconSize
      },
      allowtransparency: "yes",
      frameBorder: "0"
    }, /*#__PURE__*/React.createElement(WidgetIcon, {
      iconBackgroundColor: iconBackgroundColor,
      iconSize: iconSize,
      iconSrc: twitterIcon,
      iconTextColor: iconTextColor,
      svgSize: svgSize,
      onClick: function onClick() {
        link && window.open(link, "_blank");
      },
      handleHover: function handleHover(e) {
        return _this2.setState(e);
      }
    })), this.state.isHover && /*#__PURE__*/React.createElement(Tooltip, _extends({}, this.props, this.state)));
  };

  return Twitter;
}(Component);

export { Twitter as default };