import _extends from "@babel/runtime/helpers/extends";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _cloneDeep from "lodash/cloneDeep";
import _find from "lodash/find";
import _get from "lodash/get";

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import _regeneratorRuntime from "@babel/runtime/regenerator";
import React, { Suspense, lazy } from 'react';
import { Provider } from 'react-redux';
import { createStore, combineReducers, applyMiddleware } from 'redux';
import thunk from 'redux-thunk';
import behavior from './store/reducers/behavior.reducer';
import messages from './store/reducers/message.reducer';
import { composeWithDevTools } from 'redux-devtools-extension';
import { initWSClient, closeWSClient, setMessageHanlder, sendWebsiteEvent, disconnectWSClient, reconnectWSClient } from '../src/connections/websocket';
import WidgetContext from './widget-context';
import { setLSVariable, getLSVariable } from './commons/utils/local-storage';
import { setChannelId, setTenantId, setConversationId } from './commons/tenant-info';
import { LOCAL_STORAGE_VARIABLES, getLocalStorageVariables } from './commons/constants/local-storage';
import { WEBSITE_EVENTS } from './commons/constants/website-events';
import { GROUP, TYPE } from './commons/constants/websocket';
import { STARTING_POINT_TYPES } from './commons/constants/starting-point-types';
import { sendAckReceivingMessage } from './store/actions/ws.actions';
import clearEndSlash from './commons/utils/clear-end-slash';
import runFunAfter from './commons/utils/run-fun-after';
import { NetworkDetector } from './commons/utils/network-detector';
import { triggerTheStartingPoint, triggerTheWelcomeMessageWhenVisitPage } from './store/actions/start-conversation.actions';
var Widget = lazy(function () {
  return import('./components/widget');
});
var Conversation = lazy(function () {
  return import('./components/conversation');
});

var getHrefWithoutQueryAndParam = function getHrefWithoutQueryAndParam() {
  return "" + window.location.origin + window.location.pathname;
};

var getListStartingPoints = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(host, channelId, templateId) {
    var results, pageIndex, pageSize, totalReturnedItems, response, returnedItems;
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            results = [];
            pageIndex = 1;
            pageSize = 10;
            totalReturnedItems = 0;

          case 4:
            _context.next = 6;
            return fetch(host + "/channel/website/starting-points?channelId=" + channelId + "&templateId=" + templateId + "&pageIndex=" + pageIndex, {
              method: 'GET'
            });

          case 6:
            response = _context.sent;
            ++pageIndex;
            _context.next = 10;
            return response.json();

          case 10:
            returnedItems = _context.sent;
            Array.from(returnedItems || []).forEach(function (item) {
              if (item.active) {
                results.push(item);
              }
            });
            totalReturnedItems = returnedItems.length;

          case 13:
            if (totalReturnedItems === pageSize) {
              _context.next = 4;
              break;
            }

          case 14:
            return _context.abrupt("return", results);

          case 15:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function getListStartingPoints(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

function findValidStartingPoint(startingPoints, type, opts) {
  for (var _iterator = _createForOfIteratorHelperLoose(startingPoints), _step; !(_step = _iterator()).done;) {
    var startPoint = _step.value;

    if (type === STARTING_POINT_TYPES.VISITOR_CLICK_ELEMENT) {
      var id = opts.id,
          className = opts.className;
      if (id && id === _get(startPoint, 'detail.id')) return startPoint;
      if (className && className === _get(startPoint, 'detail.className')) return startPoint;
    }

    if (type === STARTING_POINT_TYPES.VISITOR_VISIT_URLS) {
      var _ret = function () {
        var url = opts.url; // console.log("url:", url);

        var requiredUrls = _get(startPoint, 'detail.urls') || [];
        var lowercaseUrlWithoutEndSlash = toLower(clearEndSlash(url)); // console.log("lowercaseUrlWithoutEndSlash:", lowercaseUrlWithoutEndSlash);

        if (_find(requiredUrls, function (defineUrl) {
          return toLower(clearEndSlash(defineUrl)) === lowercaseUrlWithoutEndSlash;
        })) {
          // console.log("found starting point");
          return {
            v: startPoint
          };
        }
      }();

      if (typeof _ret === "object") return _ret.v;
    }
  }

  return null;
}

var generateDefaultIframeStyles = function generateDefaultIframeStyles(styleSheetLink, widgetStylesheet) {
  return (styleSheetLink ? "<link rel=\"stylesheet\" href=\"" + styleSheetLink + "\"></link>" : '') + "\n  <style type=\"text/css\" class=\"iframe-boostcrm\">\n    .frame-content {\n      height: 100%;\n    }  \n    body {\n      font-family: 'Roboto !important';\n    }\n    body {\n      background: none !important;\n      background-color: transparent !important;    \n      overflow:hidden\n    }\n    " + (widgetStylesheet || '') + "\n  </style>";
};

var ConnectedWidget = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(ConnectedWidget, _React$Component);

  function ConnectedWidget(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "networkChangesHandler", function (isOnline) {
      if (!isOnline) {
        disconnectWSClient();
      } else {
        reconnectWSClient();
      }
    });

    var _this$props = _this.props,
        isInConfigurationMode = _this$props.isInConfigurationMode,
        isSimulator = _this$props.isSimulator,
        onInitConversationSuccess = _this$props.onInitConversationSuccess,
        setting = _this$props.setting,
        styleSheetLink = _this$props.styleSheetLink;
    var host = setting.host,
        tenantId = setting.tenantId,
        channelId = setting.channelId,
        automation = setting.automation;
    var isDisableLiveChat = !_get(setting, 'chatboxComponent.enable');
    var isDisableCall = !_get(setting, 'callComponent.enable');
    _this.state = {
      online: true,
      isReconnecting: false,
      isConnectFailed: false,
      iframeStylesInnerHtml: '',
      iframeStyles: generateDefaultIframeStyles(styleSheetLink)
    };
    var reducer = combineReducers({
      behavior: behavior,
      messages: messages
    });

    if (isInConfigurationMode) {
      _this.store = createStore(function () {}, process.env.NODE_ENV !== 'production' ? composeWithDevTools(applyMiddleware(thunk)) : applyMiddleware(thunk));
      return _assertThisInitialized(_this);
    }

    var styleTag = props.pageDocument.head.querySelector('.boostcrm-stylesheet');

    if (styleTag) {
      var observer = new MutationObserver(function () {
        _this.setState({
          iframeStylesInnerHtml: _this.state.iframeStylesInnerHtml + styleTag.innerHTML,
          iframeStyles: generateDefaultIframeStyles(styleSheetLink, _this.state.iframeStylesInnerHtml + styleTag.innerHTML)
        });

        styleTag.innerHTML = '';
      });
      observer.observe(styleTag, {
        characterData: false,
        childList: true,
        attributes: false
      });
    }

    setTenantId(tenantId);
    setChannelId(channelId);
    setLSVariable(getLocalStorageVariables(LOCAL_STORAGE_VARIABLES.IS_SIMULATOR, channelId), isSimulator);
    var persistentState = getLSVariable(getLocalStorageVariables(LOCAL_STORAGE_VARIABLES.STORE_STATE, channelId));
    setLSVariable(getLocalStorageVariables(LOCAL_STORAGE_VARIABLES.CHANNEL_ID, channelId), channelId);
    setLSVariable(getLocalStorageVariables(LOCAL_STORAGE_VARIABLES.TENANT_ID, channelId), tenantId);
    setLSVariable(getLocalStorageVariables(LOCAL_STORAGE_VARIABLES.HOST, channelId), host);

    if (isSimulator) {
      persistentState = {};
    }

    if (_get(persistentState, ['behavior', 'callInfo', 'callData'])) {
      persistentState.behavior.callInfo.callData = null;
    }

    _this.store = createStore(reducer, persistentState || {}, process.env.NODE_ENV !== 'production' ? composeWithDevTools(applyMiddleware(thunk)) : applyMiddleware(thunk));

    if (_this.store) {
      _this.store.subscribe(function () {
        var data = _cloneDeep(_this.store.getState());

        setLSVariable(getLocalStorageVariables(LOCAL_STORAGE_VARIABLES.STORE_STATE, channelId), data);
      });
    }

    if (!isSimulator && isDisableCall && isDisableLiveChat) return _assertThisInitialized(_this);
    initWSClient(host, _this.props.setting.channelToken, channelId, isSimulator, null, function (newConversationId) {
      // console.log("Start new conversation: ", newConversationId);
      setConversationId(newConversationId);
      newConversationId && onInitConversationSuccess && onInitConversationSuccess(newConversationId);
    }, function () {
      console.log('set online false 1');

      _this.setState({
        online: false,
        isConnectFailed: true,
        isReconnecting: false
      });
    }, function () {
      console.log('set online false 2');

      _this.setState({
        online: false,
        isConnectFailed: false,
        isReconnecting: true
      });
    }, function () {
      console.log('set online true');

      _this.setState({
        online: true,
        isConnectFailed: false,
        isReconnecting: false
      });
    });
    setMessageHanlder(function (message) {
      var actionType = "WS_" + _get(message, 'group') + "_" + _get(message, 'type');

      _this.store.dispatch({
        type: actionType,
        payload: message.payload
      });

      if (_get(message, 'group') === GROUP.MESSAGE && _get(message, 'type') === TYPE.MESSAGE.NEW_MESSAGE_FROM_ADMIN) {
        _this.store.dispatch(sendAckReceivingMessage(message.payload, channelId));
      }
    });

    if (!isSimulator) {
      sendWebsiteEvent(WEBSITE_EVENTS.VISIT_URL, {
        url: getHrefWithoutQueryAndParam(),
        loadDate: new Date(),
        tenantInfo: {
          channelId: channelId
        }
      });
      runFunAfter(function () {
        _this.store.dispatch && _this.store.dispatch(triggerTheWelcomeMessageWhenVisitPage(setting));
      }, 1000); // Get list of starting points here.

      var _ref2 = automation || {},
          enabled = _ref2.enabled,
          templateId = _ref2.templateId;

      if (enabled && templateId) {
        getListStartingPoints(host, setting.channelId, templateId).then(function (startingPoints) {
          if (startingPoints.length === 0) return; // Check if needed to trigger event 'visit-urls'

          var startingPointForVisitURLs = findValidStartingPoint(startingPoints, STARTING_POINT_TYPES.VISITOR_VISIT_URLS, {
            url: getHrefWithoutQueryAndParam()
          });
          startingPointForVisitURLs && runFunAfter(function () {
            _this.store.dispatch && _this.store.dispatch(triggerTheStartingPoint(STARTING_POINT_TYPES.VISITOR_VISIT_URLS, startingPointForVisitURLs.id, setting));
          }, 1000);
          var pageDocument = props.pageDocument;

          if (pageDocument) {
            pageDocument.addEventListener('click', function (e) {
              if (!e) return;
              var toElement = e.toElement;
              if (!toElement) return;
              var id = toElement.id;
              var className = toElement.className;
              var validStartPoint = findValidStartingPoint(startingPoints, STARTING_POINT_TYPES.VISITOR_CLICK_ELEMENT, {
                id: id,
                className: className
              });
              validStartPoint && _this.store.dispatch && _this.store.dispatch(triggerTheStartingPoint(STARTING_POINT_TYPES.VISITOR_CLICK_ELEMENT, validStartPoint.id, setting));
            }, true);
          }
        });
      }
    }

    return _this;
  }

  var _proto = ConnectedWidget.prototype;

  _proto.componentWillUnmount = function componentWillUnmount() {
    closeWSClient();
  };

  _proto.render = function render() {
    var _this$props2 = this.props,
        setting = _this$props2.setting,
        isSimulator = _this$props2.isSimulator,
        isInConfigurationMode = _this$props2.isInConfigurationMode;
    var _this$state = this.state,
        online = _this$state.online,
        isReconnecting = _this$state.isReconnecting,
        isConnectFailed = _this$state.isConnectFailed,
        iframeStyles = _this$state.iframeStyles;
    return /*#__PURE__*/React.createElement(Provider, {
      store: this.store
    }, /*#__PURE__*/React.createElement(WidgetContext.Provider, {
      value: {
        setting: setting,
        isSimulator: isSimulator,
        online: online,
        isReconnecting: isReconnecting,
        isConnectFailed: isConnectFailed,
        isInConfigurationMode: isInConfigurationMode
      }
    }, isSimulator && /*#__PURE__*/React.createElement(Suspense, {
      fallback: /*#__PURE__*/React.createElement("div", null)
    }, /*#__PURE__*/React.createElement(Conversation, _extends({
      online: online,
      isReconnecting: isReconnecting,
      isConnectFailed: isConnectFailed,
      isSimulator: true,
      isMobileMode: true,
      iframeStyles: iframeStyles,
      rect: {
        width: 500,
        height: 600
      }
    }, this.props))), !isSimulator && /*#__PURE__*/React.createElement(Suspense, {
      fallback: /*#__PURE__*/React.createElement("div", null)
    }, /*#__PURE__*/React.createElement(Widget, _extends({}, this.props, {
      iframeStyles: iframeStyles,
      rootWindow: window,
      rootDocument: document
    }))), /*#__PURE__*/React.createElement(NetworkDetector, {
      onChange: this.networkChangesHandler
    })));
  };

  return ConnectedWidget;
}(React.Component);

export { ConnectedWidget as default };