import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _isEmpty from "lodash/isEmpty";
import _regeneratorRuntime from "@babel/runtime/regenerator";

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import * as actions from './action-type';
import { createAction } from 'redux-actions';

function getDeviceList(cb) {
  // console.log("getDeviceList");
  try {
    var gotDevices = function gotDevices(devices) {
      // console.log("gotDevices: ", JSON.stringify(devices));
      cb(devices || []);
    };

    var handleError = function handleError(error) {
      // console.log("gotDevices-handleError: ", error);
      cb([]);
    };

    navigator.mediaDevices.enumerateDevices().then(gotDevices)["catch"](handleError);
  } catch (ex) {
    cb([]);
  }
}

export var checkMediaDeviceRequest = createAction(actions.CHECK_MEDIA_DEVICE + ".REQUEST");
export var checkMediaDeviceSuccess = createAction(actions.CHECK_MEDIA_DEVICE + ".SUCCESS");
export var checkMediaDevice = function checkMediaDevice() {
  // console.log("checkMediaDevice");
  return /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(dispatch, store) {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return dispatch(checkMediaDeviceRequest());

            case 2:
              getDeviceList(function (devices) {
                var totalAudioInput = 0;
                var totalAudioOutput = 0;
                var isAllowAcessMedia = false;

                for (var _iterator = _createForOfIteratorHelperLoose(devices), _step; !(_step = _iterator()).done;) {
                  var device = _step.value;

                  var _ref2 = device || {},
                      kind = _ref2.kind,
                      label = _ref2.label;

                  if (kind === 'audioinput') {
                    totalAudioInput++;
                  }

                  if (kind === 'audiooutput') {
                    totalAudioOutput++;
                  }

                  if (!isAllowAcessMedia && !_isEmpty(label)) {
                    isAllowAcessMedia = true;
                  }
                }

                dispatch(checkMediaDeviceSuccess({
                  totalAudioInput: totalAudioInput,
                  totalAudioOutput: totalAudioOutput,
                  devices: devices,
                  isAllowAcessMedia: isAllowAcessMedia
                }));
              });

            case 3:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};