"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.handleCorrectMessages = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _size2 = _interopRequireDefault(require("lodash/size"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _messageType = require("../constants/message-type");

var _senderTypes = require("../constants/sender-types");

var defaultIdForSubscriber = 'subscriber';
var defaultIdForBot = 'bot';
var listTypeMessageHide = [_messageType.MESSAGE_TYPES.QUICK_REPLY, _messageType.MESSAGE_TYPES.DELAY];

var handleCorrectMessages = function handleCorrectMessages(messages) {
  if ((0, _isEmpty2["default"])(messages)) return [];
  var lastPosition = (0, _size2["default"])(messages) - 1;
  messages = (messages || []).map(function (message, index) {
    //correct senderId
    // let senderId = get(message, 'senderId') ? get(message, 'senderId') : get(message, 'senderType') === 1 ? defaultIdForSubscriber : defaultIdForBot;
    var senderType = (0, _get2["default"])(message, 'senderType'); // if (!senderType) {
    //   console.log('senderType in: ', JSON.stringify(message));
    // }

    var senderId = senderType === _senderTypes.SENDER_TYPES.ADMIN || senderType === _senderTypes.SENDER_TYPES.BOT ? defaultIdForBot : senderType === _senderTypes.SENDER_TYPES.SUBSCRIBER ? defaultIdForSubscriber : (0, _get2["default"])(message, 'senderId') ? (0, _get2["default"])(message, 'senderId') : defaultIdForSubscriber; // console.log(`senderType: ${senderType} - senderId: ${senderId}`);
    //QuickReply, Typing only show when they are at last message. They will be hidden if there are new coming messages or user select the button on quickReply

    if ((0, _includes2["default"])(listTypeMessageHide, (0, _get2["default"])(message, 'message.type')) && index !== lastPosition) {
      return (0, _extends2["default"])({}, message, {
        isHideMessage: true,
        senderId: senderId
      });
    }

    return (0, _extends2["default"])({}, message, {
      senderId: senderId
    });
  });
  return messages;
};

exports.handleCorrectMessages = handleCorrectMessages;