"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _find2 = _interopRequireDefault(require("lodash/find"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _reactFrameComponent = _interopRequireDefault(require("react-frame-component"));

var _message = require("../../store/actions/message.actions");

var _widgetContext = _interopRequireDefault(require("../../widget-context"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var LayoutStyleOne = (0, _react.lazy)(function () {
  return Promise.resolve().then(function () {
    return _interopRequireWildcard(require('./layout/style-one'));
  });
});
var LayoutStyleTwo = (0, _react.lazy)(function () {
  return Promise.resolve().then(function () {
    return _interopRequireWildcard(require('./layout/style-two'));
  });
});
var LayoutStyleThree = (0, _react.lazy)(function () {
  return Promise.resolve().then(function () {
    return _interopRequireWildcard(require('./layout/style-three'));
  });
});
var NoConection = (0, _react.lazy)(function () {
  return Promise.resolve().then(function () {
    return _interopRequireWildcard(require('./no-connection'));
  });
});

var _default = function _default(props) {
  var iframeStyles = props.iframeStyles,
      isInConfigurationMode = props.isInConfigurationMode,
      demoData = props.demoData,
      setting = props.setting,
      isMobileMode = props.isMobileMode,
      area = props.area,
      rect = props.rect,
      isSimulator = props.isSimulator,
      position = props.position,
      isShowChat = props.isShowChat,
      isSettingCollapse = props.isSettingCollapse,
      isSettingLeftBottom = props.isSettingLeftBottom,
      isSettingVertical = props.isSettingVertical,
      marginBottom = props.marginBottom,
      marginRight = props.marginRight,
      marginLeft = props.marginLeft;

  var _useContext = (0, _react.useContext)(_widgetContext["default"]),
      online = _useContext.online;

  var dispatch = (0, _reactRedux.useDispatch)();
  var iframeRef = (0, _react.useRef)();
  var activeTheme = setting.activeTheme,
      isEnableAutomation = setting.isEnableAutomation,
      isInOperatingHours = setting.isInOperatingHours;
  var isStartConversationFromAdmin = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get2["default"])(store, 'behavior.isStartConversationFromAdmin');
  });
  var alreadySubmitUserInfo = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get2["default"])(store, 'behavior.alreadySubmitUserInfo');
  });
  var alreadyStartConversation = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get2["default"])(store, 'behavior.alreadyStartConversation');
  });
  var hasTriggeredWelcomeMessage = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get2["default"])(store, 'behavior.hasTriggeredWelcomeMessage');
  });
  var lastTimeAcceptChattingWithBot = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get2["default"])(store, 'behavior.lastTimeAcceptChattingWithBot');
  });
  var lastTimeAcceptLeavingOfflineMessage = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get2["default"])(store, 'behavior.lastTimeAcceptLeavingOfflineMessage');
  });
  var lastTimeReceivingMessageFromAdmin = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get2["default"])(store, 'behavior.lastTimeReceivingMessageFromAdmin');
  });
  var messages = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get2["default"])(store, 'messages.messages');
  });
  var participants = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get2["default"])(store, 'messages.participants');
  });
  var showChat = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get2["default"])(store, 'behavior.showChat');
  });

  var getFrameStyle = function getFrameStyle() {
    var isLeftSite = (0, _get2["default"])(setting, 'chatboxComponent.position') === 'left-bottom';

    if (isMobileMode) {
      return {
        right: 0,
        bottom: 0,
        position: 'fixed',
        width: '100%',
        minHeight: '250px',
        maxHeight: '100%',
        maxWidth: 'unset',
        // boxShadow: isShowChat ? 'rgba(0, 0, 0, 0.16) 0px 5px 40px' : 'none', // Phần content load sau gây cảm giác chậm
        opacity: isSimulator ? '1' : isShowChat ? '1' : '0',
        transform: isSimulator ? 'scale(1, 1)' : isShowChat ? 'scale(1, 1)' : 'scale(0, 0)',
        transition: "transform 0.3s ease-in-out,opacity 0.3s ease-in-out , box-shadow 0.3s ease-in-out",
        height: '100%',
        zIndex: 9999998,
        transformOrigin: 'bottom right'
      };
    } else {
      var windowWidth = rect.width;
      var iconSize = setting.iconSize,
          iconMargin = setting.iconMargin;
      var bottom = 0;
      var right;
      var width = 400;

      if (isSettingCollapse) {
        if (isSettingLeftBottom) {
          if (isSettingVertical) {
            bottom = 0;
            right = position.right - width - iconMargin + 10;
          } else {
            bottom = 10 + iconSize;
            right = windowWidth - width - marginLeft + 10;
          }
        } else {
          if (isSettingVertical) {
            right = (position.right || 10) + iconSize + iconMargin - 10;
            bottom = 0;
          } else {
            bottom = iconSize + 10;
            right = marginRight - 10;
          }
        }
      } else {
        if (isSettingLeftBottom) {
          if (isSettingVertical) {
            bottom = 0;
            right = position.right - width - iconMargin;
          } else {
            bottom = iconSize + iconMargin;
            right = windowWidth - width - marginLeft;
          }
        } else {
          if (isSettingVertical) {
            bottom = marginBottom;
            right = position.right + iconSize + 10;
          } else {
            bottom = marginBottom + 10 + iconSize;
            right = marginRight;
          }
        }
      }

      return {
        right: right + "px",
        bottom: bottom + "px",
        position: 'absolute',
        width: width + "px",
        minHeight: '250px',
        maxHeight: '600px',
        maxWidth: 'unset',
        // boxShadow: isShowChat ? 'rgba(0, 0, 0, 0.16) 0px 5px 40px' : 'none',
        opacity: isSimulator ? '1' : isShowChat ? '1' : '0',
        height: "600px",
        zIndex: 9999998,
        background: 'transparent',
        transform: isSimulator ? 'scale(1, 1)' : isShowChat ? 'scale(1, 1)' : 'scale(0, 0)',
        transition: "transform 0.3s ease-in-out,opacity 0.3s ease-in-out , box-shadow 0.3s ease-in-out",
        transformOrigin: isSettingLeftBottom ? 'bottom left' : 'bottom right'
      };
    }
  };

  (0, _react.useEffect)(function () {
    if (showChat && !isInConfigurationMode && !isSimulator) {
      dispatch((0, _message.getMessages)(false, setting.channelId));
    }
  }, [showChat]);
  (0, _react.useEffect)(function () {
    // console.log('iframeStyles change!');
    if (iframeRef.current) {
      var stylesheetNode = (0, _find2["default"])(iframeRef.current.node.contentDocument.styleSheets, function (node) {
        return (0, _get2["default"])(node, 'ownerNode.className') === 'iframe-boostcrm';
      });

      if (stylesheetNode && stylesheetNode.ownerNode) {
        stylesheetNode.ownerNode.outerHTML = iframeStyles;
      }
    }
  }, [iframeStyles]);

  if (!isInConfigurationMode && !online) {
    console.log('!isInConfigurationMode && !online: ', !isInConfigurationMode && !online);
    console.log('isInConfigurationMode: ', isInConfigurationMode);
    console.log('online: ', online);
  }

  return /*#__PURE__*/_react["default"].createElement(_reactFrameComponent["default"], {
    ref: iframeRef,
    initialContent: "<!DOCTYPE html><html><head>          \n        <link href=\"https://fonts.googleapis.com/css?family=Comfortaa&display=swap\" rel=\"stylesheet\">\n        <link href=\"https://fonts.googleapis.com/css?family=Roboto&display=swap\" rel=\"stylesheet\">\n        <link href=\"https://fonts.googleapis.com/css2?family=Open+Sans&display=swap\" rel=\"stylesheet\">\n        <style>\n          .bs-chatbox-input-container .ant-upload {\n            display: flex !important;\n          }\n          .bs-chat-box-form .ant-form-item-control {\n            line-height: 31px !important;\n          }\n        </style>\n        " + iframeStyles + "</head><body></body></html>\n      ",
    mountTarget: "body",
    allowtransparency: "yes",
    style: getFrameStyle(),
    frameBorder: "0",
    id: "bs-chatbox"
  }, !isInConfigurationMode && !online ? /*#__PURE__*/_react["default"].createElement(NoConection, (0, _extends2["default"])({}, props, {
    isInConfigurationMode: isInConfigurationMode,
    demoData: demoData,
    isMobileMode: isMobileMode
  })) : /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      width: '100%',
      height: '100%'
    }
  }, activeTheme === 'style-one' && /*#__PURE__*/_react["default"].createElement(_react.Suspense, {
    fallback: /*#__PURE__*/_react["default"].createElement("div", null)
  }, /*#__PURE__*/_react["default"].createElement(LayoutStyleOne, (0, _extends2["default"])({}, props, {
    lastTimeAcceptChattingWithBot: lastTimeAcceptChattingWithBot,
    lastTimeAcceptLeavingOfflineMessage: lastTimeAcceptLeavingOfflineMessage,
    lastTimeReceivingMessageFromAdmin: lastTimeReceivingMessageFromAdmin,
    isStartConversationFromAdmin: isStartConversationFromAdmin,
    alreadySubmitUserInfo: alreadySubmitUserInfo,
    messages: messages,
    participants: participants,
    isInConfigurationMode: isInConfigurationMode,
    demoData: demoData,
    isEnableAutomation: isEnableAutomation,
    isInOperatingHours: isInOperatingHours
  }))), activeTheme === 'style-two' && /*#__PURE__*/_react["default"].createElement(_react.Suspense, {
    fallback: /*#__PURE__*/_react["default"].createElement("div", null)
  }, /*#__PURE__*/_react["default"].createElement(LayoutStyleTwo, (0, _extends2["default"])({}, props, {
    lastTimeAcceptChattingWithBot: lastTimeAcceptChattingWithBot,
    lastTimeAcceptLeavingOfflineMessage: lastTimeAcceptLeavingOfflineMessage,
    lastTimeReceivingMessageFromAdmin: lastTimeReceivingMessageFromAdmin,
    isStartConversationFromAdmin: isStartConversationFromAdmin,
    alreadySubmitUserInfo: alreadySubmitUserInfo,
    alreadyStartConversation: alreadyStartConversation,
    messages: messages,
    participants: participants,
    isInConfigurationMode: isInConfigurationMode,
    demoData: demoData,
    isEnableAutomation: isEnableAutomation,
    isInOperatingHours: isInOperatingHours
  }))), activeTheme === 'style-three' && /*#__PURE__*/_react["default"].createElement(_react.Suspense, {
    fallback: /*#__PURE__*/_react["default"].createElement("div", null)
  }, /*#__PURE__*/_react["default"].createElement(LayoutStyleThree, (0, _extends2["default"])({}, props, {
    lastTimeAcceptChattingWithBot: lastTimeAcceptChattingWithBot,
    lastTimeAcceptLeavingOfflineMessage: lastTimeAcceptLeavingOfflineMessage,
    lastTimeReceivingMessageFromAdmin: lastTimeReceivingMessageFromAdmin,
    isStartConversationFromAdmin: isStartConversationFromAdmin,
    alreadySubmitUserInfo: alreadySubmitUserInfo,
    alreadyStartConversation: alreadyStartConversation,
    hasTriggeredWelcomeMessage: hasTriggeredWelcomeMessage,
    messages: messages,
    participants: participants,
    isInConfigurationMode: isInConfigurationMode,
    demoData: demoData,
    isEnableAutomation: isEnableAutomation,
    isInOperatingHours: isInOperatingHours
  })))));
};

exports["default"] = _default;
module.exports = exports.default;