"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _size2 = _interopRequireDefault(require("lodash/size"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _message = require("../../../store/actions/message.actions");

var _styleOne = _interopRequireDefault(require("./style-one"));

var _styleTwo = _interopRequireDefault(require("./style-two"));

var _styleThree = _interopRequireDefault(require("./style-three"));

var _checkValidFile = _interopRequireDefault(require("./utils/check-valid-file"));

var _isImageFile = _interopRequireDefault(require("./utils/is-image-file"));

var _getBase = _interopRequireDefault(require("./utils/get-base64"));

var _getFileMetaData = _interopRequireDefault(require("./utils/get-file-meta-data"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var MAX_COUNT_FILE = 3;

var BSChatBoxInput = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(BSChatBoxInput, _Component);

  function BSChatBoxInput() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      inputValue: '',
      uploadFiles: []
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "checkInputValueAndSend", function () {
      var _this$state = _this.state,
          inputValue = _this$state.inputValue,
          uploadFiles = _this$state.uploadFiles;
      var setting = _this.props.setting;
      var trimValue = (inputValue || '').trim();
      if ((0, _isEmpty2["default"])(trimValue) && (0, _isEmpty2["default"])(uploadFiles)) return;

      if (!(0, _isEmpty2["default"])(uploadFiles)) {
        _this.props.actions.sendAttachment(inputValue.trim(), uploadFiles, setting.channelId);

        _this.setState({
          inputValue: '',
          uploadFiles: []
        });

        return;
      }

      if (!(0, _isEmpty2["default"])(inputValue)) {
        _this.props.actions.sendTextMessage(inputValue.trim(), setting.channelId);

        _this.setState({
          inputValue: ''
        });

        return;
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleKeyPress", function (event) {
      // console.log(`handleKeyPress ${event.key} - ${event.shiftKey}`);
      if (event.key === 'Enter' && !event.shiftKey) {
        _this.checkInputValueAndSend();

        event.preventDefault();
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOnChange", function (event) {
      _this.setState({
        inputValue: event.target.value
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClickBtnSend", function () {
      _this.checkInputValueAndSend();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleBeforeUploadAttachments", function (file) {
      var uploadFiles = _this.state.uploadFiles; // console.log("file", file);

      if (!(0, _checkValidFile["default"])(file) || (0, _size2["default"])(uploadFiles) >= MAX_COUNT_FILE) {
        window && window.alert('Max 3 files, max size 1MB');
        return false;
      }

      var isImage = (0, _isImageFile["default"])(file);
      var newAttachment = (0, _extends2["default"])({
        originalFile: file
      }, (0, _getFileMetaData["default"])(file), {
        isImage: isImage
      });
      isImage ? (0, _getBase["default"])(file, function (base64) {
        _this.setState({
          uploadFiles: [].concat(uploadFiles, [(0, _extends2["default"])({}, newAttachment, {
            base64: base64
          })])
        });
      }) : _this.setState({
        uploadFiles: [].concat(uploadFiles, [newAttachment])
      });
      return false;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleRemoveAttachment", function (attachment) {
      _this.setState({
        uploadFiles: _this.state.uploadFiles.filter(function (obj) {
          return obj !== attachment;
        })
      });
    });
    return _this;
  }

  var _proto = BSChatBoxInput.prototype;

  _proto.render = function render() {
    var callbacks = {
      handleKeyPress: this.handleKeyPress.bind(this),
      handleOnChange: this.handleOnChange.bind(this),
      handleClickBtnSend: this.handleClickBtnSend.bind(this),
      handleRemoveAttachment: this.handleRemoveAttachment.bind(this),
      handleBeforeUploadAttachments: this.handleBeforeUploadAttachments.bind(this)
    };
    var setting = this.props.setting;
    var activeTheme = (0, _get2["default"])(setting, 'activeTheme'); // console.log("checkporps", this.props);

    return /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        height: '80px',
        flexGrow: '0'
      }
    }, activeTheme === 'style-two' && /*#__PURE__*/_react["default"].createElement(_styleTwo["default"], (0, _extends2["default"])({}, this.props, {
      attachments: this.state.attachments
    }, callbacks, {
      uploadFiles: this.state.uploadFiles,
      inputValue: this.state.inputValue
    })), activeTheme === 'style-one' && /*#__PURE__*/_react["default"].createElement(_styleOne["default"], (0, _extends2["default"])({}, this.props, {
      attachments: this.state.attachments
    }, callbacks, {
      uploadFiles: this.state.uploadFiles,
      inputValue: this.state.inputValue
    })), activeTheme === 'style-three' && /*#__PURE__*/_react["default"].createElement(_styleThree["default"], (0, _extends2["default"])({}, this.props, {
      attachments: this.state.attachments
    }, callbacks, {
      uploadFiles: this.state.uploadFiles,
      inputValue: this.state.inputValue
    })));
  };

  return BSChatBoxInput;
}(_react.Component);

var _default = (0, _reactRedux.connect)(function (store) {
  return {};
}, function (dispatch) {
  return {
    actions: (0, _redux.bindActionCreators)({
      sendTextMessage: _message.sendTextMessage,
      sendAttachment: _message.sendAttachment
    }, dispatch)
  };
})(BSChatBoxInput);

exports["default"] = _default;
module.exports = exports.default;