"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _last2 = _interopRequireDefault(require("lodash/last"));

var _throttle2 = _interopRequireDefault(require("lodash/throttle"));

var _delay2 = _interopRequireDefault(require("lodash/delay"));

var _size2 = _interopRequireDefault(require("lodash/size"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireDefault(require("react"));

var _chatMessageContainer = _interopRequireDefault(require("chat-message-container"));

var _reactSound = _interopRequireDefault(require("react-sound"));

var sound = _interopRequireWildcard(require("../../sounds/sound"));

var _actions = require("../../../store/actions");

var _reactRedux = require("react-redux");

var _redux = require("redux");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var MessageContainer = _chatMessageContainer["default"].MessageContainer;

var ChatMessageContainer = /*#__PURE__*/function (_React$Component) {
  (0, _inheritsLoose2["default"])(ChatMessageContainer, _React$Component);

  function ChatMessageContainer(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "scrollToBottom", function () {
      if (_this.refs.chatMessageContainer) {
        (0, _delay2["default"])(function () {
          _this.refs.chatMessageContainer && _this.refs.chatMessageContainer.scrollToBottom();
          (0, _delay2["default"])(function () {
            _this.props.actions.onScrollToBottom();
          }, 500);
        }, 500);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isScrollingOnBottom", function () {
      if (_this.refs.chatMessageContainer) {
        return _this.refs.chatMessageContainer.isAtBottom();
      }

      return false;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSoundStartFinishedPlaying", function (value) {
      _this.setState({
        playSoundForNewMessage: value
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "loadMoreMessages", function () {
      var _this$props = _this.props,
          isLoadingMessage = _this$props.isLoadingMessage,
          setting = _this$props.setting;
      if (isLoadingMessage) return;

      _this.throttledLoadMessageHistory(setting.channelId);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "isScrollingOnTop", function () {
      if (_this.refs.chatMessageContainer) {
        var _this$refs$chatMessag = _this.refs.chatMessageContainer.scrollbarRef.getValues(),
            top = _this$refs$chatMessag.top;

        if (top === 0) {
          return true;
        }
      }

      return false;
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "scrollToPositionBeforeLoadMore", function () {
      var messageContainerHeight = _this.state.messageContainerHeight;

      if (_this.refs.chatMessageContainer) {
        var currentHeight = _this.refs.chatMessageContainer.scrollbarRef.getScrollHeight();

        (0, _delay2["default"])(function () {
          var scrollTopValue = currentHeight - messageContainerHeight;

          _this.refs.chatMessageContainer.scrollbarRef.scrollTop(scrollTopValue);
        }, 100);
      }
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "updateMessageContainerHeight", function () {
      _this.setState({
        messageContainerHeight: _this.refs.chatMessageContainer.scrollbarRef.getScrollHeight()
      });
    });
    _this.state = {
      playSoundForNewMessage: false,
      originalMessage: null,
      hasInteracted: false // mouse move, click, tab

    };
    _this.throttledLoadMessageHistory = (0, _throttle2["default"])(function (channelId) {
      _this.props.actions.getMessages(true, channelId);
    }, 500, {
      trailing: false
    });
    _this.throttledPlaySound = (0, _throttle2["default"])(function (value) {
      _this.handleSoundStartFinishedPlaying(value);
    }, 2000, {
      trailing: false
    });
    return _this;
  }

  var _proto = ChatMessageContainer.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    //Scroll to bottom when F5 page
    window.addEventListener('click', function () {
      _this2.setState({
        hasInteracted: true
      });
    }, {
      once: true
    });
    window.addEventListener('touchstart', function () {
      _this2.setState({
        hasInteracted: true
      });
    }, {
      once: true
    });
    this.scrollToBottom();
  };

  ChatMessageContainer.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
    if (nextProps.messages && nextProps.messages !== prevState.originalMessage) {
      return {
        originalMessage: nextProps.messages
      };
    } else {
      return null;
    }
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    var sender = (0, _get2["default"])((0, _last2["default"])(this.state.originalMessage), 'senderId');

    if (prevState.originalMessage !== this.state.originalMessage) {
      if ((0, _size2["default"])(this.state.originalMessage) - (0, _size2["default"])(prevState.originalMessage) === 1) {
        if (sender === 'subscriber') {
          this.scrollToBottom();
        } else {
          //playsoud when receiving new message
          if (this.state.hasInteracted && this.props.soundOn && this.props.numberOfNewMessages !== 0) {
            this.throttledPlaySound(true);
          } //is at bottom


          if (this.isScrollingOnBottom()) {
            this.scrollToBottom();
          }
        }
      } //loadmore message


      if ((0, _size2["default"])(prevState.originalMessage) !== 0 && (0, _size2["default"])(prevState.originalMessage) < (0, _size2["default"])(this.state.originalMessage) && this.isScrollingOnTop()) {
        this.scrollToPositionBeforeLoadMore();
      } //update scroll height


      this.updateMessageContainerHeight();
    }
  };

  _proto.render = function render() {
    var _this3 = this;

    var _this$props2 = this.props,
        containerBgColor = _this$props2.containerBgColor,
        isShowLeftAvatar = _this$props2.isShowLeftAvatar,
        isShowRightAvatar = _this$props2.isShowRightAvatar,
        isShowSeenTime = _this$props2.isShowSeenTime,
        avatarWidth = _this$props2.avatarWidth,
        avatarMargin = _this$props2.avatarMargin,
        style = _this$props2.style,
        textFontSize = _this$props2.textFontSize,
        messageMargin = _this$props2.messageMargin,
        onClickButton = _this$props2.onClickButton,
        leftParitcipantsTextColor = _this$props2.leftParitcipantsTextColor,
        leftParitcipantsTextBgColor = _this$props2.leftParitcipantsTextBgColor,
        rightParitcipantsTextColor = _this$props2.rightParitcipantsTextColor,
        rightParitcipantsTextBgColor = _this$props2.rightParitcipantsTextBgColor,
        messages = _this$props2.messages,
        participants = _this$props2.participants;
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, this.state.playSoundForNewMessage && /*#__PURE__*/_react["default"].createElement(_reactSound["default"], {
      url: sound.SOUND_NEW_MESSAGE,
      playStatus: _reactSound["default"].status.PLAYING,
      onFinishedPlaying: function onFinishedPlaying() {
        return _this3.handleSoundStartFinishedPlaying(false);
      }
    }), /*#__PURE__*/_react["default"].createElement(MessageContainer, {
      containerBgColor: containerBgColor,
      isShowLeftAvatar: isShowLeftAvatar,
      isShowRightAvatar: isShowRightAvatar,
      isShowSeenTime: isShowSeenTime,
      avatarWidth: avatarWidth,
      avatarMargin: avatarMargin,
      style: style,
      textFontSize: textFontSize,
      messageMargin: messageMargin,
      onScrollTop: function onScrollTop() {
        return _this3.loadMoreMessages();
      },
      onScrollBottom: function onScrollBottom() {
        return _this3.scrollToBottom();
      },
      onClickButton: onClickButton,
      leftParitcipantsTextColor: leftParitcipantsTextColor,
      leftParitcipantsTextBgColor: leftParitcipantsTextBgColor,
      rightParitcipantsTextColor: rightParitcipantsTextColor,
      rightParitcipantsTextBgColor: rightParitcipantsTextBgColor,
      messages: messages,
      participants: participants,
      noMessageText: "No messages",
      isChatbox: true,
      ref: "chatMessageContainer"
    }));
  };

  return ChatMessageContainer;
}(_react["default"].Component);

var _default = (0, _reactRedux.connect)(function (store) {
  return {
    numberOfNewMessages: (0, _get2["default"])(store, 'messages.numberOfNewMessages')
  };
}, function (dispatch) {
  return {
    actions: (0, _redux.bindActionCreators)({
      getMessages: _actions.getMessages,
      onScrollToBottom: _actions.onScrollToBottom
    }, dispatch)
  };
})(ChatMessageContainer);

exports["default"] = _default;
module.exports = exports.default;