"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _react = _interopRequireWildcard(require("react"));

var _commonStyles = _interopRequireDefault(require("../../common-styles.scss"));

var _utils = require("../../../../commons/utils");

var _reactRedux = require("react-redux");

var _actions = require("../../../../store/actions");

var _widgetContext = _interopRequireDefault(require("../../../../widget-context"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var UserInfoForm = (0, _react.lazy)(function () {
  return Promise.resolve().then(function () {
    return _interopRequireWildcard(require('../../user-info-form'));
  });
});
var Header = (0, _react.lazy)(function () {
  return Promise.resolve().then(function () {
    return _interopRequireWildcard(require('../../header'));
  });
});
var Power = (0, _react.lazy)(function () {
  return Promise.resolve().then(function () {
    return _interopRequireWildcard(require('../../power'));
  });
});
var ChatBoxInput = (0, _react.lazy)(function () {
  return Promise.resolve().then(function () {
    return _interopRequireWildcard(require('../../input'));
  });
});
var OfflineStatus = (0, _react.lazy)(function () {
  return Promise.resolve().then(function () {
    return _interopRequireWildcard(require('../../offline'));
  });
});
var ChatMessageContainer = (0, _react.lazy)(function () {
  return Promise.resolve().then(function () {
    return _interopRequireWildcard(require('../message-container'));
  });
});
var NoConect = (0, _react.lazy)(function () {
  return Promise.resolve().then(function () {
    return _interopRequireWildcard(require('../../no-connection'));
  });
});

var _default = function _default(props) {
  var isInConfigurationMode = props.isInConfigurationMode,
      isMobileMode = props.isMobileMode,
      setting = props.setting,
      messages = props.messages,
      participants = props.participants,
      demoData = props.demoData;
  var dispatch = (0, _reactRedux.useDispatch)();

  var _useContext = (0, _react.useContext)(_widgetContext["default"]),
      isSimulator = _useContext.isSimulator;

  var showedScreen = isSimulator ? 'conversation' : (0, _utils.getCurrentScreen)(props);
  var soundOn = isSimulator ? false : (0, _reactRedux.useSelector)(function (store) {
    return (0, _get2["default"])(store, 'behavior.soundOn');
  });
  var isViewForOffline = showedScreen === 'off' || showedScreen === 'off_with_chatbot';
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _commonStyles["default"].conversationContainer,
    style: {
      padding: isMobileMode ? 0 : "10px"
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _commonStyles["default"].container
  }, isViewForOffline && /*#__PURE__*/_react["default"].createElement(_react.Suspense, {
    fallback: /*#__PURE__*/_react["default"].createElement("div", null)
  }, /*#__PURE__*/_react["default"].createElement(OfflineStatus, {
    setting: setting,
    isInConfigurationMode: isInConfigurationMode,
    showedScreen: showedScreen
  })), !isViewForOffline && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, !isSimulator && !(0, _includes2["default"])(['off', 'no_connection'], showedScreen) && /*#__PURE__*/_react["default"].createElement(_react.Suspense, {
    fallback: /*#__PURE__*/_react["default"].createElement("div", null)
  }, /*#__PURE__*/_react["default"].createElement(Header, {
    setting: setting,
    isInConfigurationMode: isInConfigurationMode,
    demoData: demoData,
    currentScreen: showedScreen
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: _commonStyles["default"].boxBody
  }, showedScreen === 'form' && /*#__PURE__*/_react["default"].createElement(_react.Suspense, {
    fallback: /*#__PURE__*/_react["default"].createElement("div", null)
  }, /*#__PURE__*/_react["default"].createElement(UserInfoForm, {
    setting: setting,
    isInConfigurationMode: isInConfigurationMode
  })), showedScreen === 'conversation' && /*#__PURE__*/_react["default"].createElement("div", {
    className: _commonStyles["default"].messageContainer
  }, /*#__PURE__*/_react["default"].createElement(_react.Suspense, {
    fallback: /*#__PURE__*/_react["default"].createElement("div", null)
  }, /*#__PURE__*/_react["default"].createElement(ChatMessageContainer, {
    containerBgColor: "white",
    isShowLeftAvatar: true,
    isShowRightAvatar: false,
    isShowSeenTime: false,
    avatarWidth: 25,
    avatarMargin: 0,
    style: 1,
    textFontSize: 12,
    messageMargin: 25,
    onScrollTop: function onScrollTop() {},
    onClickButton: function onClickButton(buttonData) {
      return dispatch((0, _actions.sendButtonMessage)(buttonData, setting.channelId));
    },
    leftParitcipantsTextColor: (0, _get2["default"])(setting, 'screenConversation.leftSideTextColor'),
    leftParitcipantsTextBgColor: (0, _get2["default"])(setting, 'screenConversation.leftSideBackgroundColor'),
    rightParitcipantsTextColor: (0, _get2["default"])(setting, 'screenConversation.rightSideTextColor'),
    rightParitcipantsTextBgColor: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor'),
    messages: isInConfigurationMode ? demoData.messages : messages,
    participants: isInConfigurationMode ? demoData.participants : participants,
    soundOn: soundOn,
    setting: setting
  }))), showedScreen === 'conversation' && /*#__PURE__*/_react["default"].createElement(_react.Suspense, {
    fallback: /*#__PURE__*/_react["default"].createElement("div", null)
  }, /*#__PURE__*/_react["default"].createElement(ChatBoxInput, {
    setting: setting,
    isInConfigurationMode: isInConfigurationMode
  })), showedScreen === 'no_connection' && /*#__PURE__*/_react["default"].createElement(_react.Suspense, {
    fallback: /*#__PURE__*/_react["default"].createElement("div", null)
  }, /*#__PURE__*/_react["default"].createElement(NoConect, {
    setting: setting,
    isInConfigurationMode: isInConfigurationMode,
    demoData: demoData,
    isMobileMode: isMobileMode
  })))), /*#__PURE__*/_react["default"].createElement(Power, {
    setting: setting,
    showedScreen: showedScreen
  })));
};

exports["default"] = _default;
module.exports = exports.default;