"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _react = _interopRequireWildcard(require("react"));

var _commonStyles = _interopRequireDefault(require("../../common-styles.scss"));

var _userInfoForm = _interopRequireDefault(require("../../user-info-form"));

var _header = _interopRequireDefault(require("../../header"));

var _power = _interopRequireDefault(require("../../power"));

var _input = _interopRequireDefault(require("../../input"));

var _utils = require("../../../../commons/utils");

var _offline = _interopRequireDefault(require("../../offline"));

var _reactRedux = require("react-redux");

var _actions = require("../../../../store/actions");

var _messageContainer = _interopRequireDefault(require("../message-container"));

var _widgetContext = _interopRequireDefault(require("../../../../widget-context"));

var _noConnection = _interopRequireDefault(require("../../no-connection"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _default = function _default(props) {
  var alreadyStartConversation = props.alreadyStartConversation,
      isInConfigurationMode = props.isInConfigurationMode,
      isMobileMode = props.isMobileMode,
      setting = props.setting,
      messages = props.messages,
      participants = props.participants,
      demoData = props.demoData;
  var dispatch = (0, _reactRedux.useDispatch)();

  var _useContext = (0, _react.useContext)(_widgetContext["default"]),
      isSimulator = _useContext.isSimulator;

  var showedScreen = isSimulator ? 'conversation' : (0, _utils.getCurrentScreen)(props);
  var soundOn = isSimulator ? false : (0, _reactRedux.useSelector)(function (store) {
    return (0, _get2["default"])(store, 'behavior.soundOn');
  });
  var isViewForOffline = showedScreen === 'off' || showedScreen === 'off_with_chatbot';
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _commonStyles["default"].conversationContainer,
    style: {
      borderRadius: "" + (isMobileMode ? '0' : '18px'),
      padding: isMobileMode ? 0 : '10px'
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _commonStyles["default"].container,
    style: {
      borderRadius: "" + (isMobileMode ? '0' : '18px')
    }
  }, isViewForOffline && /*#__PURE__*/_react["default"].createElement(_offline["default"], {
    setting: setting,
    showedScreen: showedScreen
  }), !isViewForOffline && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, !isSimulator && !(0, _includes2["default"])(['off', 'no_connection'], showedScreen) && /*#__PURE__*/_react["default"].createElement(_header["default"], {
    setting: setting,
    isInConfigurationMode: isInConfigurationMode,
    demoData: demoData,
    currentScreen: showedScreen,
    isMobileMode: isMobileMode
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: _commonStyles["default"].boxBody
  }, showedScreen === 'form' && /*#__PURE__*/_react["default"].createElement(_userInfoForm["default"], {
    setting: setting,
    isInConfigurationMode: isInConfigurationMode
  }), showedScreen === 'conversation' && /*#__PURE__*/_react["default"].createElement("div", {
    className: _commonStyles["default"].messageContainer
  }, /*#__PURE__*/_react["default"].createElement(_messageContainer["default"], {
    containerBgColor: "white",
    isShowLeftAvatar: false,
    isShowRightAvatar: false,
    isShowSeenTime: false,
    avatarWidth: 25,
    avatarMargin: 0,
    style: 2,
    textFontSize: 12,
    messageMargin: 25,
    onScrollTop: function onScrollTop() {},
    onClickButton: function onClickButton(buttonData) {
      return dispatch((0, _actions.sendButtonMessage)(buttonData, setting.channelId));
    },
    leftParitcipantsTextColor: (0, _get2["default"])(setting, 'screenConversation.leftSideTextColor'),
    leftParitcipantsTextBgColor: (0, _get2["default"])(setting, 'screenConversation.leftSideBackgroundColor'),
    rightParitcipantsTextColor: (0, _get2["default"])(setting, 'screenConversation.rightSideTextColor'),
    rightParitcipantsTextBgColor: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor'),
    messages: isInConfigurationMode ? demoData.messages : messages,
    participants: isInConfigurationMode ? demoData.participants : participants,
    soundOn: soundOn,
    setting: setting
  })), showedScreen === 'conversation' && /*#__PURE__*/_react["default"].createElement(_input["default"], {
    setting: setting,
    isInConfigurationMode: isInConfigurationMode
  }), showedScreen === 'no_connection' && /*#__PURE__*/_react["default"].createElement(_noConnection["default"], {
    setting: setting,
    isInConfigurationMode: isInConfigurationMode,
    demoData: demoData,
    isMobileMode: isMobileMode
  }))), /*#__PURE__*/_react["default"].createElement(_power["default"], {
    setting: setting,
    showedScreen: showedScreen,
    isInConfigurationMode: isInConfigurationMode
  })));
};

exports["default"] = _default;
module.exports = exports.default;