"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _header = _interopRequireDefault(require("../../header"));

var _power = _interopRequireDefault(require("../../power"));

var _commonStyles = _interopRequireDefault(require("../../common-styles.scss"));

var _no_connection = _interopRequireDefault(require("../../../icon/no_connection.svg"));

var _reactInlinesvg = _interopRequireDefault(require("react-inlinesvg"));

var _widgetContext = _interopRequireDefault(require("../../../../widget-context"));

var _commonHandlers = require("../common-handlers");

var _reload = _interopRequireDefault(require("../../../icon/reload.svg"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _default = function _default(props) {
  var setting = props.setting,
      isInConfigurationMode = props.isInConfigurationMode,
      demoData = props.demoData,
      showedScreen = props.showedScreen,
      isMobileMode = props.isMobileMode;

  var _useContext = (0, _react.useContext)(_widgetContext["default"]),
      isReconnecting = _useContext.isReconnecting,
      isConnectFailed = _useContext.isConnectFailed;

  var isShowReloadContent = !isReconnecting && isConnectFailed || isInConfigurationMode;
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _commonStyles["default"].noConnectionContainer,
    style: {
      borderRadius: isMobileMode ? '0' : '18px'
    }
  }, /*#__PURE__*/_react["default"].createElement(_header["default"], {
    setting: setting,
    isInConfigurationMode: isInConfigurationMode,
    demoData: demoData,
    currentScreen: showedScreen
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: _commonStyles["default"].boxBody
  }, /*#__PURE__*/_react["default"].createElement(_reactInlinesvg["default"], {
    className: _commonStyles["default"].image,
    src: _no_connection["default"]
  }), isReconnecting && !isConnectFailed && /*#__PURE__*/_react["default"].createElement("span", {
    className: _commonStyles["default"].wsStatus
  }, "Reconnecting..."), isShowReloadContent && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("span", {
    className: _commonStyles["default"].title
  }, (0, _get2["default"])(setting, 'chatboxThemeSettings.commonSettings.no_conect_title')), /*#__PURE__*/_react["default"].createElement("span", {
    className: _commonStyles["default"].subtitle
  }, (0, _get2["default"])(setting, 'chatboxThemeSettings.commonSettings.no_conect_subtitle')), /*#__PURE__*/_react["default"].createElement("span", {
    className: _commonStyles["default"].btnReload,
    onClick: _commonHandlers.clickReloadHandler,
    style: {
      color: (0, _get2["default"])(setting, 'screenConversation.rightSideTextColor'),
      backgroundColor: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor')
    }
  }, /*#__PURE__*/_react["default"].createElement(_reactInlinesvg["default"], {
    className: _commonStyles["default"].reloadIcon,
    src: _reload["default"]
  }), (0, _get2["default"])(setting, 'chatboxThemeSettings.commonSettings.no_conect_btn_reload_label') || 'Reload'))), /*#__PURE__*/_react["default"].createElement(_power["default"], {
    setting: setting,
    showedScreen: showedScreen
  }));
};

exports["default"] = _default;
module.exports = exports.default;