"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireDefault(require("react"));

var _offlineStatus = _interopRequireDefault(require("./offline-status.scss"));

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _actions = require("../../../store/actions");

var _icon = require("../../icon");

var _websocket = require("../../../commons/constants/websocket");

var _withoutAutomation = _interopRequireDefault(require("./components/without-automation"));

var _withAutomation = _interopRequireDefault(require("./components/with-automation"));

var OfflineStatus = /*#__PURE__*/function (_React$Component) {
  (0, _inheritsLoose2["default"])(OfflineStatus, _React$Component);

  function OfflineStatus() {
    var _this;

    _this = _React$Component.call(this) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onStartConversation", function (message) {});
    _this.state = {
      message: null
    };
    return _this;
  }

  var _proto = OfflineStatus.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        setting = _this$props.setting,
        showedScreen = _this$props.showedScreen;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: _offlineStatus["default"].container
    }, showedScreen === 'off' && /*#__PURE__*/_react["default"].createElement(_withoutAutomation["default"], {
      setting: setting,
      onStartConversation: function onStartConversation(message) {
        var isInConfigurationMode = _this2.props.isInConfigurationMode;
        if (isInConfigurationMode) return;

        _this2.props.actions.startConversation(_websocket.BUTTON_STARTS.LEAVE_MESSAGE, {
          isWorkingDay: setting.isInOperatingHours,
          leaveMessage: message
        });
      }
    }), showedScreen === 'off_with_chatbot' && /*#__PURE__*/_react["default"].createElement(_withAutomation["default"], {
      setting: setting,
      onStartConversation: function onStartConversation() {
        _this2.props.actions.startConversation(_websocket.BUTTON_STARTS.CHAT_WITH_BOT, {
          isWorkingDay: setting.isInOperatingHours
        });
      }
    }), /*#__PURE__*/_react["default"].createElement(_icon.CloseIcon, {
      className: _offlineStatus["default"].closeIcon,
      iconTextColor: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor')
    }));
  };

  return OfflineStatus;
}(_react["default"].Component);

var _default = (0, _reactRedux.connect)(function (store) {
  return {
    userInfo: (0, _get2["default"])(store, 'behavior.userInfo')
  };
}, function (dispatch) {
  return {
    actions: (0, _redux.bindActionCreators)({
      startConversation: _actions.startConversation
    }, dispatch)
  };
})(OfflineStatus);

exports["default"] = _default;
module.exports = exports.default;