"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _react = _interopRequireWildcard(require("react"));

var _userInfoForm = _interopRequireDefault(require("./user-info-form.scss"));

var _actions = require("../../../store/actions");

var _formInput = _interopRequireDefault(require("../../../commons/components/form-input"));

var _formCheckbox = _interopRequireDefault(require("../../../commons/components/form-checkbox"));

var _btnStartConversation = _interopRequireDefault(require("./btn-start-conversation"));

var _skipForm = _interopRequireDefault(require("../../icon/skip-form.svg"));

var _reactInlinesvg = _interopRequireDefault(require("react-inlinesvg"));

var _name = _interopRequireDefault(require("../../icon/name.svg"));

var _email = _interopRequireDefault(require("../../icon/email.svg"));

var _phone = _interopRequireDefault(require("../../icon/phone.svg"));

var _reactHookForm = require("react-hook-form");

var _reactRedux = require("react-redux");

var _websocket = require("../../../commons/constants/websocket");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _default = function _default(_ref) {
  var setting = _ref.setting;

  var _useState = (0, _react.useState)(null),
      name = _useState[0],
      setName = _useState[1];

  var _useState2 = (0, _react.useState)(null),
      email = _useState2[0],
      setEmail = _useState2[1];

  var _useState3 = (0, _react.useState)(null),
      phone = _useState3[0],
      setPhone = _useState3[1];

  var _useState4 = (0, _react.useState)(false),
      checkPrivacyPolicyConsent = _useState4[0],
      setCheckPrivacyPolicyConsent = _useState4[1];

  var _useForm = (0, _reactHookForm.useForm)(),
      handleSubmit = _useForm.handleSubmit;

  var _useState5 = (0, _react.useState)(false),
      isSubmit = _useState5[0],
      setSubmit = _useState5[1];

  var dispatch = (0, _reactRedux.useDispatch)();
  var activeTheme = (0, _get2["default"])(setting, 'activeTheme');
  var enableFieldName = (0, _get2["default"])(setting, 'chatboxThemeSettings.commonSettings.form_name_enable');
  var enableFieldEmail = (0, _get2["default"])(setting, 'chatboxThemeSettings.commonSettings.form_email_enable');
  var enableFieldPhone = (0, _get2["default"])(setting, 'chatboxThemeSettings.commonSettings.form_phone_enable');
  var enablePrivacyPolicyConsent = (0, _get2["default"])(setting, 'chatboxThemeSettings.preChatForm.privacy_consent_enable') === true;
  var privacyPolicyMessage = (0, _get2["default"])(setting, 'chatboxThemeSettings.preChatForm.privacy_consent_message');
  var privacyPolicyLink = (0, _get2["default"])(setting, 'chatboxThemeSettings.preChatForm.privacy_consent_link');
  var requiredFieldName = (0, _get2["default"])(setting, 'chatboxThemeSettings.commonSettings.form_name_require');
  var requiredFieldEmail = (0, _get2["default"])(setting, 'chatboxThemeSettings.commonSettings.form_email_require');
  var requiredFieldPhone = (0, _get2["default"])(setting, 'chatboxThemeSettings.commonSettings.form_phone_require');
  var isInOperatingHours = (0, _get2["default"])(setting, 'isInOperatingHours');
  var canSkip = !requiredFieldName && !requiredFieldPhone && !requiredFieldEmail;

  var onSubmit = function onSubmit() {
    var validateName = enableFieldName && requiredFieldName && (0, _isEmpty2["default"])(name) ? false : true;
    var validateEmail = enableFieldEmail && requiredFieldEmail && (0, _isEmpty2["default"])(email) ? false : true;
    var validatePhone = enableFieldPhone && requiredFieldPhone && (0, _isEmpty2["default"])(phone) ? false : true;
    setSubmit(true);
    if (enablePrivacyPolicyConsent && !checkPrivacyPolicyConsent) return;

    if (!(0, _includes2["default"])([validateName, validatePhone, validateEmail], false)) {
      dispatch((0, _actions.startConversation)(_websocket.BUTTON_STARTS.START_CONVERSATION, {
        name: name,
        email: email,
        phone: phone,
        isWorkingDay: setting.isInOperatingHours
      }));
      return;
    }

    if (canSkip) {
      dispatch((0, _actions.startConversation)(_websocket.BUTTON_STARTS.START_CONVERSATION, {
        name: name,
        email: email,
        phone: phone,
        isWorkingDay: setting.isInOperatingHours
      }));
    }
  };

  var getInputTextColor = function getInputTextColor(setting) {
    var activeTheme = (0, _get2["default"])(setting, 'activeTheme');

    if (activeTheme === 'style-one') {
      return (0, _get2["default"])(setting, 'screenForm.inputTextColor');
    } else if (activeTheme === 'style-two') {
      return (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor');
    } else {
      return (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor');
    }
  }; // console.log('check: ', checkPrivacyPolicyConsent)


  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _userInfoForm["default"].userInfoFormContainer + " bs-chat-box-form"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _userInfoForm["default"].form
  }, /*#__PURE__*/_react["default"].createElement("form", {
    onSubmit: handleSubmit(onSubmit),
    className: _userInfoForm["default"].userForm
  }, /*#__PURE__*/_react["default"].createElement("div", null, enableFieldName && /*#__PURE__*/_react["default"].createElement(_formInput["default"], {
    style: activeTheme,
    backgroundColor: (0, _get2["default"])(setting, 'screenForm.inputBackgroundColor'),
    isRequired: requiredFieldName,
    textColor: getInputTextColor(setting),
    icon: /*#__PURE__*/_react["default"].createElement(_reactInlinesvg["default"], {
      src: _name["default"],
      style: {
        width: '12px',
        height: '12px'
      }
    }),
    placeholder: (0, _get2["default"])(setting, 'chatboxThemeSettings.commonSettings.form_name_placeholder'),
    onChange: function onChange(e) {
      return setName(e.target.value);
    },
    isValid: isSubmit ? (0, _isEmpty2["default"])(name) : undefined,
    inputValue: name,
    placeholderColor: (0, _get2["default"])(setting, 'screenForm.placeholderTextColor')
  })), /*#__PURE__*/_react["default"].createElement("div", null, enableFieldEmail && /*#__PURE__*/_react["default"].createElement(_formInput["default"], {
    style: activeTheme,
    backgroundColor: (0, _get2["default"])(setting, 'screenForm.inputBackgroundColor'),
    isRequired: requiredFieldEmail,
    textColor: getInputTextColor(setting),
    icon: /*#__PURE__*/_react["default"].createElement(_reactInlinesvg["default"], {
      src: _email["default"],
      style: {
        width: '16px',
        height: '11px'
      }
    }),
    placeholder: (0, _get2["default"])(setting, 'chatboxThemeSettings.commonSettings.form_email_placeholder'),
    onChange: function onChange(e) {
      return setEmail(e.target.value);
    },
    isValid: isSubmit ? (0, _isEmpty2["default"])(email) : undefined,
    inputValue: email,
    placeholderColor: (0, _get2["default"])(setting, 'screenForm.placeholderTextColor')
  })), /*#__PURE__*/_react["default"].createElement("div", null, enableFieldPhone && /*#__PURE__*/_react["default"].createElement(_formInput["default"], {
    style: activeTheme,
    backgroundColor: (0, _get2["default"])(setting, 'screenForm.inputBackgroundColor'),
    isRequired: requiredFieldPhone,
    textColor: getInputTextColor(setting),
    icon: /*#__PURE__*/_react["default"].createElement(_reactInlinesvg["default"], {
      style: {
        width: '16.8px',
        height: '16.8px'
      },
      src: _phone["default"]
    }),
    placeholder: (0, _get2["default"])(setting, 'chatboxThemeSettings.commonSettings.form_phone_placeholder'),
    onChange: function onChange(e) {
      return setPhone(e.target.value);
    },
    isValid: isSubmit ? (0, _isEmpty2["default"])(phone) : undefined,
    inputValue: phone,
    placeholderColor: (0, _get2["default"])(setting, 'screenForm.placeholderTextColor')
  })), /*#__PURE__*/_react["default"].createElement("div", null, enablePrivacyPolicyConsent && /*#__PURE__*/_react["default"].createElement(_formCheckbox["default"], {
    color: isSubmit && !checkPrivacyPolicyConsent ? 'red' : (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor'),
    label: privacyPolicyMessage,
    link: privacyPolicyLink,
    checked: checkPrivacyPolicyConsent,
    onChange: function onChange(checked) {
      return setCheckPrivacyPolicyConsent(checked);
    }
  })), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_btnStartConversation["default"], {
    setting: setting
  })), /*#__PURE__*/_react["default"].createElement("div", null, canSkip && /*#__PURE__*/_react["default"].createElement("div", {
    onClick: onSubmit,
    className: _userInfoForm["default"].skipWrapper,
    style: {
      color: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor')
    }
  }, /*#__PURE__*/_react["default"].createElement("span", null, (0, _get2["default"])(setting, 'chatboxThemeSettings.commonSettings.skip_button_label')), /*#__PURE__*/_react["default"].createElement("span", null, /*#__PURE__*/_react["default"].createElement(_reactInlinesvg["default"], {
    src: _skipForm["default"],
    style: {
      width: '7.5px',
      height: '4.8px',
      marginLeft: '3.8px'
    }
  })))))));
};

exports["default"] = _default;
module.exports = exports.default;