"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _reactFrameComponent = _interopRequireDefault(require("react-frame-component"));

var _linkedin = _interopRequireDefault(require("../icon/linkedin.svg"));

var _widgetIcon = _interopRequireDefault(require("../../commons/components/widget-icon"));

var _tooltip = _interopRequireDefault(require("../tooltip"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Linkedin = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(Linkedin, _Component);

  function Linkedin(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      isHover: false
    };
    return _this;
  }

  var _proto = Linkedin.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        iframeStyles = _this$props.iframeStyles,
        position = _this$props.position,
        setting = _this$props.setting,
        svgSize = _this$props.svgSize,
        component = _this$props.component;
    var iconBackgroundColor = setting.iconBackgroundColor,
        iconTextColor = setting.iconTextColor;
    var iconSize = (0, _get2["default"])(setting, "iconSize");
    var link = (0, _get2["default"])(component, "configurationData.link");
    return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_reactFrameComponent["default"], {
      initialContent: "<!DOCTYPE html><html><head>" + iframeStyles + "</head><body></body></html>",
      mountTarget: "body",
      style: {
        width: iconSize,
        height: iconSize,
        position: "absolute",
        bottom: position.bottom + "px",
        right: position.right + "px",
        transition: "opacity 0.8s",
        zIndex: "9999997",
        maxWidth: iconSize,
        minWidth: iconSize,
        minHeight: iconSize,
        maxHeight: iconSize
      },
      allowtransparency: "yes",
      frameBorder: "0"
    }, /*#__PURE__*/_react["default"].createElement(_widgetIcon["default"], {
      iconBackgroundColor: iconBackgroundColor,
      iconSize: iconSize,
      iconSrc: _linkedin["default"],
      iconTextColor: iconTextColor,
      svgSize: svgSize,
      onClick: function onClick() {
        link && window.open(link, "_blank");
      },
      handleHover: function handleHover(e) {
        return _this2.setState(e);
      }
    })), this.state.isHover && /*#__PURE__*/_react["default"].createElement(_tooltip["default"], (0, _extends2["default"])({}, this.props, this.state)));
  };

  return Linkedin;
}(_react.Component);

exports["default"] = Linkedin;
module.exports = exports.default;