"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _throttle2 = _interopRequireDefault(require("lodash/throttle"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _reactFrameComponent = _interopRequireDefault(require("react-frame-component"));

var _actions = require("../../store/actions");

var _liveChat = _interopRequireDefault(require("../icon/live-chat.svg"));

var _widgetIcon = _interopRequireDefault(require("../../commons/components/widget-icon"));

var _tooltip = _interopRequireDefault(require("../tooltip"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _default = function _default(_ref) {
  var numberOfNewMessages = _ref.numberOfNewMessages,
      props = _ref.props;
  var iframeStyles = props.iframeStyles,
      position = props.position,
      setting = props.setting,
      svgSize = props.svgSize;

  var _useState = (0, _react.useState)(false),
      isHover = _useState[0],
      setIsHover = _useState[1];

  var iconBackgroundColor = setting.iconBackgroundColor,
      iconTextColor = setting.iconTextColor;
  var iconSize = (0, _get2["default"])(setting, 'iconSize');
  var dispatch = (0, _reactRedux.useDispatch)();
  var throttleOnClickIcon = (0, _react.useCallback)((0, _throttle2["default"])(function () {
    dispatch((0, _actions.toggleChat)(setting));
  }, 300, {
    trailing: false
  }), []);
  return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_reactFrameComponent["default"], {
    initialContent: "<!DOCTYPE html><html><head>" + iframeStyles + "</head><body></body></html>",
    mountTarget: "body",
    style: {
      width: iconSize,
      height: iconSize,
      position: 'absolute',
      bottom: position.bottom + "px",
      right: position.right + "px",
      transition: "opacity 0.8s",
      zIndex: '9999997',
      maxWidth: iconSize,
      minWidth: iconSize,
      minHeight: iconSize,
      maxHeight: iconSize
    },
    allowtransparency: "yes",
    frameBorder: "0"
  }, /*#__PURE__*/_react["default"].createElement(_widgetIcon["default"], {
    iconBackgroundColor: iconBackgroundColor,
    iconSize: iconSize,
    iconSrc: _liveChat["default"],
    iconTextColor: iconTextColor,
    svgSize: svgSize,
    onClick: throttleOnClickIcon,
    numberOfNewMessages: numberOfNewMessages,
    handleHover: function handleHover(e) {
      return setIsHover(e.isHover);
    }
  })), isHover && /*#__PURE__*/_react["default"].createElement(_tooltip["default"], (0, _extends2["default"])({}, props, {
    type: "chat"
  })));
};

exports["default"] = _default;
module.exports = exports.default;