"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _styles = _interopRequireDefault(require("./styles.scss"));

var _webrtc = _interopRequireDefault(require("../../webrtc"));

var hark = _interopRequireWildcard(require("hark"));

var _icon = require("../../../icon");

var _power = _interopRequireDefault(require("../power"));

var _reactInlinesvg = _interopRequireDefault(require("react-inlinesvg"));

var _endCall = _interopRequireDefault(require("../../../icon/end-call.svg"));

var _calling = _interopRequireDefault(require("../../../icon/calling.svg"));

var _avatar = _interopRequireDefault(require("../../../../commons/components/avatar"));

var _countTime = _interopRequireDefault(require("../../../../commons/components/count-time"));

var _websocket = require("../../../../connections/websocket");

var _websocket2 = require("../../../../commons/constants/websocket");

var _tenantInfo = require("../../../../commons/tenant-info");

var _constants = require("../../constants");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// https://medium.com/@BoltAssaults/autoplay-muted-html5-video-safari-ios-10-in-react-673ae50ba1f5
var isSafari = function isSafari() {
  var ua = navigator.userAgent.toLowerCase();
  return ua.indexOf('safari') > -1 && ua.indexOf('chrome') < 0;
};

var PageCalling = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(PageCalling, _Component);

  function PageCalling(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      remoteStream: undefined,
      second: 0,
      minute: 0
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onClickStop", function () {
      var handleStopCall = _this.props.handleStopCall;
      handleStopCall && handleStopCall(_constants.CALL_STOP_REASON.SUBSCRIBER_STOP);
      clearInterval(_this.interval);
      clearInterval(_this.intervalSendInCallSignal);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleUpdateRemotePeerConnection", function () {
      var callInfo = _this.props.callInfo;
      var remotePeerConnectionInfo = (0, _get2["default"])(callInfo, 'callData.adminPeerConnectionInfo'); // console.log("configure WebRTC connection", remotePeerConnectionInfo);

      _webrtc["default"].updateRemotePeerConnection(remotePeerConnectionInfo);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleGotGotRemoteStreamHandler", function () {
      _webrtc["default"].onGotRemoteStreamHandler(function (remoteStream) {
        // console.log("webRTC.onGotRemoteStreamHandler: ", remoteStream);
        var adminSpeechEvents = hark(remoteStream, {});
        adminSpeechEvents.on('speaking', function () {
          console.log('AdminTalking');
        });

        _this.setState({
          remoteStream: remoteStream
        }); // adminSpeechEvents.on("stopped_speaking", () => {});
        // const localStream = webRTC.getLocalStream();
        // const localSpeechEvents = hark(localStream, {});
        // localSpeechEvents.on("speaking", () => {
        //   console.log("YouTalking");
        // });
        // localSpeechEvents.on("stopped_speaking", () => {});

      });
    });
    _this.audioParentRef = _react["default"].createRef();
    return _this;
  }

  var _proto = PageCalling.prototype;

  _proto.updateRemoteAudioStream = function updateRemoteAudioStream() {
    // console.log("updateRemoteAudioStream");
    var audio = this.audioParentRef.current.children[0];

    if (audio && this.state.remoteStream && audio.srcObject !== this.state.remoteStream) {
      // console.log("setup audio: ", audio);
      if ('srcObject' in audio) {
        // console.log("set audio.srcObject");
        audio.srcObject = this.state.remoteStream;
      } else if ('src' in audio && window.URL.createObjectURL) {
        // console.log("set audio.src");
        audio.src = window.URL.createObjectURL(this.state.remoteStream);
      }

      if (isSafari()) {
        // console.log("isSafari");
        audio.controls = false;
        audio.playsinline = true;
        audio.muted = false; //audio.setAttribute("muted", "");

        audio.autoplay = true;

        if (audio.load) {
          // console.log("audio.load");
          audio.load();
        }

        if (audio.play) {
          console.log('audio.play');
          setTimeout(function () {
            var promise = audio.play();

            if (promise.then) {
              promise.then(function () {// console.log("play successfully");
              })["catch"](function (err) {
                console.log('play failed', err);
              });
            } else {// console.log("is not a promise");
            }
          }, 0);
        }
      } else {
        audio.muted = false;
        audio.controls = false;
        audio.playsinline = true;
        audio.autoplay = true;
        audio.load();
        setTimeout(function () {
          var promise = audio.play();

          if (promise.then) {
            promise.then(function () {// console.log("play successfully");
            })["catch"](function (err) {
              console.log('play failed', err);
            });
          }
        }, 0);
      }

      audio.onloadedmetadata = function () {
        if (isSafari()) {// audio.controls = false;
          // audio.playsinline = true;
          // audio.muted = true;
          // audio.setAttribute("muted", "");
          // audio.autoplay = true;
          // if (audio.play) {
          //   console.log("audio.play");
          //   setTimeout(() => {
          //     const promise = audio.play();
          //     if (promise.then) {
          //       promise
          //         .then(() => {
          //           console.log("play successfully");
          //         })
          //         .catch((err) => {
          //           console.log("play failed", err);
          //         });
          //     }
          //   }, 0);
          // }
        } else {
          setTimeout(function () {
            var promise = audio.play();

            if (promise.then) {
              promise.then(function () {
                console.log('play successfully');
              })["catch"](function (err) {
                console.log('play failed', err);
              });
            }
          }, 0);
        }
      };
    }
  };

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    this.handleUpdateRemotePeerConnection();
    this.handleGotGotRemoteStreamHandler();
    this.updateRemoteAudioStream(); // Count time

    this.interval = setInterval(function () {
      if (_this2.state.second === 59) {
        _this2.setState({
          second: 0,
          minute: _this2.state.minute + 1
        });
      } else {
        _this2.setState({
          second: _this2.state.second + 1
        });
      }
    }, 1000); // Interval send ttl

    this.intervalSendInCallSignal = setInterval(function () {
      (0, _websocket.sendMessage)({
        group: _websocket2.GROUP.CALL,
        type: _websocket2.TYPE.CALL.UPDATE_IN_CALL_SIGNAL,
        payload: {
          callId: (0, _get2["default"])(_this2.props.callInfo, ['callData', 'id'])
        },
        tenantInfo: (0, _tenantInfo.getTenantInfo)()
      });
    }, 15000);

    window.parent.onbeforeunload = function () {
      return 'Do not reload page';
    };

    window.parent.addEventListener('unload', this.onClickStop);
  };

  _proto.componentDidUpdate = function componentDidUpdate() {
    this.updateRemoteAudioStream();
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.interval && clearInterval(this.interval);
    this.intervalSendInCallSignal && clearInterval(this.intervalSendInCallSignal);
    window.parent.onbeforeunload = null;
    window.parent.removeEventListener('unload', this.onClickStop);
  };

  _proto.render = function render() {
    var _this$props = this.props,
        setting = _this$props.setting,
        callInfo = _this$props.callInfo,
        isMobileMode = _this$props.isMobileMode;
    var _this$state = this.state,
        minute = _this$state.minute,
        second = _this$state.second;
    var adminInfo = (0, _get2["default"])(callInfo, ['callData', 'admin']);
    var adminAvatar = (0, _get2["default"])(adminInfo, 'avatar');
    var adminName = (0, _get2["default"])(adminInfo, 'displayName') || 'Admin name';
    var isCustomAdminInfo = (0, _get2["default"])(setting, 'callThemeSettings.isCustomAdminInfo');
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].container
    }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].timeContent
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].icon
    }, /*#__PURE__*/_react["default"].createElement(_reactInlinesvg["default"], {
      src: _calling["default"]
    })), /*#__PURE__*/_react["default"].createElement(_countTime["default"], {
      minute: minute,
      second: second
    }))), /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].infoContent
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].userAvatar
    }, /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        backgroundColor: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor'),
        color: 'transparent'
      },
      className: _styles["default"].wrapOpacity1
    }), /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        backgroundColor: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor')
      },
      className: _styles["default"].wrapOpacity2
    }), !isCustomAdminInfo ? /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        backgroundColor: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor')
      },
      className: _styles["default"].wrap
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].avartar
    }, adminAvatar ? /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        width: '60px',
        height: '60px'
      }
    }, /*#__PURE__*/_react["default"].createElement(_avatar["default"], {
      size: "60px",
      src: adminAvatar
    })) : /*#__PURE__*/_react["default"].createElement(_avatar["default"], {
      size: "30px",
      src: _icon.CALLING_ICON.CALLING3
    }))) : /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        backgroundColor: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor')
      },
      className: _styles["default"].wrap
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].avartar
    }, /*#__PURE__*/_react["default"].createElement(_avatar["default"], {
      size: "60px",
      src: (0, _get2["default"])(setting, 'callThemeSettings.informationSettings.callee_avatar')
    })))), /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        marginTop: '9px'
      }
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: _styles["default"].userName
    }, isCustomAdminInfo ? (0, _get2["default"])(setting, 'callThemeSettings.informationSettings.callee_name') : adminName))), /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].endButton,
      onClick: this.onClickStop
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].iconContainer
    }, /*#__PURE__*/_react["default"].createElement(_reactInlinesvg["default"], {
      src: _endCall["default"]
    }))), /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].power
    }, /*#__PURE__*/_react["default"].createElement(_power["default"], {
      setting: setting
    })), /*#__PURE__*/_react["default"].createElement("div", {
      ref: this.audioParentRef,
      style: {
        display: 'none'
      },
      dangerouslySetInnerHTML: {
        __html: "\n                <video\n                  loop\n                  muted\n                  autoplay\n                  playsinline\n                  preload=\"metadata\"\n                >\n                </video>"
      }
    }), /*#__PURE__*/_react["default"].createElement(_icon.CloseCallIcon, {
      className: _styles["default"].closeIcon
    }));
  };

  return PageCalling;
}(_react.Component);

exports["default"] = PageCalling;
module.exports = exports.default;