"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _styles = _interopRequireDefault(require("./styles.scss"));

var _power = _interopRequireDefault(require("../power"));

var _reactInlinesvg = _interopRequireDefault(require("react-inlinesvg"));

var _callEnded = _interopRequireDefault(require("../../../icon/call-ended.svg"));

var _reactStarRatings = _interopRequireDefault(require("react-star-ratings"));

var _button = _interopRequireDefault(require("../button"));

var _icon = require("../../../icon");

var _reactRedux = require("react-redux");

var _updateCall = require("../../../../store/actions/update-call.action");

var _constants = require("../../constants");

var _avatar = _interopRequireDefault(require("../../../../commons/components/avatar"));

var _countTime = _interopRequireDefault(require("../../../../commons/components/count-time"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _default = function _default(props) {
  var dispatch = (0, _reactRedux.useDispatch)();
  var setting = props.setting,
      callInfo = props.callInfo,
      status = props.status,
      isMobileMode = props.isMobileMode;

  var _useState = (0, _react.useState)(0),
      rating = _useState[0],
      setRating = _useState[1];

  var ratingColor = (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor');
  var totalDuration = (0, _get2["default"])(callInfo, 'callData.totalDuration');
  var adminAvatar = (0, _get2["default"])(callInfo, ['callData', 'admin', 'avatar']);
  var minute = 0;
  var second = 0;

  if (totalDuration) {
    minute = Math.floor(totalDuration / 60);
    second = totalDuration % 60;
  }

  var onChangeRating = function onChangeRating(newRating) {
    var setting = props.setting;
    setRating(newRating);
    dispatch((0, _updateCall.updateCallInfo)({
      id: callInfo.callData.id,
      rating: newRating
    }, _constants.CALL_STATUS.COMPLETED_RATING, setting.channelId));
  };

  var onClickMakeAnotherCall = function onClickMakeAnotherCall() {
    var handleMakeAnotherCall = props.handleMakeAnotherCall;
    handleMakeAnotherCall && handleMakeAnotherCall();
  };

  var isCustomAdminInfo = (0, _get2["default"])(setting, 'callThemeSettings.isCustomAdminInfo');
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].container
  }, status === _constants.CALL_STATUS.COMPLETED_RATING || rating !== 0 ? /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].ratingResult
  }, /*#__PURE__*/_react["default"].createElement(_reactStarRatings["default"], {
    rating: rating || (0, _get2["default"])(props.callInfo, ['callData', 'rating']),
    starRatedColor: ratingColor,
    starHoverColor: ratingColor,
    numberOfStars: 5,
    name: "rating",
    starDimension: "28.8px",
    starSpacing: "7.7px"
  }), /*#__PURE__*/_react["default"].createElement("span", {
    className: _styles["default"].title
  }, (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.rating_text')), /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].button
  }, /*#__PURE__*/_react["default"].createElement(_button["default"], {
    setting: setting,
    text: (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.make_another_call_label'),
    callIcon: true,
    onClick: onClickMakeAnotherCall
  }))) : /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].content
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].mainContain
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].endtimeContent
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].icon
  }, /*#__PURE__*/_react["default"].createElement(_reactInlinesvg["default"], {
    src: _callEnded["default"]
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].time,
    style: {
      fontFamily: 'Open Sans'
    }
  }, /*#__PURE__*/_react["default"].createElement(_countTime["default"], {
    minute: minute,
    second: second
  }), /*#__PURE__*/_react["default"].createElement("span", {
    style: {
      marginLeft: '5px'
    }
  }, " Call ended "))), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].userAvatar
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      backgroundColor: '#d6d6d6'
    },
    className: _styles["default"].wrapOpacity1
  }), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      backgroundColor: '#d6d6d6'
    },
    className: _styles["default"].wrapOpacity2
  }), !isCustomAdminInfo ? /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      backgroundColor: '#d6d6d6'
    },
    className: _styles["default"].wrap
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].avartar
  }, adminAvatar ? /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      width: '60px',
      height: '60px'
    }
  }, /*#__PURE__*/_react["default"].createElement(_avatar["default"], {
    size: "60px",
    src: adminAvatar
  })) : /*#__PURE__*/_react["default"].createElement(_avatar["default"], {
    size: "30px",
    src: _icon.CALLING_ICON.CALLING3
  }))) : /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      backgroundColor: (0, _get2["default"])(setting, 'iconTextColor')
    },
    className: _styles["default"].wrap
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].avartar
  }, /*#__PURE__*/_react["default"].createElement(_avatar["default"], {
    size: "60px",
    src: (0, _get2["default"])(setting, 'callThemeSettings.informationSettings.callee_avatar')
  })))), /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].ratingContent
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: _styles["default"].text
  }, (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.pre_rating_text')), /*#__PURE__*/_react["default"].createElement(_reactStarRatings["default"], {
    rating: rating,
    starRatedColor: ratingColor,
    starHoverColor: ratingColor,
    changeRating: function changeRating(newRating, name) {
      return onChangeRating(newRating);
    } // setRating(newRating)
    ,
    numberOfStars: 5,
    name: "rating",
    starDimension: "27.5px",
    starSpacing: "7.7px"
  })))), /*#__PURE__*/_react["default"].createElement(_power["default"], {
    setting: setting
  })), status === _constants.CALL_STATUS.COMPLETED_RATING || rating !== 0 && /*#__PURE__*/_react["default"].createElement(_power["default"], {
    setting: setting
  }), /*#__PURE__*/_react["default"].createElement(_icon.CloseCallIcon, {
    iconTextColor: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor'),
    className: _styles["default"].closeIcon
  }));
};

exports["default"] = _default;
module.exports = exports.default;