"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _styles = _interopRequireDefault(require("./styles.scss"));

var _constants = require("../../constants");

var _icon = require("../../../icon");

var _power = _interopRequireDefault(require("../power"));

var _reactInlinesvg = _interopRequireDefault(require("react-inlinesvg"));

var _endCall = _interopRequireDefault(require("../../../icon/end-call.svg"));

var _avatar = _interopRequireDefault(require("../../../../commons/components/avatar"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var PageInitCall = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(PageInitCall, _Component);

  function PageInitCall(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "onClickStop", function () {
      var handleStopCall = _this.props.handleStopCall; //ToDo: Server is based on TotalDuration. Need to refactor

      handleStopCall && handleStopCall(_constants.CALL_STOP_REASON.SUBSCRIBER_STOP, 0);
      clearTimeout(_this.setTimeoutStopCall);
    });
    return _this;
  }

  var _proto = PageInitCall.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    // Auto stop call after init 30s but nobody accepting this call
    // console.log("handleAutoStopCall");
    this.setTimeoutStopCall = setTimeout(function () {
      _this2.props.handleStopCall(_constants.CALL_STOP_REASON.SUBSCRIBER_AUTO_STOP_WHEN_TIMEOUT);
    }, 60000);

    window.parent.onbeforeunload = function () {
      return 'Do not reload page';
    };

    window.parent.addEventListener('unload', this.onClickStop);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.setTimeoutStopCall && clearInterval(this.setTimeoutStopCall);
    window.parent.onbeforeunload = null;
    window.parent.removeEventListener('unload', this.onClickStop);
  };

  _proto.render = function render() {
    var _this$props = this.props,
        callInfo = _this$props.callInfo,
        setting = _this$props.setting,
        isMobileMode = _this$props.isMobileMode;
    var status = (0, _get2["default"])(callInfo, ['callData', 'status']);
    var subscriberName = (0, _get2["default"])(callInfo.callData, ['callInfo', 'name']);
    var isCustomAvatar = (0, _get2["default"])(setting, 'callThemeSettings.isCustomProjectAvatar');
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].container
    }, status === _constants.CALL_STATUS.INITIATED && /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].callStatus
    }, "Initializing..."), status === _constants.CALL_STATUS.RINGING && /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].callStatus
    }, "Ringing..."), /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].infoContent
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].userAvatar
    }, /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        backgroundColor: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor'),
        color: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor')
      },
      className: _styles["default"].wrapOpacity1
    }), /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        backgroundColor: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor')
      },
      className: _styles["default"].wrapOpacity2
    }), !isCustomAvatar ? /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        backgroundColor: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor')
      },
      className: _styles["default"].wrap
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].icon
    }, /*#__PURE__*/_react["default"].createElement("img", {
      src: _icon.CALLING_ICON.CALLING1
    })), /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].icon
    }, /*#__PURE__*/_react["default"].createElement("img", {
      src: _icon.CALLING_ICON.CALLING2
    })), /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].icon
    }, /*#__PURE__*/_react["default"].createElement("img", {
      src: _icon.CALLING_ICON.CALLING3
    }))) : /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        backgroundColor: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor')
      },
      className: _styles["default"].wrap
    }, /*#__PURE__*/_react["default"].createElement(_avatar["default"], {
      size: "60px",
      src: (0, _get2["default"])(setting, 'callThemeSettings.informationSettings.project_avatar')
    }))), /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        marginTop: '9px'
      }
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: _styles["default"].userName
    }, (0, _get2["default"])(setting, 'callThemeSettings.informationSettings.project_name')))), /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].endButton,
      onClick: this.onClickStop
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].iconContainer
    }, /*#__PURE__*/_react["default"].createElement(_reactInlinesvg["default"], {
      src: _endCall["default"]
    }))), /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].power
    }, /*#__PURE__*/_react["default"].createElement(_power["default"], {
      setting: setting
    })), /*#__PURE__*/_react["default"].createElement(_icon.CloseCallIcon, {
      className: _styles["default"].closeIcon
    }));
  };

  return PageInitCall;
}(_react.Component);

exports["default"] = PageInitCall;
module.exports = exports.default;