"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _react = _interopRequireWildcard(require("react"));

var _styles = _interopRequireDefault(require("./styles.scss"));

var _formInput = _interopRequireDefault(require("../../../../commons/components/form-input"));

var _button = _interopRequireDefault(require("../button"));

var _leaveInformation = require("../../../../store/actions/leave-information.action");

var _name = _interopRequireDefault(require("../../../icon/name.svg"));

var _email = _interopRequireDefault(require("../../../icon/email.svg"));

var _phone = _interopRequireDefault(require("../../../icon/phone.svg"));

var _reactInlinesvg = _interopRequireDefault(require("react-inlinesvg"));

var _reactHookForm = require("react-hook-form");

var _reactRedux = require("react-redux");

var _power = _interopRequireDefault(require("../power"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var _default = function _default(_ref) {
  var setting = _ref.setting;

  var _useState = (0, _react.useState)(null),
      name = _useState[0],
      setName = _useState[1];

  var _useState2 = (0, _react.useState)(null),
      email = _useState2[0],
      setEmail = _useState2[1];

  var _useState3 = (0, _react.useState)(null),
      phone = _useState3[0],
      setPhone = _useState3[1];

  var _useForm = (0, _reactHookForm.useForm)(),
      handleSubmit = _useForm.handleSubmit;

  var _useState4 = (0, _react.useState)(false),
      isSubmit = _useState4[0],
      setSubmit = _useState4[1];

  var dispatch = (0, _reactRedux.useDispatch)();
  var activeTheme = (0, _get2["default"])(setting, 'activeTheme');
  var enableFieldName = (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.form_name_enable');
  var enableFieldEmail = (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.form_email_enable');
  var enableFieldPhone = (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.form_phone_enable');
  var requiredFieldName = (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.form_name_require');
  var requiredFieldEmail = (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.form_email_require');
  var requiredFieldPhone = (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.form_phone_require');

  var onSubmit = function onSubmit() {
    var validateName = enableFieldName && requiredFieldName && (0, _isEmpty2["default"])(name) ? false : true;
    var validateEmail = enableFieldEmail && requiredFieldEmail && (0, _isEmpty2["default"])(email) ? false : true;
    var validatePhone = enableFieldPhone && requiredFieldPhone && (0, _isEmpty2["default"])(phone) ? false : true;
    setSubmit(true);

    if (!(0, _includes2["default"])([validateName, validatePhone, validateEmail], false)) {
      dispatch((0, _leaveInformation.leaveInformation)({
        name: name,
        email: email,
        phone: phone
      }, setting.channelId));
    }
  };

  var getInputTextColor = function getInputTextColor(setting) {
    var activeTheme = (0, _get2["default"])(setting, 'activeTheme');

    if (activeTheme === 'style-one') {
      return (0, _get2["default"])(setting, 'screenForm.inputTextColor');
    } else if (activeTheme === 'style-two') {
      return (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor');
    } else {
      return (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor');
    }
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].content
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].userInfoFormContainer + " bs-call-form"
  }, /*#__PURE__*/_react["default"].createElement("span", {
    className: _styles["default"].title
  }, (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.leave_info_tile')), /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].form
  }, /*#__PURE__*/_react["default"].createElement("form", {
    onSubmit: handleSubmit(onSubmit),
    className: _styles["default"].userForm
  }, /*#__PURE__*/_react["default"].createElement("div", null, enableFieldName && /*#__PURE__*/_react["default"].createElement(_formInput["default"], {
    style: activeTheme,
    backgroundColor: (0, _get2["default"])(setting, 'screenForm.inputBackgroundColor'),
    isRequired: requiredFieldName,
    textColor: getInputTextColor(setting),
    icon: /*#__PURE__*/_react["default"].createElement(_reactInlinesvg["default"], {
      src: _name["default"],
      style: {
        width: '12px',
        height: '12px'
      }
    }),
    placeholder: (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.form_name_placeholder'),
    onChange: function onChange(e) {
      return setName(e.target.value);
    },
    isValid: isSubmit ? (0, _isEmpty2["default"])(name) : undefined,
    inputValue: name,
    placeholderColor: (0, _get2["default"])(setting, 'screenForm.placeholderTextColor')
  })), /*#__PURE__*/_react["default"].createElement("div", null, enableFieldEmail && /*#__PURE__*/_react["default"].createElement(_formInput["default"], {
    style: activeTheme,
    backgroundColor: (0, _get2["default"])(setting, 'screenForm.inputBackgroundColor'),
    isRequired: requiredFieldEmail,
    textColor: getInputTextColor(setting),
    icon: /*#__PURE__*/_react["default"].createElement(_reactInlinesvg["default"], {
      src: _email["default"],
      style: {
        width: '16px',
        height: '11px'
      }
    }),
    placeholder: (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.form_email_placeholder'),
    onChange: function onChange(e) {
      return setEmail(e.target.value);
    },
    isValid: isSubmit ? (0, _isEmpty2["default"])(email) : undefined,
    inputValue: email,
    placeholderColor: (0, _get2["default"])(setting, 'screenForm.placeholderTextColor')
  })), /*#__PURE__*/_react["default"].createElement("div", null, enableFieldPhone && /*#__PURE__*/_react["default"].createElement(_formInput["default"], {
    style: activeTheme,
    backgroundColor: (0, _get2["default"])(setting, 'screenForm.inputBackgroundColor'),
    isRequired: requiredFieldPhone,
    textColor: getInputTextColor(setting),
    icon: /*#__PURE__*/_react["default"].createElement(_reactInlinesvg["default"], {
      style: {
        width: '16.8px',
        height: '16.8px'
      },
      src: _phone["default"]
    }),
    placeholder: (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.form_phone_placeholder'),
    onChange: function onChange(e) {
      return setPhone(e.target.value);
    },
    isValid: isSubmit ? (0, _isEmpty2["default"])(phone) : undefined,
    inputValue: phone,
    placeholderColor: (0, _get2["default"])(setting, 'screenForm.placeholderTextColor')
  })), /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_button["default"], {
    width: "100%",
    setting: setting,
    sendIcon: true,
    borderRadius: 10,
    text: (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.send_info_label')
  })))), /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].power
  }, /*#__PURE__*/_react["default"].createElement(_power["default"], {
    setting: setting
  }))));
};

exports["default"] = _default;
module.exports = exports.default;