"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _get2 = _interopRequireDefault(require("lodash/get"));

var _styles = _interopRequireDefault(require("./styles.scss"));

var _react = _interopRequireWildcard(require("react"));

var _power = _interopRequireDefault(require("../power"));

var _button = _interopRequireDefault(require("../button"));

var _leaveInfo = _interopRequireDefault(require("../leave-info"));

var _icon = require("../../../icon");

var _call = _interopRequireDefault(require("../../../icon/call.svg"));

var _reactInlinesvg = _interopRequireDefault(require("react-inlinesvg"));

var _reactRedux = require("react-redux");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var getBorderRadiusValue = function getBorderRadiusValue(activeTheme) {
  if (activeTheme === 'style-one') {
    return '0px';
  }

  if (activeTheme === 'style-two') {
    return '30px';
  }

  return '10px';
};

var _default = function _default(props) {
  var setting = props.setting;

  var _useState = (0, _react.useState)(false),
      wannaLeaveInfo = _useState[0],
      setWannaLeaveInfo = _useState[1];

  var phoneNumber = (0, _get2["default"])(setting, 'callComponent.phoneNumber');
  var activeTheme = (0, _get2["default"])(setting, 'activeTheme');
  var borderRadius = getBorderRadiusValue(activeTheme);
  var alreadySaveInfo = (0, _reactRedux.useSelector)(function (store) {
    return (0, _get2["default"])(store, 'behavior.alreadySubmitUserInfo');
  });
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].container
  }, wannaLeaveInfo && !alreadySaveInfo ? /*#__PURE__*/_react["default"].createElement(_leaveInfo["default"], {
    setting: setting,
    isNoSupport: true,
    onCloseForm: function onCloseForm() {
      return setLeaveInfo(false);
    }
  }) : /*#__PURE__*/_react["default"].createElement("div", {
    className: _styles["default"].content
  }, /*#__PURE__*/_react["default"].createElement("span", {
    style: {
      color: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor')
    },
    className: _styles["default"].title
  }, (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.no_support_title')), !alreadySaveInfo && /*#__PURE__*/_react["default"].createElement("span", {
    className: _styles["default"].description
  }, (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.no_spport_description')), !alreadySaveInfo && /*#__PURE__*/_react["default"].createElement(_button["default"], {
    setting: setting,
    onClick: function onClick() {
      return setWannaLeaveInfo(true);
    },
    text: (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.no_support_label'),
    isBorder: true,
    width: "100%"
  }), phoneNumber && /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      marginTop: '24px'
    }
  }, /*#__PURE__*/_react["default"].createElement("a", {
    style: {
      background: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor'),
      borderRadius: borderRadius
    },
    className: _styles["default"].phoneCallButton,
    href: "tel:" + phoneNumber
  }, /*#__PURE__*/_react["default"].createElement(_reactInlinesvg["default"], {
    className: _styles["default"].icon,
    src: _call["default"]
  }), phoneNumber))), /*#__PURE__*/_react["default"].createElement(_power["default"], {
    setting: setting
  }), /*#__PURE__*/_react["default"].createElement(_icon.CloseCallIcon, {
    iconTextColor: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor'),
    className: _styles["default"].closeIcon
  }));
};

exports["default"] = _default;
module.exports = exports.default;