"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _styles = _interopRequireDefault(require("./styles.scss"));

var _header = _interopRequireDefault(require("../header"));

var _power = _interopRequireDefault(require("../power"));

var _button = _interopRequireDefault(require("../button"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var PageStartCall = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(PageStartCall, _Component);

  function PageStartCall() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChangeSpeaker", function (e) {
      var _this$props = _this.props,
          handleSelectDevices = _this$props.handleSelectDevices,
          selectedMicrophoneId = _this$props.selectedMicrophoneId;
      handleSelectDevices && handleSelectDevices(e.target.value, selectedMicrophoneId);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleChangeMicrophone", function (e) {
      var _this$props2 = _this.props,
          handleSelectDevices = _this$props2.handleSelectDevices,
          selectedSpeakerId = _this$props2.selectedSpeakerId;
      handleSelectDevices && handleSelectDevices(selectedSpeakerId, e.target.value);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClickCall", function () {
      var _this$props3 = _this.props,
          handleStartCall = _this$props3.handleStartCall,
          selectedMicrophoneId = _this$props3.selectedMicrophoneId,
          selectedSpeakerId = _this$props3.selectedSpeakerId;
      handleStartCall && handleStartCall(selectedSpeakerId, selectedMicrophoneId);
    });
    return _this;
  }

  var _proto = PageStartCall.prototype;

  _proto.render = function render() {
    var _this$props4 = this.props,
        selectedMicrophoneId = _this$props4.selectedMicrophoneId,
        selectedSpeakerId = _this$props4.selectedSpeakerId,
        callInfo = _this$props4.callInfo;
    var _this$props5 = this.props,
        devices = _this$props5.devices,
        setting = _this$props5.setting,
        isMobileMode = _this$props5.isMobileMode;
    var speakers = (devices || []).filter(function (device) {
      return device.kind === 'audiooutput';
    });
    var microphones = (devices || []).filter(function (device) {
      return device.kind === 'audioinput';
    });
    selectedSpeakerId = selectedSpeakerId || (!(0, _isEmpty2["default"])(speakers) ? speakers[0].deviceId : undefined);
    selectedMicrophoneId = selectedMicrophoneId || (!(0, _isEmpty2["default"])(microphones) ? microphones[0].deviceId : undefined);
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].container
    }, /*#__PURE__*/_react["default"].createElement(_header["default"], {
      setting: setting,
      isMobileMode: isMobileMode
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].content
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].deviceSetting
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].labelContainer
    }, /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        color: (0, _get2["default"])(setting, 'screenConversation.rightSideBackgroundColor')
      },
      className: _styles["default"].label
    }, (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.start_call__choose_your_input_device') || 'Choose your input device')), /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].deviceStatus
    }, /*#__PURE__*/_react["default"].createElement("select", {
      onChange: this.handleChangeMicrophone,
      value: selectedMicrophoneId
    }, microphones.map(function (mic) {
      return /*#__PURE__*/_react["default"].createElement("option", {
        key: mic.deviceId,
        value: mic.deviceId
      }, mic.label);
    })))), /*#__PURE__*/_react["default"].createElement("div", {
      className: _styles["default"].btnCallWrapper
    }, /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        width: '100%',
        paddingLeft: '39px',
        paddingRight: '39px'
      }
    }, /*#__PURE__*/_react["default"].createElement(_button["default"], {
      isLoading: (0, _get2["default"])(this.props, 'callInfo.callData.status') === 'Connecting',
      setting: setting,
      onClick: this.handleClickCall,
      callIcon: true,
      color: "#fff",
      text: (0, _get2["default"])(setting, 'callThemeSettings.commonSettings.call_now_label'),
      width: "min-content"
    })))), /*#__PURE__*/_react["default"].createElement(_power["default"], {
      setting: setting
    }));
  };

  return PageStartCall;
}(_react.Component);

exports["default"] = PageStartCall;
module.exports = exports.default;