"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _find2 = _interopRequireDefault(require("lodash/find"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _includes2 = _interopRequireDefault(require("lodash/includes"));

var _react = _interopRequireWildcard(require("react"));

var _reactFrameComponent = _interopRequireDefault(require("react-frame-component"));

var _callWidget = _interopRequireDefault(require("../icon/call-widget.svg"));

var _actions = require("../../store/actions");

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _noSupport = _interopRequireDefault(require("./components/no-support"));

var _getPermission = _interopRequireDefault(require("./components/get-permission"));

var _startCall = _interopRequireDefault(require("./components/start-call"));

var _initCall = _interopRequireDefault(require("./components/init-call"));

var _calling = _interopRequireDefault(require("./components/calling"));

var _complete = _interopRequireDefault(require("./components/complete"));

var _busyLine = _interopRequireDefault(require("./components/busy-line"));

var _constants = require("./constants");

var _widgetIcon = _interopRequireDefault(require("../../commons/components/widget-icon"));

var _layout = _interopRequireDefault(require("./components/layout"));

var _tooltip = _interopRequireDefault(require("../tooltip"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var PhoneCall = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(PhoneCall, _Component);

  function PhoneCall(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClickCall", function () {
      _this.props.actions.toggleCall();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleGetPermission", function (_ref) {
      var isAllow = _ref.isAllow;

      _this.props.actions.updateMediaPermission(isAllow);

      _this.props.actions.checkMediaDevice();
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleStartCall", /*#__PURE__*/function () {
      var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(speakerId, microphoneId) {
        var setting;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                setting = _this.props.setting;

                _this.props.actions.startCall({
                  speakerId: speakerId,
                  microphoneId: microphoneId
                }, setting.channelId);

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x, _x2) {
        return _ref2.apply(this, arguments);
      };
    }());
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSelectDevices", function (speakerId, microphoneId) {
      _this.props.actions.selectDevices({
        speakerId: speakerId,
        microphoneId: microphoneId
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleStopCall", function (stopReason, totalDuration) {
      if (_this.props.isInConfigurationMode) return;
      var _this$props = _this.props,
          callInfo = _this$props.callInfo,
          setting = _this$props.setting;

      _this.props.actions.stopCall(callInfo.callData, {
        stopReason: stopReason || _constants.CALL_STOP_REASON.SUBSCRIBER_STOP,
        totalDuration: totalDuration
      }, setting.channelId);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "calculateWidgetPosition", function () {
      var _this$props2 = _this.props,
          position = _this$props2.position,
          area = _this$props2.area,
          setting = _this$props2.setting,
          showChat = _this$props2.showChat,
          rect = _this$props2.rect,
          isSettingCollapse = _this$props2.isSettingCollapse,
          isSettingLeftBottom = _this$props2.isSettingLeftBottom,
          isSettingVertical = _this$props2.isSettingVertical,
          marginBottom = _this$props2.marginBottom,
          marginLeft = _this$props2.marginLeft,
          marginRight = _this$props2.marginRight;
      var iconSize = setting.iconSize,
          iconMargin = setting.iconMargin;
      var chatboxPosition = (0, _get2["default"])(setting, 'chatboxComponent.position');
      var leftBottomAlign = (0, _get2["default"])(setting, 'leftBottomAlign');
      var rightBottomAlign = (0, _get2["default"])(setting, 'rightBottomAlign');
      var windowWidth = rect.width;
      var bottom = 10;
      var right = 0;
      var width = 400;
      var isChatBoxInSameArea = area === chatboxPosition;
      var isLeftBottomAlignHorizontal = leftBottomAlign === 'horizontal';
      var isRightBottomAlignHorizontal = rightBottomAlign === 'horizontal';

      if (isSettingCollapse) {
        if (isSettingLeftBottom) {
          if (showChat) {
            if (isSettingVertical) {
              right = position.right - width - width - iconMargin - iconMargin + 30;
              bottom = 0;
            } else {
              bottom = 10 + iconSize;
              right = windowWidth - marginRight - width - 10 - width - 10 + 40;
            }
          } else {
            // Don't care the chatbox now in this logic branch
            if (isSettingVertical) {
              right = position.right - width - iconMargin + 10;
              bottom = 0;
            } else {
              bottom = 10 + iconSize;
              right = windowWidth - width - marginLeft + 10;
            }
          }
        } else {
          if (showChat) {
            if (isSettingVertical) {
              right = position.right + 380 + marginRight + iconSize;
              bottom = 0;
            } else {
              bottom = 10 + iconSize;
              right = marginRight + width - 20;
            }
          } else {
            if (isSettingVertical) {
              bottom = 0;
              right = marginRight + iconSize;
            } else {
              bottom = iconSize + 10;
              right = marginRight - 10;
            }
          }
        }
      } else {
        if (isSettingLeftBottom) {
          // If chatbox is in them same area and showing.
          if (showChat) {
            if (isSettingVertical) {
              bottom = marginBottom;
              right = position.right - width - width - iconMargin - iconMargin;
            } else {
              bottom = marginBottom + 10 + iconSize;
              right = windowWidth - marginLeft - 10 - width - width;
            }
          } else {
            // Don't care the chatbox now in this logic branch
            if (isSettingVertical) {
              bottom = marginBottom;
              right = windowWidth - width - 10 - marginLeft - iconSize;
            } else {
              bottom = marginBottom + iconSize + iconMargin;
              right = windowWidth - width - marginLeft;
            }
          }
        } else {
          if (showChat) {
            if (isSettingVertical) {
              bottom = marginBottom;
              right = marginBottom + 10 + +iconSize + width + 10;
            } else {
              right = width + 10 + marginRight;
              bottom = marginBottom + 10 + iconSize;
            }
          } else {
            if (isSettingVertical) {
              right = marginRight + 10 + iconSize;
              bottom = marginBottom;
            } else {
              right = marginRight;
              bottom = marginBottom + 10 + iconSize;
            }
          }
        }
      }

      return {
        bottom: bottom,
        right: right,
        width: width
      };
    });
    _this.state = {
      isHover: false
    };
    _this.iframeRef = _react["default"].createRef();
    return _this;
  }

  var _proto = PhoneCall.prototype;

  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    if (prevProps.iframeStyles !== this.props.iframeStyles) {
      if (this.iframeRef.current) {
        var stylesheetNode = (0, _find2["default"])(this.iframeRef.current.node.contentDocument.styleSheets, function (node) {
          return (0, _get2["default"])(node, 'ownerNode.className') === 'iframe-boostcrm';
        });

        if (stylesheetNode && stylesheetNode.ownerNode) {
          stylesheetNode.ownerNode.outerHTML = this.props.iframeStyles;
        }
      }
    }
  };

  _proto.componentDidMount = /*#__PURE__*/function () {
    var _componentDidMount = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              this.props.actions.checkMediaDevice();

            case 1:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function componentDidMount() {
      return _componentDidMount.apply(this, arguments);
    }

    return componentDidMount;
  }();

  _proto.renderCallWidget = function renderCallWidget() {
    var _this2 = this,
        _ref3;

    var _this$props3 = this.props,
        demoData = _this$props3.demoData,
        isInConfigurationMode = _this$props3.isInConfigurationMode,
        isSettingLeftBottom = _this$props3.isSettingLeftBottom;
    var showCall = (0, _get2["default"])(this.props, 'callInfo.isShowCall');
    var currentComponent = (0, _get2["default"])(demoData, 'currentComponent');
    var isShowCall = isInConfigurationMode && currentComponent === 'call' || showCall;
    var callInfo = isInConfigurationMode ? demoData.callInfo : this.props.callInfo;
    var isAllowAccessMicrophone = callInfo.isAllowAccessMicrophone,
        isDeviceSupport = callInfo.isDeviceSupport,
        devices = callInfo.devices,
        selectedMicrophoneId = callInfo.selectedMicrophoneId,
        selectedSpeakerId = callInfo.selectedSpeakerId;
    var _this$props4 = this.props,
        isMobileMode = _this$props4.isMobileMode,
        iframeStyles = _this$props4.iframeStyles,
        setting = _this$props4.setting;

    var _this$calculateWidget = this.calculateWidgetPosition(),
        bottom = _this$calculateWidget.bottom,
        right = _this$calculateWidget.right,
        width = _this$calculateWidget.width;

    var status = isInConfigurationMode ? demoData.status : (0, _get2["default"])(callInfo, 'callData.status');
    var isShowGetPermission = isInConfigurationMode ? status === _constants.CALL_STATUS.ACCESS_REQUEST : !isAllowAccessMicrophone;
    var isBorder = isShowGetPermission || (0, _includes2["default"])([_constants.CALL_STATUS.START_CALL, _constants.CALL_STATUS.CONNECTING], status);
    var isStartCall = !status || (0, _includes2["default"])([_constants.CALL_STATUS.START_CALL, _constants.CALL_STATUS.CONNECTING], status);
    var isLeftSite = (0, _get2["default"])(setting, 'display.position') === 'LEFT_BOTTOM';
    var backgroundColor = (0, _includes2["default"])([_constants.CALL_STATUS.INITIATED, _constants.CALL_STATUS.QUEUED, _constants.CALL_STATUS.RINGING, _constants.CALL_STATUS.IN_PROGRESS], status) ? (0, _get2["default"])(setting, 'iconBackgroundColor') || "#fff" : '#fff';

    var renderWhenDeviceSupports = function renderWhenDeviceSupports() {
      return /*#__PURE__*/_react["default"].createElement(_layout["default"], {
        isShowCall: isShowCall,
        setting: setting,
        isMobileMode: isMobileMode,
        border: isBorder ? true : false,
        backgroundColor: backgroundColor,
        isLeftSite: isLeftSite
      }, isShowGetPermission && /*#__PURE__*/_react["default"].createElement(_getPermission["default"], {
        handleGetPermission: _this2.handleGetPermission.bind(_this2),
        setting: setting,
        isMobileMode: isMobileMode
      }), isStartCall && /*#__PURE__*/_react["default"].createElement(_startCall["default"], {
        callInfo: callInfo,
        devices: devices,
        handleStartCall: _this2.handleStartCall.bind(_this2),
        handleSelectDevices: _this2.handleSelectDevices.bind(_this2),
        selectedMicrophoneId: selectedMicrophoneId,
        selectedSpeakerId: selectedSpeakerId,
        setting: setting,
        isMobileMode: isMobileMode
      }), (0, _includes2["default"])([_constants.CALL_STATUS.INITIATED, _constants.CALL_STATUS.QUEUED, _constants.CALL_STATUS.RINGING], status) && /*#__PURE__*/_react["default"].createElement(_initCall["default"], {
        callInfo: callInfo,
        handleStopCall: _this2.handleStopCall.bind(_this2),
        setting: setting,
        isMobileMode: isMobileMode
      }), status === _constants.CALL_STATUS.IN_PROGRESS && /*#__PURE__*/_react["default"].createElement(_calling["default"], {
        callInfo: callInfo,
        handleStopCall: _this2.handleStopCall.bind(_this2),
        setting: setting,
        isMobileMode: isMobileMode
      }), (0, _includes2["default"])([_constants.CALL_STATUS.BUSY, _constants.CALL_STATUS.ADMIN_CANCELED, _constants.CALL_STATUS.CUSTOMER_CANCELED, _constants.CALL_STATUS.NO_ANSWER, _constants.CALL_STATUS.BUSY_LEAVE_INFO, _constants.CALL_STATUS.FAILED], status) && /*#__PURE__*/_react["default"].createElement(_busyLine["default"], {
        status: status,
        setting: setting,
        handleCallAgain: _this2.handleStartCall.bind(_this2),
        isMobileMode: isMobileMode
      }), (0, _includes2["default"])([_constants.CALL_STATUS.COMPLETED, _constants.CALL_STATUS.COMPLETED_RATING], status) && /*#__PURE__*/_react["default"].createElement(_complete["default"], {
        status: status,
        setting: setting,
        callInfo: callInfo,
        handleMakeAnotherCall: _this2.handleStartCall.bind(_this2),
        isMobileMode: isMobileMode
      }), status === _constants.CALL_STATUS.NO_SUPPORT && /*#__PURE__*/_react["default"].createElement(_noSupport["default"], {
        status: status,
        setting: setting,
        isMobileMode: isMobileMode
      }));
    };

    return /*#__PURE__*/_react["default"].createElement(_reactFrameComponent["default"], {
      ref: this.iframeRef,
      initialContent: "<!DOCTYPE html><html><head>          \n          <link href=\"https://fonts.googleapis.com/css?family=Comfortaa&display=swap\" rel=\"stylesheet\">\n          <link href=\"https://fonts.googleapis.com/css?family=Roboto&display=swap\" rel=\"stylesheet\">\n          <link href=\"https://fonts.googleapis.com/css2?family=Open+Sans&display=swap\" rel=\"stylesheet\">\n          <style>\n            .bs-chatbox-input-container .ant-upload {\n              display: flex !important;\n            }\n            .bs-call-form .ant-form-item-control {\n              line-height: 31px !important;\n            }\n          </style>\n          " + iframeStyles + "</head><body></body></html>\n        ",
      mountTarget: "body",
      allowtransparency: "yes",
      style: (_ref3 = {
        right: isMobileMode ? 0 : right + "px",
        bottom: isMobileMode ? 0 : bottom + "px",
        position: isMobileMode ? 'fixed' : 'absolute',
        width: isMobileMode ? '100%' : width + "px",
        minHeight: '468px',
        maxHeight: isMobileMode ? '100%' : '468px',
        opacity: isShowCall ? '1' : '0',
        transform: isShowCall ? 'scale(1, 1)' : 'scale(0, 0)',
        height: isMobileMode ? '100%' : "calc(100% - " + bottom + "px)",
        zIndex: 9999999,
        transition: "opacity 0.8s",
        overflow: 'hidden',
        transformOrigin: isSettingLeftBottom ? "bottom left" : "bottom right"
      }, _ref3["transition"] = "transform 0.3s ease-in-out,opacity 0.3s ease-in-out , box-shadow 0.3s ease-in-out , right 0.3s ease-in-out", _ref3.maxWidth = 'unset', _ref3),
      frameBorder: "0"
    }, /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        width: '100%',
        height: '100%'
      }
    }, !isDeviceSupport && /*#__PURE__*/_react["default"].createElement(_layout["default"], {
      setting: setting,
      isMobileMode: isMobileMode,
      backgroundColor: backgroundColor
    }, /*#__PURE__*/_react["default"].createElement(_noSupport["default"], {
      status: status,
      setting: setting,
      isMobileMode: isMobileMode
    })), isDeviceSupport && renderWhenDeviceSupports()));
  };

  _proto.render = function render() {
    var _this3 = this;

    var _this$props5 = this.props,
        iframeStyles = _this$props5.iframeStyles,
        position = _this$props5.position,
        setting = _this$props5.setting,
        svgSize = _this$props5.svgSize;
    var iconBackgroundColor = setting.iconBackgroundColor,
        iconTextColor = setting.iconTextColor;
    var iconSize = (0, _get2["default"])(setting, 'iconSize');
    return /*#__PURE__*/_react["default"].createElement("div", null, this.renderCallWidget(), /*#__PURE__*/_react["default"].createElement(_reactFrameComponent["default"], {
      initialContent: "<!DOCTYPE html><html><head>" + iframeStyles + "</head><body></body></html>",
      mountTarget: "body",
      style: {
        width: iconSize,
        height: iconSize,
        position: 'absolute',
        bottom: position.bottom + "px",
        right: position.right + "px",
        transition: "opacity 0.8s",
        zIndex: '9999997',
        maxWidth: iconSize,
        minWidth: iconSize,
        minHeight: iconSize,
        maxHeight: iconSize
      },
      allowtransparency: "yes",
      frameBorder: "0"
    }, /*#__PURE__*/_react["default"].createElement(_widgetIcon["default"], {
      iconBackgroundColor: iconBackgroundColor,
      iconSize: iconSize,
      iconSrc: _callWidget["default"],
      iconTextColor: iconTextColor,
      svgSize: svgSize,
      onClick: this.handleClickCall,
      handleHover: function handleHover(e) {
        return _this3.setState(e);
      }
    })), this.state.isHover && /*#__PURE__*/_react["default"].createElement(_tooltip["default"], (0, _extends2["default"])({}, this.props, this.state)));
  };

  return PhoneCall;
}(_react.Component);

var _default = (0, _reactRedux.connect)(function (store) {
  return {
    callInfo: (0, _get2["default"])(store, 'behavior.callInfo'),
    showChat: (0, _get2["default"])(store, 'behavior.showChat')
  };
}, function (dispatch) {
  return {
    actions: (0, _redux.bindActionCreators)({
      checkMediaDevice: _actions.checkMediaDevice,
      toggleCall: _actions.toggleCall,
      updateMediaPermission: _actions.updateMediaPermission,
      startCall: _actions.startCall,
      stopCall: _actions.stopCall,
      selectDevices: _actions.selectDevices
    }, dispatch)
  };
})(PhoneCall);

exports["default"] = _default;
module.exports = exports.default;