"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _utils = require("../../commons/utils");

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var fibonacciNumbers = [0.5, 1, 2, 3, 5, 8, 13];

var WebRTC = /*#__PURE__*/function () {
  function WebRTC() {
    var _this = this;

    (0, _defineProperty2["default"])(this, "peerConnection", void 0);
    (0, _defineProperty2["default"])(this, "candidates", []);
    (0, _defineProperty2["default"])(this, "iceServers", []);
    (0, _defineProperty2["default"])(this, "desc", void 0);
    (0, _defineProperty2["default"])(this, "remoteStream", void 0);
    (0, _defineProperty2["default"])(this, "localStream", void 0);
    (0, _defineProperty2["default"])(this, "gotRemoteStreamHandler", undefined);
    (0, _defineProperty2["default"])(this, "_setRemotePeerConnectionInfo", /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(remotePeerConnectionInfo) {
        var _ref2, desc, candidates, _iterator, _step, candidate;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // console.log("_setRemotePeerConnectionInfo");
                _ref2 = remotePeerConnectionInfo || {}, desc = _ref2.desc, candidates = _ref2.candidates;

                if (!(!desc || !candidates)) {
                  _context.next = 3;
                  break;
                }

                return _context.abrupt("return");

              case 3:
                _context.next = 5;
                return _this.peerConnection.setRemoteDescription(new RTCSessionDescription(desc));

              case 5:
                _iterator = _createForOfIteratorHelperLoose(candidates);

              case 6:
                if ((_step = _iterator()).done) {
                  _context.next = 12;
                  break;
                }

                candidate = _step.value;
                _context.next = 10;
                return _this.peerConnection.addIceCandidate(new RTCIceCandidate(candidate));

              case 10:
                _context.next = 6;
                break;

              case 12:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
  }

  var _proto = WebRTC.prototype;

  _proto._resetProperties = function _resetProperties() {
    this.remoteStream = null;
    this.localStream = null;
  };

  _proto._convertCandidateToJSON = function _convertCandidateToJSON(candidate) {
    if (!candidate) return null;
    return {
      address: candidate.address,
      candidate: candidate.candidate,
      component: candidate.component,
      foundation: candidate.foundation,
      port: candidate.port,
      priority: candidate.priority,
      protocol: candidate.protocol,
      relatedAddress: candidate.relatedAddress,
      relatedPort: candidate.relatedPort,
      sdpMLineIndex: candidate.sdpMLineIndex,
      sdpMid: candidate.sdpMid,
      tcpType: candidate.tcpType,
      type: candidate.type,
      usernameFragment: candidate.usernameFragment
    };
  };

  _proto._initPeerConnection = function _initPeerConnection() {
    var _this2 = this;

    // console.log("_initPeerConnection:", this.iceServers);
    this.peerConnection = new RTCPeerConnection({
      iceServers: this.iceServers,
      iceTransportPolicy: 'all',
      iceCandidatePoolSize: '0'
    });

    this.peerConnection.ontrack = function (e) {
      // console.log("receive remote stream");
      // console.log("-----------------receive remote stream---------");
      _this2.remoteStream = e.streams[0];
      _this2.gotRemoteStreamHandler && _this2.gotRemoteStreamHandler(_this2.remoteStream);
    }; // Some should read documents
    // https://www.html5rocks.com/en/tutorials/webrtc/infrastructure/#how-can-i-build-a-signaling-service
    // https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection
    // https://webrtc.github.io/samples/src/content/peerconnection/trickle-ice/
    // https://code.google.com/archive/p/coturn/wikis/turnserver.wiki


    this.peerConnection.onicegatheringstatechange = function () {// console.log(
      //   "onicegatheringstatechange: ",
      //   this.peerConnection.iceGatheringState
      // );
      // if (this.peerConnection.iceGatheringState !== "complete") {
      //   return;
      // }
    };

    this.peerConnection.onicecandidate = function (_ref3) {
      var candidate = _ref3.candidate;
      // console.log("onicecandidate:");
      candidate && _this2.candidates.push(_this2._convertCandidateToJSON(candidate));
    };

    this.peerConnection.onicecandidateerror = function (err) {// console.log("onicecandidateerror:", err);
    };

    this.peerConnection.oniceconnectionstatechange = function (e) {// console.log("ICE Event: ", e);
      // console.log(
      //   "iceConnectionState: ",
      //   this.peerConnection.iceConnectionState
      // );
    };
  };

  _proto._collectICECandicates = /*#__PURE__*/function () {
    var _collectICECandicates2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2() {
      var maxWaitDurations, currentWaitTimeIndex, findRequiredICE, findSRFLX, findREPLAY, _iterator2, _step2, ice;

      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              // console.log("_collectICECandicates at ", new Date());
              maxWaitDurations = fibonacciNumbers;
              currentWaitTimeIndex = 0;
              findRequiredICE = false;
              findSRFLX = false;
              findREPLAY = false;

            case 5:
              _context2.next = 7;
              return (0, _utils.wait)(maxWaitDurations[currentWaitTimeIndex] * 1000);

            case 7:
              for (_iterator2 = _createForOfIteratorHelperLoose(this.candidates); !(_step2 = _iterator2()).done;) {
                ice = _step2.value;

                if (ice.type === 'srflx') {
                  findSRFLX = true;
                }

                if (ice.type === 'relay') {
                  findREPLAY = true;
                }
              }

              findRequiredICE = findSRFLX && findREPLAY;
              ++currentWaitTimeIndex;

            case 10:
              if (!findRequiredICE && currentWaitTimeIndex < maxWaitDurations.length - 1) {
                _context2.next = 5;
                break;
              }

            case 11:
              if (findRequiredICE) {
                _context2.next = 13;
                break;
              }

              throw new Error();

            case 13:
              if (this) {
                _context2.next = 15;
                break;
              }

              return _context2.abrupt("return");

            case 15:
              return _context2.abrupt("return", {
                desc: this.desc,
                candidates: this.candidates
              });

            case 16:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    function _collectICECandicates() {
      return _collectICECandicates2.apply(this, arguments);
    }

    return _collectICECandicates;
  }();

  _proto._initUserMedia = /*#__PURE__*/function () {
    var _initUserMedia2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3() {
      var _this3 = this;

      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.prev = 0;
              _context3.next = 3;
              return navigator.mediaDevices.getUserMedia({
                audio: true
              });

            case 3:
              this.localStream = _context3.sent;
              this.localStream.getTracks().forEach(function (track) {
                // console.log("this.peerConnection.addTrack");
                _this3.peerConnection.addTrack(track, _this3.localStream);
              });
              _context3.next = 10;
              break;

            case 7:
              _context3.prev = 7;
              _context3.t0 = _context3["catch"](0);
              throw new Error(JSON.stringify({
                message: 'Init User Media failed',
                code: '2'
              }));

            case 10:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, this, [[0, 7]]);
    }));

    function _initUserMedia() {
      return _initUserMedia2.apply(this, arguments);
    }

    return _initUserMedia;
  }();

  _proto._createOffer = /*#__PURE__*/function () {
    var _createOffer2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4() {
      return _regenerator["default"].wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              if (this) {
                _context4.next = 2;
                break;
              }

              return _context4.abrupt("return");

            case 2:
              _context4.next = 4;
              return this.peerConnection.createOffer({
                offerToReceiveAudio: 1
              });

            case 4:
              this.desc = _context4.sent;
              _context4.next = 7;
              return this.peerConnection.setLocalDescription(this.desc);

            case 7:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4, this);
    }));

    function _createOffer() {
      return _createOffer2.apply(this, arguments);
    }

    return _createOffer;
  }();

  _proto._createAnswer = /*#__PURE__*/function () {
    var _createAnswer2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee5() {
      return _regenerator["default"].wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              if (this) {
                _context5.next = 2;
                break;
              }

              return _context5.abrupt("return");

            case 2:
              _context5.next = 4;
              return this.peerConnection.createAnswer();

            case 4:
              this.desc = _context5.sent;
              _context5.next = 7;
              return this.peerConnection.setLocalDescription(this.desc);

            case 7:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, this);
    }));

    function _createAnswer() {
      return _createAnswer2.apply(this, arguments);
    }

    return _createAnswer;
  }();

  _proto.startCall = /*#__PURE__*/function () {
    var _startCall = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee7(iceServers) {
      var _this4 = this;

      return _regenerator["default"].wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              this.iceServers = iceServers; // console.log("startCall");

              return _context7.abrupt("return", new Promise( /*#__PURE__*/function () {
                var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee6(resolve, reject) {
                  var _yield$_this4$_collec, desc, candidates;

                  return _regenerator["default"].wrap(function _callee6$(_context6) {
                    while (1) {
                      switch (_context6.prev = _context6.next) {
                        case 0:
                          _context6.prev = 0;

                          _this4._initPeerConnection();

                          _context6.next = 4;
                          return _this4._initUserMedia();

                        case 4:
                          _context6.next = 6;
                          return _this4._createOffer();

                        case 6:
                          _context6.next = 8;
                          return _this4._collectICECandicates();

                        case 8:
                          _yield$_this4$_collec = _context6.sent;
                          desc = _yield$_this4$_collec.desc;
                          candidates = _yield$_this4$_collec.candidates;
                          resolve([null, {
                            desc: desc,
                            candidates: candidates
                          }]);
                          _context6.next = 17;
                          break;

                        case 14:
                          _context6.prev = 14;
                          _context6.t0 = _context6["catch"](0);
                          // ToDo: Could not collect ICE Candicates -> Leave some information for call back
                          reject([_context6.t0]);

                        case 17:
                        case "end":
                          return _context6.stop();
                      }
                    }
                  }, _callee6, null, [[0, 14]]);
                }));

                return function (_x3, _x4) {
                  return _ref4.apply(this, arguments);
                };
              }()));

            case 2:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7, this);
    }));

    function startCall(_x2) {
      return _startCall.apply(this, arguments);
    }

    return startCall;
  }();

  _proto.acceptCall = /*#__PURE__*/function () {
    var _acceptCall = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee9(remotePeerConnectionInfo) {
      var _this5 = this;

      return _regenerator["default"].wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              return _context9.abrupt("return", new Promise( /*#__PURE__*/function () {
                var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee8(resolve, reject) {
                  var _yield$_this5$_collec, desc, candidates;

                  return _regenerator["default"].wrap(function _callee8$(_context8) {
                    while (1) {
                      switch (_context8.prev = _context8.next) {
                        case 0:
                          _context8.prev = 0;

                          _this5._initPeerConnection();

                          _context8.next = 4;
                          return _this5._initUserMedia();

                        case 4:
                          _context8.next = 6;
                          return _this5._setRemotePeerConnectionInfo(remotePeerConnectionInfo);

                        case 6:
                          _context8.next = 8;
                          return _this5._createAnswer();

                        case 8:
                          _context8.next = 10;
                          return _this5._collectICECandicates();

                        case 10:
                          _yield$_this5$_collec = _context8.sent;
                          desc = _yield$_this5$_collec.desc;
                          candidates = _yield$_this5$_collec.candidates;
                          resolve([null, {
                            desc: desc,
                            candidates: candidates
                          }]);
                          _context8.next = 19;
                          break;

                        case 16:
                          _context8.prev = 16;
                          _context8.t0 = _context8["catch"](0);
                          // ToDo: Could not collect ICE Candicates -> Leave some information for call back
                          reject([_context8.t0]);

                        case 19:
                        case "end":
                          return _context8.stop();
                      }
                    }
                  }, _callee8, null, [[0, 16]]);
                }));

                return function (_x6, _x7) {
                  return _ref5.apply(this, arguments);
                };
              }()));

            case 1:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9);
    }));

    function acceptCall(_x5) {
      return _acceptCall.apply(this, arguments);
    }

    return acceptCall;
  }();

  _proto.stopCall = function stopCall() {
    // console.log("stop Call");
    if (!this) return;
    this.localStream && this.localStream.getTracks().forEach(function (track) {
      track.stop();
    });

    if (this.peerConnection) {
      this.peerConnection.close();
      this.peerConnection = undefined;
    }

    this.candidates = [], this.desc = [];
  };

  _proto.onGotRemoteStreamHandler = function onGotRemoteStreamHandler(cb) {
    this.gotRemoteStreamHandler = cb;
  };

  _proto.updateRemotePeerConnection = /*#__PURE__*/function () {
    var _updateRemotePeerConnection = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee10(remotePeerConnectionInfo) {
      return _regenerator["default"].wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              // console.log("updateRemotePeerConnection");
              this._setRemotePeerConnectionInfo(remotePeerConnectionInfo);

            case 1:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10, this);
    }));

    function updateRemotePeerConnection(_x8) {
      return _updateRemotePeerConnection.apply(this, arguments);
    }

    return updateRemotePeerConnection;
  }();

  _proto.getLocalStream = function getLocalStream() {
    return this.localStream;
  };

  _proto.getRemoteStream = function getRemoteStream() {
    return this.remoteStream;
  };

  return WebRTC;
}();

var _default = new WebRTC();

exports["default"] = _default;
module.exports = exports.default;