"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _reactFrameComponent = _interopRequireDefault(require("react-frame-component"));

var _scroll_top = _interopRequireDefault(require("../icon/scroll_top.svg"));

var _widgetIcon = _interopRequireDefault(require("../../commons/components/widget-icon"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ScrollTop = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(ScrollTop, _Component);

  function ScrollTop() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      visibile: false
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function () {
      var rootWindow = _this.props.rootWindow;
      var position = rootWindow.pageYOffset; // console.log("position", position);

      rootWindow && rootWindow.scrollTo({
        top: 0,
        left: 0,
        behavior: 'smooth'
      });
    });
    return _this;
  }

  var _proto = ScrollTop.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;

    var _this$props = this.props,
        rootWindow = _this$props.rootWindow,
        rootDocument = _this$props.rootDocument;

    if (rootWindow) {
      var updateIconStatus = function updateIconStatus() {
        var scrollHeight = (0, _get2["default"])(rootWindow, 'pageYOffset');
        var screenHeight = (0, _get2["default"])(rootWindow, 'screen.height') || (0, _get2["default"])(rootDocument, 'body.clientHeight');

        if (scrollHeight - screenHeight > 0) {
          _this2.setState({
            visibile: true
          });
        } else {
          _this2.setState({
            visibile: false
          });
        }
      };

      rootWindow.onscroll = function () {
        updateIconStatus();
      };

      if (rootWindow && rootDocument) {
        updateIconStatus();
      }
    }
  };

  _proto.render = function render() {
    var _this$props2 = this.props,
        iframeStyles = _this$props2.iframeStyles,
        position = _this$props2.position,
        setting = _this$props2.setting,
        svgSize = _this$props2.svgSize;
    var iconBackgroundColor = setting.iconBackgroundColor,
        iconTextColor = setting.iconTextColor,
        isAlwayShowScrollTop = setting.isAlwayShowScrollTop;
    var iconSize = (0, _get2["default"])(setting, 'iconSize');
    return isAlwayShowScrollTop || this.state.visibile ? /*#__PURE__*/_react["default"].createElement(_reactFrameComponent["default"], {
      initialContent: "<!DOCTYPE html><html><head>" + iframeStyles + "</head><body></body></html>",
      mountTarget: "body",
      style: {
        width: iconSize,
        height: iconSize,
        position: 'absolute',
        bottom: position.bottom + "px",
        right: position.right + "px",
        transition: "opacity 0.8s",
        zIndex: '9999997',
        maxWidth: iconSize,
        minWidth: iconSize,
        minHeight: iconSize,
        maxHeight: iconSize
      },
      allowtransparency: "yes",
      frameBorder: "0"
    }, /*#__PURE__*/_react["default"].createElement(_widgetIcon["default"], {
      iconBackgroundColor: iconBackgroundColor,
      iconSize: iconSize,
      iconSrc: _scroll_top["default"],
      iconTextColor: iconTextColor,
      svgSize: 20,
      onClick: this.handleClick
    })) : /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        display: 'none'
      }
    });
  };

  return ScrollTop;
}(_react.Component);

exports["default"] = ScrollTop;
module.exports = exports.default;