"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _reactFrameComponent = _interopRequireDefault(require("react-frame-component"));

var _collapse_widgets = _interopRequireDefault(require("../icon/collapse_widgets.svg"));

var _support = _interopRequireDefault(require("../icon/support.svg"));

var _widgetIcon = _interopRequireDefault(require("../../commons/components/widget-icon"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Support = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(Support, _Component);

  function Support(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function () {
      var _this$props = _this.props,
          t = _this$props.t,
          toggleCollapseExpandWidget = _this$props.toggleCollapseExpandWidget;
      toggleCollapseExpandWidget && toggleCollapseExpandWidget();
    });
    _this.myRef = _react["default"].createRef();
    _this.state = {
      widthText: 0
    };
    return _this;
  }

  var _proto = Support.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.myRef.current && this.setState({
      widthText: this.myRef.current.offsetWidth
    });
  };

  _proto.render = function render() {
    var _this$props2 = this.props,
        iframeStyles = _this$props2.iframeStyles,
        position = _this$props2.position,
        setting = _this$props2.setting,
        svgSize = _this$props2.svgSize,
        isCurrentExpand = _this$props2.isCurrentExpand,
        area = _this$props2.area,
        showChat = _this$props2.showChat,
        numberOfNewMessages = _this$props2.numberOfNewMessages,
        marginBottom = _this$props2.marginBottom,
        isSettingLeftBottom = _this$props2.isSettingLeftBottom,
        marginLeft = _this$props2.marginLeft,
        isFixedRect = _this$props2.isFixedRect;
    var iconBackgroundColor = setting.iconBackgroundColor,
        iconTextColor = setting.iconTextColor;
    var iconSize = (0, _get2["default"])(setting, 'iconSize');
    var isActive = (0, _get2["default"])(setting, 'display.isActiveTextAction');
    var toolTipHeight = iconSize === 70 ? 44 : iconSize === 60 ? 38 : 36;
    var bottom = (iconSize - toolTipHeight) / 2 + marginBottom;
    var positionTextAction = isSettingLeftBottom ? {
      left: !isFixedRect ? -(position.right - 10) : marginLeft + iconSize + 10
    } : {
      right: position.right + iconSize + 10
    };
    var style = (0, _extends2["default"])({
      padding: iconSize === 70 ? '11px 16px' : iconSize === 60 ? '8px 14px' : '7px 12px',
      boxShadow: '0 0 10px 0 rgba(0, 0, 0, 0.16)',
      backgroundColor: '#ffffff',
      position: 'absolute',
      bottom: bottom + "px",
      fontFamily: 'OpenSans-Regular',
      fontSize: '16px',
      fontWeight: 'normal',
      fontStretch: 'normal',
      fontStyle: 'normal',
      letterSpacing: 'normal',
      textAlign: 'left',
      color: '#000000',
      minWidth: 'max-content'
    }, positionTextAction);
    return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_reactFrameComponent["default"], {
      initialContent: "<!DOCTYPE html><html><head>" + iframeStyles + "</head><body></body></html>",
      mountTarget: "body",
      style: {
        width: iconSize,
        height: iconSize,
        position: 'absolute',
        bottom: position.bottom + "px",
        right: position.right + "px",
        transition: "opacity 0.8s",
        zIndex: '9999997',
        maxWidth: iconSize,
        minWidth: iconSize,
        minHeight: iconSize,
        maxHeight: iconSize
      },
      allowtransparency: "yes",
      frameBorder: "0"
    }, /*#__PURE__*/_react["default"].createElement(_widgetIcon["default"], {
      iconBackgroundColor: iconBackgroundColor,
      iconSize: iconSize,
      iconSrc: isCurrentExpand ? _collapse_widgets["default"] : _support["default"],
      iconTextColor: iconTextColor,
      svgSize: isCurrentExpand ? 16 : svgSize,
      onClick: this.handleClick,
      numberOfNewMessages: !isCurrentExpand && !showChat ? numberOfNewMessages : null
    })), /*#__PURE__*/_react["default"].createElement("div", null, isActive && !isCurrentExpand && /*#__PURE__*/_react["default"].createElement("span", {
      ref: this.myRef,
      style: style
    }, (0, _get2["default"])(setting, 'display.textAction') || 'Need support?')));
  };

  return Support;
}(_react.Component);

exports["default"] = Support;
module.exports = exports.default;