"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Tooltip = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(Tooltip, _Component);

  function Tooltip(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.myRef = _react["default"].createRef();
    _this.state = {
      widthText: 0
    };
    return _this;
  }

  var _proto = Tooltip.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.getWidthTooltip();
  };

  _proto.componentDidUpdate = function componentDidUpdate() {
    this.getWidthTooltip();
  };

  _proto.getWidthTooltip = function getWidthTooltip() {
    if (this.myRef.current && +this.myRef.current.offsetWidth !== +this.state.widthText && (+this.myRef.current.offsetWidth > +this.state.widthText + 5 || +this.myRef.current.offsetWidth < +this.state.widthText - 5)) {
      this.setState({
        widthText: +this.myRef.current.offsetWidth
      });
    }
  };

  _proto.render = function render() {
    var _this$props = this.props,
        type = _this$props.type,
        isSettingLeftBottom = _this$props.isSettingLeftBottom,
        position = _this$props.position,
        marginBottom = _this$props.marginBottom,
        setting = _this$props.setting,
        isHover = _this$props.isHover,
        isSettingVertical = _this$props.isSettingVertical,
        marginRight = _this$props.marginRight,
        index = _this$props.index;
    var widthText = this.state.widthText;
    var iconSize = (0, _get2["default"])(setting, 'iconSize');
    var toolTipHeight = iconSize === 70 ? 44 : iconSize === 60 ? 38 : 36;
    var bottom = isSettingVertical ? (iconSize - toolTipHeight) / 2 + marginBottom + (iconSize + 10) * index : marginBottom + iconSize + 10;
    var positionTextAction = isSettingLeftBottom ? {
      right: isSettingVertical ? position.right - 10 - widthText : position.right - (widthText - iconSize) / 2
    } : {
      right: isSettingVertical ? marginRight + iconSize + 10 : position.right - (widthText - iconSize) / 2
    };
    var style = (0, _extends2["default"])({
      padding: iconSize === 70 ? '11px 16px' : iconSize === 60 ? '8px 14px' : '7px 12px',
      boxShadow: '0 0 10px 0 rgba(0, 0, 0, 0.16)',
      backgroundColor: '#ffffff',
      position: 'absolute',
      bottom: bottom + "px",
      fontFamily: 'OpenSans-Regular',
      fontSize: '16px',
      fontWeight: 'normal',
      fontStretch: 'normal',
      fontStyle: 'normal',
      letterSpacing: 'normal',
      textAlign: 'left',
      color: '#000000',
      minWidth: 'max-content'
    }, positionTextAction);
    return /*#__PURE__*/_react["default"].createElement("span", {
      style: style,
      ref: this.myRef,
      className: "tooltip"
    }, type.charAt(0).toUpperCase() + type.slice(1));
  };

  return Tooltip;
}(_react.Component);

exports["default"] = Tooltip;
module.exports = exports.default;