"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _cloneDeep2 = _interopRequireDefault(require("lodash/cloneDeep"));

var _find2 = _interopRequireDefault(require("lodash/find"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _react = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _reduxThunk = _interopRequireDefault(require("redux-thunk"));

var _behavior = _interopRequireDefault(require("./store/reducers/behavior.reducer"));

var _message = _interopRequireDefault(require("./store/reducers/message.reducer"));

var _reduxDevtoolsExtension = require("redux-devtools-extension");

var _websocket = require("../src/connections/websocket");

var _widgetContext = _interopRequireDefault(require("./widget-context"));

var _localStorage = require("./commons/utils/local-storage");

var _tenantInfo = require("./commons/tenant-info");

var _localStorage2 = require("./commons/constants/local-storage");

var _websiteEvents = require("./commons/constants/website-events");

var _websocket2 = require("./commons/constants/websocket");

var _startingPointTypes = require("./commons/constants/starting-point-types");

var _ws = require("./store/actions/ws.actions");

var _clearEndSlash = _interopRequireDefault(require("./commons/utils/clear-end-slash"));

var _runFunAfter = _interopRequireDefault(require("./commons/utils/run-fun-after"));

var _networkDetector = require("./commons/utils/network-detector");

var _startConversation = require("./store/actions/start-conversation.actions");

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Widget = (0, _react.lazy)(function () {
  return Promise.resolve().then(function () {
    return _interopRequireWildcard(require('./components/widget'));
  });
});
var Conversation = (0, _react.lazy)(function () {
  return Promise.resolve().then(function () {
    return _interopRequireWildcard(require('./components/conversation'));
  });
});

var getHrefWithoutQueryAndParam = function getHrefWithoutQueryAndParam() {
  return "" + window.location.origin + window.location.pathname;
};

var getListStartingPoints = /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(host, channelId, templateId) {
    var results, pageIndex, pageSize, totalReturnedItems, response, returnedItems;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            results = [];
            pageIndex = 1;
            pageSize = 10;
            totalReturnedItems = 0;

          case 4:
            _context.next = 6;
            return fetch(host + "/channel/website/starting-points?channelId=" + channelId + "&templateId=" + templateId + "&pageIndex=" + pageIndex, {
              method: 'GET'
            });

          case 6:
            response = _context.sent;
            ++pageIndex;
            _context.next = 10;
            return response.json();

          case 10:
            returnedItems = _context.sent;
            Array.from(returnedItems || []).forEach(function (item) {
              if (item.active) {
                results.push(item);
              }
            });
            totalReturnedItems = returnedItems.length;

          case 13:
            if (totalReturnedItems === pageSize) {
              _context.next = 4;
              break;
            }

          case 14:
            return _context.abrupt("return", results);

          case 15:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function getListStartingPoints(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

function findValidStartingPoint(startingPoints, type, opts) {
  for (var _iterator = _createForOfIteratorHelperLoose(startingPoints), _step; !(_step = _iterator()).done;) {
    var startPoint = _step.value;

    if (type === _startingPointTypes.STARTING_POINT_TYPES.VISITOR_CLICK_ELEMENT) {
      var id = opts.id,
          className = opts.className;
      if (id && id === (0, _get2["default"])(startPoint, 'detail.id')) return startPoint;
      if (className && className === (0, _get2["default"])(startPoint, 'detail.className')) return startPoint;
    }

    if (type === _startingPointTypes.STARTING_POINT_TYPES.VISITOR_VISIT_URLS) {
      var _ret = function () {
        var url = opts.url; // console.log("url:", url);

        var requiredUrls = (0, _get2["default"])(startPoint, 'detail.urls') || [];
        var lowercaseUrlWithoutEndSlash = toLower((0, _clearEndSlash["default"])(url)); // console.log("lowercaseUrlWithoutEndSlash:", lowercaseUrlWithoutEndSlash);

        if ((0, _find2["default"])(requiredUrls, function (defineUrl) {
          return toLower((0, _clearEndSlash["default"])(defineUrl)) === lowercaseUrlWithoutEndSlash;
        })) {
          // console.log("found starting point");
          return {
            v: startPoint
          };
        }
      }();

      if (typeof _ret === "object") return _ret.v;
    }
  }

  return null;
}

var generateDefaultIframeStyles = function generateDefaultIframeStyles(styleSheetLink, widgetStylesheet) {
  return (styleSheetLink ? "<link rel=\"stylesheet\" href=\"" + styleSheetLink + "\"></link>" : '') + "\n  <style type=\"text/css\" class=\"iframe-boostcrm\">\n    .frame-content {\n      height: 100%;\n    }  \n    body {\n      font-family: 'Roboto !important';\n    }\n    body {\n      background: none !important;\n      background-color: transparent !important;    \n      overflow:hidden\n    }\n    " + (widgetStylesheet || '') + "\n  </style>";
};

var ConnectedWidget = /*#__PURE__*/function (_React$Component) {
  (0, _inheritsLoose2["default"])(ConnectedWidget, _React$Component);

  function ConnectedWidget(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "networkChangesHandler", function (isOnline) {
      if (!isOnline) {
        (0, _websocket.disconnectWSClient)();
      } else {
        (0, _websocket.reconnectWSClient)();
      }
    });
    var _this$props = _this.props,
        isInConfigurationMode = _this$props.isInConfigurationMode,
        isSimulator = _this$props.isSimulator,
        onInitConversationSuccess = _this$props.onInitConversationSuccess,
        setting = _this$props.setting,
        styleSheetLink = _this$props.styleSheetLink;
    var host = setting.host,
        tenantId = setting.tenantId,
        channelId = setting.channelId,
        automation = setting.automation;
    var isDisableLiveChat = !(0, _get2["default"])(setting, 'chatboxComponent.enable');
    var isDisableCall = !(0, _get2["default"])(setting, 'callComponent.enable');
    _this.state = {
      online: true,
      isReconnecting: false,
      isConnectFailed: false,
      iframeStylesInnerHtml: '',
      iframeStyles: generateDefaultIframeStyles(styleSheetLink)
    };
    var reducer = (0, _redux.combineReducers)({
      behavior: _behavior["default"],
      messages: _message["default"]
    });

    if (isInConfigurationMode) {
      _this.store = (0, _redux.createStore)(function () {}, process.env.NODE_ENV !== 'production' ? (0, _reduxDevtoolsExtension.composeWithDevTools)((0, _redux.applyMiddleware)(_reduxThunk["default"])) : (0, _redux.applyMiddleware)(_reduxThunk["default"]));
      return (0, _assertThisInitialized2["default"])(_this);
    }

    var styleTag = props.pageDocument.head.querySelector('.boostcrm-stylesheet');

    if (styleTag) {
      var observer = new MutationObserver(function () {
        _this.setState({
          iframeStylesInnerHtml: _this.state.iframeStylesInnerHtml + styleTag.innerHTML,
          iframeStyles: generateDefaultIframeStyles(styleSheetLink, _this.state.iframeStylesInnerHtml + styleTag.innerHTML)
        });

        styleTag.innerHTML = '';
      });
      observer.observe(styleTag, {
        characterData: false,
        childList: true,
        attributes: false
      });
    }

    (0, _tenantInfo.setTenantId)(tenantId);
    (0, _tenantInfo.setChannelId)(channelId);
    (0, _localStorage.setLSVariable)((0, _localStorage2.getLocalStorageVariables)(_localStorage2.LOCAL_STORAGE_VARIABLES.IS_SIMULATOR, channelId), isSimulator);
    var persistentState = (0, _localStorage.getLSVariable)((0, _localStorage2.getLocalStorageVariables)(_localStorage2.LOCAL_STORAGE_VARIABLES.STORE_STATE, channelId));
    (0, _localStorage.setLSVariable)((0, _localStorage2.getLocalStorageVariables)(_localStorage2.LOCAL_STORAGE_VARIABLES.CHANNEL_ID, channelId), channelId);
    (0, _localStorage.setLSVariable)((0, _localStorage2.getLocalStorageVariables)(_localStorage2.LOCAL_STORAGE_VARIABLES.TENANT_ID, channelId), tenantId);
    (0, _localStorage.setLSVariable)((0, _localStorage2.getLocalStorageVariables)(_localStorage2.LOCAL_STORAGE_VARIABLES.HOST, channelId), host);

    if (isSimulator) {
      persistentState = {};
    }

    if ((0, _get2["default"])(persistentState, ['behavior', 'callInfo', 'callData'])) {
      persistentState.behavior.callInfo.callData = null;
    }

    _this.store = (0, _redux.createStore)(reducer, persistentState || {}, process.env.NODE_ENV !== 'production' ? (0, _reduxDevtoolsExtension.composeWithDevTools)((0, _redux.applyMiddleware)(_reduxThunk["default"])) : (0, _redux.applyMiddleware)(_reduxThunk["default"]));

    if (_this.store) {
      _this.store.subscribe(function () {
        var data = (0, _cloneDeep2["default"])(_this.store.getState());
        (0, _localStorage.setLSVariable)((0, _localStorage2.getLocalStorageVariables)(_localStorage2.LOCAL_STORAGE_VARIABLES.STORE_STATE, channelId), data);
      });
    }

    if (!isSimulator && isDisableCall && isDisableLiveChat) return (0, _assertThisInitialized2["default"])(_this);
    (0, _websocket.initWSClient)(host, _this.props.setting.channelToken, channelId, isSimulator, null, function (newConversationId) {
      // console.log("Start new conversation: ", newConversationId);
      (0, _tenantInfo.setConversationId)(newConversationId);
      newConversationId && onInitConversationSuccess && onInitConversationSuccess(newConversationId);
    }, function () {
      console.log('set online false 1');

      _this.setState({
        online: false,
        isConnectFailed: true,
        isReconnecting: false
      });
    }, function () {
      console.log('set online false 2');

      _this.setState({
        online: false,
        isConnectFailed: false,
        isReconnecting: true
      });
    }, function () {
      console.log('set online true');

      _this.setState({
        online: true,
        isConnectFailed: false,
        isReconnecting: false
      });
    });
    (0, _websocket.setMessageHanlder)(function (message) {
      var actionType = "WS_" + (0, _get2["default"])(message, 'group') + "_" + (0, _get2["default"])(message, 'type');

      _this.store.dispatch({
        type: actionType,
        payload: message.payload
      });

      if ((0, _get2["default"])(message, 'group') === _websocket2.GROUP.MESSAGE && (0, _get2["default"])(message, 'type') === _websocket2.TYPE.MESSAGE.NEW_MESSAGE_FROM_ADMIN) {
        _this.store.dispatch((0, _ws.sendAckReceivingMessage)(message.payload, channelId));
      }
    });

    if (!isSimulator) {
      (0, _websocket.sendWebsiteEvent)(_websiteEvents.WEBSITE_EVENTS.VISIT_URL, {
        url: getHrefWithoutQueryAndParam(),
        loadDate: new Date(),
        tenantInfo: {
          channelId: channelId
        }
      });
      (0, _runFunAfter["default"])(function () {
        _this.store.dispatch && _this.store.dispatch((0, _startConversation.triggerTheWelcomeMessageWhenVisitPage)(setting));
      }, 1000); // Get list of starting points here.

      var _ref2 = automation || {},
          enabled = _ref2.enabled,
          templateId = _ref2.templateId;

      if (enabled && templateId) {
        getListStartingPoints(host, setting.channelId, templateId).then(function (startingPoints) {
          if (startingPoints.length === 0) return; // Check if needed to trigger event 'visit-urls'

          var startingPointForVisitURLs = findValidStartingPoint(startingPoints, _startingPointTypes.STARTING_POINT_TYPES.VISITOR_VISIT_URLS, {
            url: getHrefWithoutQueryAndParam()
          });
          startingPointForVisitURLs && (0, _runFunAfter["default"])(function () {
            _this.store.dispatch && _this.store.dispatch((0, _startConversation.triggerTheStartingPoint)(_startingPointTypes.STARTING_POINT_TYPES.VISITOR_VISIT_URLS, startingPointForVisitURLs.id, setting));
          }, 1000);
          var pageDocument = props.pageDocument;

          if (pageDocument) {
            pageDocument.addEventListener('click', function (e) {
              if (!e) return;
              var toElement = e.toElement;
              if (!toElement) return;
              var id = toElement.id;
              var className = toElement.className;
              var validStartPoint = findValidStartingPoint(startingPoints, _startingPointTypes.STARTING_POINT_TYPES.VISITOR_CLICK_ELEMENT, {
                id: id,
                className: className
              });
              validStartPoint && _this.store.dispatch && _this.store.dispatch((0, _startConversation.triggerTheStartingPoint)(_startingPointTypes.STARTING_POINT_TYPES.VISITOR_CLICK_ELEMENT, validStartPoint.id, setting));
            }, true);
          }
        });
      }
    }

    return _this;
  }

  var _proto = ConnectedWidget.prototype;

  _proto.componentWillUnmount = function componentWillUnmount() {
    (0, _websocket.closeWSClient)();
  };

  _proto.render = function render() {
    var _this$props2 = this.props,
        setting = _this$props2.setting,
        isSimulator = _this$props2.isSimulator,
        isInConfigurationMode = _this$props2.isInConfigurationMode;
    var _this$state = this.state,
        online = _this$state.online,
        isReconnecting = _this$state.isReconnecting,
        isConnectFailed = _this$state.isConnectFailed,
        iframeStyles = _this$state.iframeStyles;
    return /*#__PURE__*/_react["default"].createElement(_reactRedux.Provider, {
      store: this.store
    }, /*#__PURE__*/_react["default"].createElement(_widgetContext["default"].Provider, {
      value: {
        setting: setting,
        isSimulator: isSimulator,
        online: online,
        isReconnecting: isReconnecting,
        isConnectFailed: isConnectFailed,
        isInConfigurationMode: isInConfigurationMode
      }
    }, isSimulator && /*#__PURE__*/_react["default"].createElement(_react.Suspense, {
      fallback: /*#__PURE__*/_react["default"].createElement("div", null)
    }, /*#__PURE__*/_react["default"].createElement(Conversation, (0, _extends2["default"])({
      online: online,
      isReconnecting: isReconnecting,
      isConnectFailed: isConnectFailed,
      isSimulator: true,
      isMobileMode: true,
      iframeStyles: iframeStyles,
      rect: {
        width: 500,
        height: 600
      }
    }, this.props))), !isSimulator && /*#__PURE__*/_react["default"].createElement(_react.Suspense, {
      fallback: /*#__PURE__*/_react["default"].createElement("div", null)
    }, /*#__PURE__*/_react["default"].createElement(Widget, (0, _extends2["default"])({}, this.props, {
      iframeStyles: iframeStyles,
      rootWindow: window,
      rootDocument: document
    }))), /*#__PURE__*/_react["default"].createElement(_networkDetector.NetworkDetector, {
      onChange: this.networkChangesHandler
    })));
  };

  return ConnectedWidget;
}(_react["default"].Component);

exports["default"] = ConnectedWidget;
module.exports = exports.default;