"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.toggleChat = toggleChat;
exports.toggleCall = toggleCall;
exports.settingSound = settingSound;
exports.selectDevices = exports.updateMediaPermission = exports.toggleTheSupportWidgetRequest = exports.toggleChatRequest = exports.onScrollToBottom = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var actions = _interopRequireWildcard(require("./action-type"));

var _reduxActions = require("redux-actions");

var _websocket = require("../../connections/websocket");

var _websocket2 = require("../../commons/constants/websocket");

var _tenantInfo = require("../../commons/tenant-info");

var _startConversation = require("./start-conversation.actions");

var _utils = require("../../commons/utils");

var _getTimeDuration = _interopRequireDefault(require("../../commons/utils/get-time-duration"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var onScrollToBottom = (0, _reduxActions.createAction)(actions.ON_SCROLL_TO_BOTTOM);
exports.onScrollToBottom = onScrollToBottom;
var toggleChatRequest = (0, _reduxActions.createAction)(actions.TOGGLE_CHAT + ".REQUEST");
exports.toggleChatRequest = toggleChatRequest;
var toggleTheSupportWidgetRequest = (0, _reduxActions.createAction)(actions.TOGGLE_SUPPORT_WIDGET + ".REQUEST");
exports.toggleTheSupportWidgetRequest = toggleTheSupportWidgetRequest;

function toggleChat(setting) {
  return /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(dispatch, getState) {
      var showChat, state, hasTriggeredWelcomeMessage, alreadyStartConversation, delay;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              showChat = (0, _get2["default"])(getState(), 'behavior.showChat');
              dispatch(toggleChatRequest(!showChat));

              if (setting.isEnableAutomation) {
                _context.next = 5;
                break;
              }

              console.log('Ingore because not enable bot now');
              return _context.abrupt("return");

            case 5:
              if (!showChat) {
                _context.next = 7;
                break;
              }

              return _context.abrupt("return");

            case 7:
              state = getState();
              hasTriggeredWelcomeMessage = (0, _get2["default"])(state, 'behavior.hasTriggeredWelcomeMessage');
              alreadyStartConversation = (0, _get2["default"])(state, 'behavior.alreadyStartConversation');

              if (!(!(0, _utils.isDisablePreChatForm)(setting) && !alreadyStartConversation)) {
                _context.next = 13;
                break;
              }

              console.log('Ingore because the pre-chat form is enable & the conversation has not started');
              return _context.abrupt("return");

            case 13:
              if (!(!(0, _utils.isTriggerWelcomeMessageWhenClickIcon)(setting) && !(0, _utils.isTriggerWelcomeBackMessageWhenClickIcon)(setting))) {
                _context.next = 16;
                break;
              }

              console.log('Ingore because dont enable welcome message & welcome back message when revisit');
              return _context.abrupt("return");

            case 16:
              if (!((0, _utils.isTriggerWelcomeMessageWhenClickIcon)(setting) && !hasTriggeredWelcomeMessage)) {
                _context.next = 20;
                break;
              }

              (0, _websocket.sendMessage)({
                group: _websocket2.GROUP.MESSAGE,
                type: _websocket2.TYPE.MESSAGE.TRIGGER_WELCOME_MESSAGE,
                payload: {},
                tenantInfo: (0, _tenantInfo.getTenantInfo)()
              });
              dispatch((0, _startConversation.updateHasTriggeredWelcomeMessage)());
              return _context.abrupt("return");

            case 20:
              if (!(hasTriggeredWelcomeMessage && (0, _utils.isTriggerWelcomeBackMessageWhenClickIcon)(setting))) {
                _context.next = 25;
                break;
              }

              delay = (0, _getTimeDuration["default"])((0, _get2["default"])(setting, 'screenWelcomeBackMessages.trigger.time'), (0, _get2["default"])(setting, 'screenWelcomeBackMessages.trigger.unitOfTime'));
              console.log('...Trigger the welcome back message when click if:', delay);

              if ((0, _utils.isLastTimeMoreThanAPeriod)((0, _get2["default"])(state, 'behavior.lastTimeTriggeredWelcomeMessage'), delay)) {
                console.log('Trigger the welcome back message');
                (0, _websocket.sendMessage)({
                  group: _websocket2.GROUP.MESSAGE,
                  type: _websocket2.TYPE.MESSAGE.TRIGGER_WELCOME_BACK_MESSAGE,
                  payload: {},
                  tenantInfo: (0, _tenantInfo.getTenantInfo)()
                });
                dispatch((0, _startConversation.updateHasTriggeredWelcomeMessage)());
              }

              return _context.abrupt("return");

            case 25:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
}

function toggleCall() {
  return {
    type: actions.TOGGLE_CALL
  };
}

function settingSound() {
  return {
    type: actions.SOUND_SETTING
  };
}

var updateMediaPermission = (0, _reduxActions.createAction)(actions.UPDATE_MEDIA_PERMISSION + ".REQUEST");
exports.updateMediaPermission = updateMediaPermission;
var selectDevices = (0, _reduxActions.createAction)(actions.SELECT_DEVICE + ".REQUEST");
exports.selectDevices = selectDevices;