"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.startCall = exports.startCallError = exports.startCallSuccess = exports.startCallRequest = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _isArray2 = _interopRequireDefault(require("lodash/isArray"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var actions = _interopRequireWildcard(require("./action-type"));

var _reduxActions = require("redux-actions");

var _websocket = require("../../connections/websocket");

var _websocket2 = require("../../commons/constants/websocket");

var _tenantInfo = require("../../commons/tenant-info");

var _utils = require("../../commons/utils");

var _webrtc = _interopRequireDefault(require("../../components/phone-call/webrtc"));

var _getClientInfo = _interopRequireDefault(require("../../commons/utils/get-client-info"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var startCallRequest = (0, _reduxActions.createAction)(actions.START_CALL + ".REQUEST");
exports.startCallRequest = startCallRequest;
var startCallSuccess = (0, _reduxActions.createAction)(actions.START_CALL + ".SUCCESS");
exports.startCallSuccess = startCallSuccess;
var startCallError = (0, _reduxActions.createAction)(actions.START_CALL + ".ERROR");
exports.startCallError = startCallError;

var startCall = function startCall(device) {
  return /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(dispatch, getState) {
      var tenantInfo, _yield$webRTC$startCa, error, peerConnectionInfo;

      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return dispatch(startCallRequest({
                device: device
              }));

            case 2:
              tenantInfo = (0, _tenantInfo.getTenantInfo)(); // Request ICE Server

              (0, _websocket.sendMessage)({
                group: _websocket2.GROUP.CALL,
                type: _websocket2.TYPE.CALL.REQUEST_ICE_SERVERS,
                tenantInfo: tenantInfo
              });
              _context.prev = 4;
              _context.next = 7;
              return (0, _utils.retryFuncWithFibonancies)(function () {
                // console.log("Trying to connect to server");
                // To test what happen if could not get ice server
                // return false;
                var iceServers = (0, _get2["default"])(getState(), 'behavior.callInfo.callData.iceServers'); // console.log("iceServers: ", iceServers);

                // console.log("iceServers: ", iceServers);
                var result = (0, _isArray2["default"])(iceServers) && !(0, _isEmpty2["default"])(iceServers);
                return result;
              }, [0.5, 1, 2, 3, 5, 8]);

            case 7:
              _context.next = 9;
              return _webrtc["default"].startCall((0, _get2["default"])(getState(), 'behavior.callInfo.callData.iceServers'));

            case 9:
              _yield$webRTC$startCa = _context.sent;
              error = _yield$webRTC$startCa[0];
              peerConnectionInfo = _yield$webRTC$startCa[1];

              if (error) {
                _context.next = 26;
                break;
              }

              _context.t0 = _websocket.sendMessage;
              _context.t1 = _websocket2.GROUP.CALL;
              _context.t2 = _websocket2.TYPE.CALL.START_CALL;
              _context.t3 = peerConnectionInfo;
              _context.next = 19;
              return (0, _getClientInfo["default"])();

            case 19:
              _context.t4 = _context.sent;
              _context.t5 = {
                peerConnectionInfo: _context.t3,
                callerInfo: _context.t4
              };
              _context.t6 = tenantInfo;
              _context.t7 = {
                group: _context.t1,
                type: _context.t2,
                payload: _context.t5,
                tenantInfo: _context.t6
              };
              (0, _context.t0)(_context.t7);
              _context.next = 28;
              break;

            case 26:
              _context.next = 28;
              return dispatch(startCallError({
                error: 'Could not establish the connection'
              }));

            case 28:
              _context.next = 34;
              break;

            case 30:
              _context.prev = 30;
              _context.t8 = _context["catch"](4);
              _context.next = 34;
              return dispatch(startCallError({
                error: 'Could not connect to server'
              }));

            case 34:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[4, 30]]);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
};

exports.startCall = startCall;