"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.triggerTheWelcomeMessageWhenVisitPage = exports.triggerTheStartingPoint = exports.startConversation = exports.trackingTheTriggerEvent = exports.updateHasTriggeredWelcomeMessage = exports.startConversationRequest = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _find2 = _interopRequireDefault(require("lodash/find"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var actions = _interopRequireWildcard(require("./action-type"));

var _reduxActions = require("redux-actions");

var _websocket = require("../../connections/websocket");

var _websocket2 = require("../../commons/constants/websocket");

var _tenantInfo = require("../../commons/tenant-info");

var _saveUserInfo = require("./save-user-info.actions");

var _runFunAfter = _interopRequireDefault(require("../../commons/utils/run-fun-after"));

var _getTimeDuration = _interopRequireDefault(require("../../commons/utils/get-time-duration"));

var _utils = require("../../commons/utils");

var _startingPointTypes = require("../../commons/constants/starting-point-types");

var _message = require("./message.actions");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var startConversationRequest = (0, _reduxActions.createAction)(actions.START_CONVERSATION + ".REQUEST");
exports.startConversationRequest = startConversationRequest;
var updateHasTriggeredWelcomeMessage = (0, _reduxActions.createAction)(actions.UPDATE_HAS_TRIGGERED_WELCOME_MESSAGE + ".SUCCESS");
exports.updateHasTriggeredWelcomeMessage = updateHasTriggeredWelcomeMessage;
var trackingTheTriggerEvent = (0, _reduxActions.createAction)(actions.TRACK_THE_TRIGGER_EVENT + ".SUCCESS");
exports.trackingTheTriggerEvent = trackingTheTriggerEvent;

var startConversation = function startConversation(fromButton, _ref) {
  var name = _ref.name,
      email = _ref.email,
      phone = _ref.phone,
      isWorkingDay = _ref.isWorkingDay,
      leaveMessage = _ref.leaveMessage;
  return /*#__PURE__*/function () {
    var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(dispatch) {
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return dispatch(startConversationRequest({
                name: name,
                email: email,
                phone: phone,
                fromButton: fromButton,
                isWorkingDay: isWorkingDay
              }));

            case 2:
              if (!(!(0, _isEmpty2["default"])(name) || !(0, _isEmpty2["default"])(email) || !(0, _isEmpty2["default"])(phone))) {
                _context.next = 5;
                break;
              }

              _context.next = 5;
              return dispatch((0, _saveUserInfo.saveUserInfo)(name, email, phone));

            case 5:
              fromButton === _websocket2.BUTTON_STARTS.START_CONVERSATION && (0, _websocket.sendMessage)({
                group: _websocket2.GROUP.MESSAGE,
                type: _websocket2.TYPE.MESSAGE.START_CONVERSATION,
                payload: {
                  displayName: name,
                  email: email,
                  phone: phone
                },
                tenantInfo: (0, _tenantInfo.getTenantInfo)()
              }); // Check whether it's needed to trigger the welcome message

              if (fromButton === _websocket2.BUTTON_STARTS.CHAT_WITH_BOT || fromButton === _websocket2.BUTTON_STARTS.START_CONVERSATION && isWorkingDay) {
                console.log('Trigger the welcome message');
                (0, _runFunAfter["default"])(function () {
                  (0, _websocket.sendMessage)({
                    group: _websocket2.GROUP.MESSAGE,
                    type: _websocket2.TYPE.MESSAGE.TRIGGER_WELCOME_MESSAGE,
                    payload: {},
                    tenantInfo: (0, _tenantInfo.getTenantInfo)()
                  });
                  dispatch(updateHasTriggeredWelcomeMessage());
                }, 200);
              }

              if (fromButton === _websocket2.BUTTON_STARTS.LEAVE_MESSAGE) {
                console.log('BUTTON_STARTS.LEAVE_MESSAGE: ', leaveMessage);
                (0, _runFunAfter["default"])(function () {
                  dispatch((0, _message.sendTextMessage)(leaveMessage));
                }, 200);
              }

            case 8:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x) {
      return _ref2.apply(this, arguments);
    };
  }();
};

exports.startConversation = startConversation;

var triggerTheStartingPoint = function triggerTheStartingPoint(startingPointType, startingPointId, setting) {
  return /*#__PURE__*/function () {
    var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(dispatch, getState) {
      var state, alreadyStartConversation, trackingTriggerEvents, _ref4, lastTime;

      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              console.log('triggerTheStartingPoint:', startingPointId);

              if (setting.isEnableAutomation) {
                _context2.next = 4;
                break;
              }

              console.log('Ingore because not enable bot now');
              return _context2.abrupt("return");

            case 4:
              state = getState();
              alreadyStartConversation = (0, _get2["default"])(state, 'behavior.alreadyStartConversation');
              trackingTriggerEvents = (0, _get2["default"])(state, 'behavior.triggerStartingPointTracking') || []; // If enable the pre-chat form, only trigger the startingPoint after starting the conversation.

              if (!(!(0, _utils.isDisablePreChatForm)(setting) && !alreadyStartConversation)) {
                _context2.next = 10;
                break;
              }

              console.log('ingore the action');
              return _context2.abrupt("return");

            case 10:
              if (!(startingPointType === _startingPointTypes.STARTING_POINT_TYPES.VISITOR_CLICK_ELEMENT)) {
                _context2.next = 14;
                break;
              }

              console.log('triggerTheStartingPoint');
              (0, _websocket.triggerStartingPoint)(startingPointId);
              return _context2.abrupt("return");

            case 14:
              if (startingPointType === _startingPointTypes.STARTING_POINT_TYPES.VISITOR_VISIT_URLS) {
                // console.log('startingPointType === STARTING_POINT_TYPES.VISITOR_VISIT_URLS');
                _ref4 = (0, _find2["default"])(trackingTriggerEvents, function (event) {
                  return event.startingPointId === startingPointId;
                }) || {}, lastTime = _ref4.lastTime; // console.log('lastTime:', lastTime);
                // console.log('isLastTimeMoreThanOneDay: ', isLastTimeMoreThanOneDay(lastTime));

                if ((0, _isEmpty2["default"])(lastTime) || (0, _utils.isLastTimeMoreThanOneDay)(lastTime)) {
                  // console.log('trigger');
                  (0, _websocket.triggerStartingPoint)(startingPointId);
                  dispatch(trackingTheTriggerEvent({
                    startingPointType: startingPointType,
                    startingPointId: startingPointId
                  }));
                }
              }

            case 15:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x2, _x3) {
      return _ref3.apply(this, arguments);
    };
  }();
};

exports.triggerTheStartingPoint = triggerTheStartingPoint;

var triggerTheWelcomeMessageWhenVisitPage = function triggerTheWelcomeMessageWhenVisitPage(setting) {
  return /*#__PURE__*/function () {
    var _ref5 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(dispatch, getState) {
      var state, hasTriggeredWelcomeMessage, alreadyStartConversation, delay, _delay;

      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              console.log('triggerTheWelcomeMessageWhenVisitPage');
              state = getState();

              if (setting.isEnableAutomation) {
                _context3.next = 5;
                break;
              }

              console.log('Ingore because not enable bot now');
              return _context3.abrupt("return");

            case 5:
              hasTriggeredWelcomeMessage = (0, _get2["default"])(state, 'behavior.hasTriggeredWelcomeMessage');
              alreadyStartConversation = (0, _get2["default"])(state, 'behavior.alreadyStartConversation');

              if (!(!(0, _utils.isDisablePreChatForm)(setting) && !alreadyStartConversation)) {
                _context3.next = 10;
                break;
              }

              console.log('Ingore because the pre-chat form is enable & the conversation has not started'); // When enable the pre-chat form, only start conversation when click to chat with bot

              return _context3.abrupt("return");

            case 10:
              if (!(!(0, _utils.isTriggerWelcomeMessageWhenVisitPage)(setting) && !(0, _utils.isTriggerWelcomeBackMessageWhenVisitPage)(setting))) {
                _context3.next = 13;
                break;
              }

              console.log('Ingore because dont enable welcome message & welcome back message when revisit');
              return _context3.abrupt("return");

            case 13:
              if (!((0, _utils.isTriggerWelcomeMessageWhenVisitPage)(setting) && !hasTriggeredWelcomeMessage)) {
                _context3.next = 18;
                break;
              }

              // Trigger the welcome message
              delay = (0, _getTimeDuration["default"])((0, _get2["default"])(setting, 'screenWelcomeMessages.trigger.time'), (0, _get2["default"])(setting, 'screenWelcomeMessages.trigger.unitOfTime'));
              console.log('...Trigger the welcome message: ', delay);
              setTimeout(function () {
                console.log('Trigger the welcome message');
                (0, _websocket.sendMessage)({
                  group: _websocket2.GROUP.MESSAGE,
                  type: _websocket2.TYPE.MESSAGE.TRIGGER_WELCOME_MESSAGE,
                  payload: {},
                  tenantInfo: (0, _tenantInfo.getTenantInfo)()
                });
                dispatch(updateHasTriggeredWelcomeMessage());
              }, delay);
              return _context3.abrupt("return");

            case 18:
              if (!(hasTriggeredWelcomeMessage && (0, _utils.isTriggerWelcomeBackMessageWhenVisitPage)(setting))) {
                _context3.next = 23;
                break;
              }

              // Trigger the welcome back message
              _delay = (0, _getTimeDuration["default"])((0, _get2["default"])(setting, 'screenWelcomeBackMessages.trigger.time'), (0, _get2["default"])(setting, 'screenWelcomeBackMessages.trigger.unitOfTime'));
              console.log('...Trigger the welcome back message:', _delay);

              if ((0, _utils.isLastTimeMoreThanAPeriod)((0, _get2["default"])(state, 'behavior.lastTimeTriggeredWelcomeMessage'), _delay)) {
                console.log('Trigger the welcome back message');
                (0, _websocket.sendMessage)({
                  group: _websocket2.GROUP.MESSAGE,
                  type: _websocket2.TYPE.MESSAGE.TRIGGER_WELCOME_BACK_MESSAGE,
                  payload: {},
                  tenantInfo: (0, _tenantInfo.getTenantInfo)()
                });
                dispatch(updateHasTriggeredWelcomeMessage());
              }

              return _context3.abrupt("return");

            case 23:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function (_x4, _x5) {
      return _ref5.apply(this, arguments);
    };
  }();
}; // - Nếu enable pre-chat form (Tức là yêu cầu có thông tin mới bắt đầu chat)
// ---- Nếu in operating hours
// -------- Nếu enable chatbot -> Gửi welcome message.
// ---- Nếu not in operating hours
// -------- Nếu enable automation
// --------- Show chat with bot -> Gửi welcome message.
// -------- Nếu not enable automation
// --------- Show leave message -> Không gửi welcome message.
// - Nếu không enable pre-chat form
// ---- Nếu in operating hours
//
// ---- Nếu not in operating hours


exports.triggerTheWelcomeMessageWhenVisitPage = triggerTheWelcomeMessageWhenVisitPage;