"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.stopCall = exports.stopCallRequest = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var actions = _interopRequireWildcard(require("./action-type"));

var _reduxActions = require("redux-actions");

var _websocket = require("../../connections/websocket");

var _websocket2 = require("../../commons/constants/websocket");

var _tenantInfo = require("../../commons/tenant-info");

var _webrtc = _interopRequireDefault(require("../../components/phone-call/webrtc"));

var _constants = require("../../components/phone-call/constants");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var stopCallRequest = (0, _reduxActions.createAction)(actions.STOP_CALL + ".REQUEST");
exports.stopCallRequest = stopCallRequest;

var stopCall = function stopCall(callInfo, _ref) {
  var stopReason = _ref.stopReason,
      totalDuration = _ref.totalDuration;
  return /*#__PURE__*/function () {
    var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(dispatch) {
      var payload;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              // webRTC stop call
              _webrtc["default"].stopCall();

              if ((0, _get2["default"])(callInfo, 'id')) {
                _context.next = 3;
                break;
              }

              return _context.abrupt("return");

            case 3:
              payload = (0, _extends2["default"])({}, callInfo, {
                stopReason: stopReason,
                totalDuration: stopReason === _constants.CALL_STOP_REASON.SUBSCRIBER_AUTO_STOP_WHEN_TIMEOUT ? 0 : totalDuration,
                status: stopReason === _constants.CALL_STOP_REASON.SUBSCRIBER_AUTO_STOP_WHEN_TIMEOUT || callInfo.status !== _constants.CALL_STATUS.IN_PROGRESS ? _constants.CALL_STATUS.CUSTOMER_CANCELED : _constants.CALL_STATUS.COMPLETED
              });
              dispatch(stopCallRequest({
                status: payload.status
              }));
              (0, _websocket.sendMessage)({
                group: _websocket2.GROUP.CALL,
                type: _websocket2.TYPE.CALL.STOP_CALL,
                payload: payload,
                tenantInfo: (0, _tenantInfo.getTenantInfo)()
              });

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x) {
      return _ref2.apply(this, arguments);
    };
  }();
};

exports.stopCall = stopCall;